
There seems to be renewed interest in this, so I thought I'd post
Lionel's article once more. After reading this I tried it on my
older vintage AR1000 and successfully moved the low frequency limit
from 8 to 0.5 mHz. Your mileage may vary. Anything which results from
implementing the instructions below is AT YOUR OWN RISK.

Lionel copied these instructions from a factory set up sheet, sent
to him by his dealer when the CPU locked up (a rare event), rendering
his radio dead. It is also reproduced in the service manual, available
from AOR Japan (no, I don't have the address).

---------------------------------------------------------------------------

                        =======================
                        AR-1000 Reset Procedure
                        =======================

* What you need :

        - A small Philips screwdriver
        - A soldering iron (30 W max)

* What to do :

        - Remove the antenna
        - Remove the batteries
        - Remove the tuning, volume, and squelch buttons
        - Remove the back cover (4 black screws), and disconnect it from
          the rest

        - Lay the unit flat on the table, keyboard and display below,
          antenna connector away from you
        - Unsolder the black wire from the lower right corner of
          the upper board
        - Unsolder the brown wire from the upper left corner of the same
          board
        - Remove the 3 screws that hold this board
        - Pull GENTLY this board out of the upper panel (volume, squelch,
          and tune rods come with the board - not the antenna connector)

        - Unsolder the black wire from the upper left corner of the middle
          board
        - Unscrew the 3 copper columns that hold this board

        - To get a better access on the lower board, you may wish to remove
          some of the connectors that link the upper and middle boards to
          the power supply board (the one that hides the speaker) --- don't
          forget to take note of which connector goes where !!!

        - Now take a look at the lower board. It looks like this :

                                (X) green led

        +--------------------------------------------------------+
        |                                                        |
        |                    LCD display                         |
        |                                                        |
        +--------------------------------------------------------+

                        +-----------------+
                        |       NEC       |
                        |       chip      |
                        |   D75308GF651   |
                        +-----------------+

                      o     (A) o
                      |         |
                      R1        R2
                      |         |
                      o         o

                +---------------+                 +--------+
                |               |                 | diodes |
                |               |                 +--------+
                |               |
                | Hitachi chip  |           +--------+
                | HN58C65FP-25T |           | diodes |
                |               |           +--------+
                |               |
                |               |               +--------+
                |               |               | diodes |
                +---------------+               +--------+  (B)

        - Solder a piece of wire (wrapping wire is a good candidate)
          between points (A) and (B).
        - Reconnect ALL wires (solder unsoldered wires and connect dis-
          connected ones)
        - Place batteries back
        - Turn unit on : the display should be blank.
        - Now type the following :

                BANK
                1 PROG    8 LIMIT  49.995 SEARCH 561.225 ENTER
                2 PROG   50 LIMIT 107.995 SEARCH 561.225 ENTER
                3 PROG  108 LIMIT 169.995 SEARCH 561.225 ENTER
                4 PROG  170 LIMIT 296.995 SEARCH 561.225 ENTER
                5 PROG  297 LIMIT 600     SEARCH 251.575 ENTER
                6 PROG  805 LIMIT 1109995 [down arrow] 251.575 ENTER
                7 PROG 1110 LIMIT 1300    [down arrow] 561.225 ENTER

        - Turn unit off
        - Unsolder the piece of wrapping wire
        - Mount the unit back (wires, connectors, screws...)

        - Turn unit on : it should be working !!!

* My comments :

         DO NOT TRY THIS BY YOURSELF IF YOU DON'T FEEL CONFIDENT ABOUT
         USING A SOLDERING IRON ON SUCH A MINIATURIZED DEVICE !!!

         DON'T FORGET THAT, IF YOU FAIL, THE WARRANTY WILL BE VOID !!!

        Now, let's relax. From the programming procedure, it is obvious
        that you enter 7 sub-bands in the unit :

                8 to   49.995 MHz
               50 to  107.995 MHz
              108 to  169.995 MHz
              170 to  296.995 MHz
              297 to  600.000 MHz
              805 to 1109.995 MHz
             1110 to 1300.000 MHz

        These are the values for the AR-1000 as sold in France. The values
        may be different for the units sold in Northern America (there may
        be other gaps, especially for cellular phone frequencies).

        I don't know what the following parameters (561.225 and 251.575)
        mean. I guess they indicate which RF subcircuit, which step, and
        which modulation mode to use. Anyway, since the sub-bands limits
        appear so clearly, it might be fun to experiment. See what I mean ?

        But, if we are to experiment, let's make things easier. Instead of
        dismounting-soldering-programming-unsoldering-mounting the unit each
        time, let's solder a 5" piece of wrapping wire to point (A),
        a 5" piece of wrapping wire to point (B). Now we have 2 free ends :
        let's solder a microswitch to them. We can glue the microswitch at
        the bottom end of the unit, near the power supply board. Resetting
        the AR-1000 is now much simpler : just open the unit (4 screws),
        flip the switch, turn the unit on, reprogram it, turn it off, flip
        the switch back, close the unit.

        First of all, if you replace the first "8" with "0.5", you get an
        AR-1000 with coverage extended down to 500 kHz. This may not work
        on older units. My unit didn't let me program any frequency lower
        than 0.5 MHz, or higher than 1300 MHz. Anyway, my aim was to try
        to get rid of the 600-805 MHz gap. I tried the following sub-bands :

                   0.5 -   29.995
                  30.0 -  219.995
                 220.0 -  409.995
                 410.0 -  599.995
                 600.0 -  904.995
                 905.0 - 1209.995
                1210.0 - 1300.000

        To choose these values, I made the following assumptions : the
        original values never exceed a 190 MHz span for the "561.225" series,
        and never exceed a 304.995 MHz for the "251.575" series. I was careful
        not to exceed these ranges, because of the necessarily limited span
        of the internal VFO.

        These values did seem to work, since I was able to hear some TV signals
        near 620 MHz, that is, in the previous gap ! However, when I programmed
        some search banks, it sometimes refused to search, even on "authorized"
        frequencies (around 450 MHz). And, since there is nothing but TV
        channels between 600 and 805 MHz (at least in France), I restored the
        original values (except for the 0.5 MHz lower limit).

        Now, if you find something interesting, please keep me informed !

                                       Lionel ANCELET

                                              BIX : lanc
                                       CompuServe : 71641,1340
                                       INTERNET   : 71641.1340@compuserve.com

------------------------------------------------------------------------------
--
 Mike Schuster                                      |    CIS: 70346,1745
