#ifndef	_CONFIG_H
#define	_CONFIG_H

/* Software options */
#define	MAILBOX		1	/* Include SM0RGV mailbox server */
#define	MBFWD		1	/* Enable mailbox forwarding code */
/* chose only one kind of the following NNTP versions */
#define	NNTPCLIENT	1	/* Netnews client */
#undef	NNTPSERVER	1	/* Netnews client + server */
/* chose only one kind of POP or  POP* group */
#define	POP2CLIENT	1	/* POP2 client - IAB not recomended */
#define	POP2SERVER	1	/* POP2 server - IAB not recomended */
#define	POP3CLIENT	1	/* POP3 client - IAB draft standard */
#define	POP3SERVER	1	/* POP3 server - IAB draft standard */
#undef	POP		1	/* Include POP2 Post Office Protocol */
/* */
#define	SMTPCLIENT	1	/* SMTP client */
#define	SMTPSERVER	1	/* SMTP server */
#define	SERVERS		1	/* Include TCP servers */
#define	TRACE		1	/* Include packet tracing code */
#define	TRACEBACK	1	/* Include stack tracing code */
#define	RIP		1	/* Include RIP routing */
#define	HOPCHECK	1	/* IP path tracing command */
#define	DIALER		1	/* SLIP redial code */
#undef	NRS		1	/* NET/ROM async interface */
#define	NETROM		1	/* NET/ROM network support */
#define	LZW		1	/* LZW-compressed sockets */
#undef	RLOGINCLI	1	/* Rlogin client code */
#define	SLIP		1	/* Serial line IP on built-in ports */
#undef	PPP		1	/* Point-to-Point Protocol code */
#define	VJCOMPRESS	1	/* Van Jacobson TCP compression for SLIP */
#define	ESCAPE		1	/* Allow Unix style escape on PC */
#undef	RSPF		1	/* Include Radio Shortest Path First Protocol */
#define	AXIP		1	/* digipeater via ip port 93 interface */
#define	IPACCESS	1	/* Include IP access control code */
#undef	RARP		1	/* Enable Reverse ARP protocol */
#define	LOCK		1	/* Password lockup for keyboard */
#define	DOSCMD		1	/* Enable the internal DOS commands */ 
#define	ALLCMD		1	/* Enable all commands */
#define	ALLSERV		1	/* Enable all server commands */
#undef	CONVERS		1	/* Conference bridge (babbelbox) */
#define	TABS		1	/* Use tab chars i.s.o. spaces in some data */
#undef	LPD		1	/* Dave Johnson's LPD server */
#undef	LPCLIENTS	1	/* Dave Johnson's LP clients (LPR,LPRM,LPQ) */

/* Software tuning parameters */
#define	MTHRESH		8192	/* Default memory threshold */
#define	NROWS		25	/* Number of rows on screen */
#define	NIBUFS		5	/* Number of interrupt buffers */
#define	IBUFSIZE	2048	/* Size of interrupt buffers */
#define	NSESSIONS	10	/* Number of interactive clients */
#define	DEFNSOCK	40	/* Default number of sockets */

/* Hardware driver options */
#undef	ARCNET		1	/* ARCnet via PACKET driver */
#undef	PC_EC		1	/* 3-Com 3C501 Ethernet controller */
#define	KISS		1	/* KISS TNC code */
#undef	HS		1	/* High speed (56kbps) modem driver */
#undef	HAPN		1	/* Hamilton Area Packet Network driver code */
#undef	EAGLE		1	/* Eagle card driver */
#define	PACKET		1	/* FTP Software's Packet Driver interface */
#undef	PC100		1	/* PAC-COM PC-100 driver code */
#undef	APPLETALK	1	/* Appletalk interface (Macintosh) */
#undef	DRSI		1	/* DRSI PCPA slow-speed driver */
#define	SCC		1	/* PE1CHL generic scc driver */
#undef	PI		1	/* VE3IFB pi dma card scc driver */
#define	ASY		1	/* Asynch driver code */
#undef	SLFP		1	/* SLFP packet driver class supported */

#if defined(NRS)
#undef	NETROM
#define	NETROM		1	/* NRS implies NETROM */
#endif

#if (defined(HS)||defined(NETROM)||defined(KISS)||defined(HAPN)||defined(EAGLE)||defined(PC100)||defined(PI))
#define	AX25		1	/* AX.25 subnet code */
#endif

#if (defined(ARCNET) || defined(SLFP))
#undef	PACKET
#define	PACKET		1	/* FTP Software's Packet Driver interface */
#endif

#if (defined(PC_EC) || defined(PACKET))
#define	ETHER		1	/* Generic Ethernet code */
#endif

#if (defined(NNTPCLIENT) && defined(NNTPSERVER))
#error only one NNTP type might be defined
#endif

#if (defined(POP2CLIENT) || defined(POP3CLIENT))
#define	MAILCLIENT	1
#undef POP
#endif

#if (defined(POP2SERVER) || defined(POP3SERVER) || defined(SMTPSERVER) || defined(REMOTE) || defined(RIP))
#undef	SERVERS
#define	SERVERS		1
#endif

#if (defined(MAILBOX) || defined(MAILCLIENT) || defined(SMTPSERVER) || defined(REMOTE))
#undef	SMTPCLIENT
#define	SMTPCLIENT	1
#endif

#endif	/* _CONFIG_H */
