/* Copyright 1989 Xanthus Inc and Thomas A. Moulton, W2VY
   ALL RIGHTS RESERVED!
*/
/* Main program INI.  Simple State Machine. */

#include <string.h>
#undef NULL
#include <conio.h>
#include <stdio.h>
#define TRUE 1
#define FALSE 0
FILE *fnami, *fnamii;
char zarr[100],fname[80];
char got_file[160];
char *nextoken, EOLN;

char ROSE[]="ROSE Interactive Network Monitor by W2VY";
extern int Verify;
char *error;
int S_TOP;
struct menu *State[16];
int F_TOP;
struct menu *(*Fcn[16])();
extern char DEF_INCL[80];

char *Prompt, prmstr[]="ROSE > ";
char deferr[]="Error";

int
getlin(str,max)
char *str;
int max;
{
	int ch, pos;

	ch=pos=0;
	while (ch != 0x0a && pos<max) {
		ch=getchar();
		if (ch == -1) return -1;
		str[pos++]=ch;
		str[pos]=0;
	}
	if (ch== 0x0a) str[pos-1]=0;
	return (strlen(str));
}

int
fgetlin(str,max,f)
char *str;
int max;
FILE *f;
{
	int ch, pos;

	ch=pos=0;
	while (ch != 0x0a && pos<max) {
		ch=getc(f);
		if (ch == EOF) return EOF;
		str[pos++]=ch;
		str[pos]=0;
	}
	if (ch== 0x0a) str[pos-1]=0;
	return (strlen(str));
}

int
fgetline(str,max,f)
char *str;
int max;
FILE *f;
{
	int l;

	do line_init();		/* Reset some stuff with each line */
	while ((l=fgetlin(str, max, f)) == 0) ;
	return l;
}

int
getline(str,max)
char *str;
int max;
{
	int l;

	while ((l=getlin(str, max)) == 0) ;
	return l;
}

int
fputline(s,f)
char *s;
FILE *f;
{
	while (*s) fputc(*s++,f);
	fputc(0x0a,f);
}

int
get_yes()
{
	register char ch;

	do {
		ch=getch();
		ch=toupper(ch);
	} while ( (ch!=0x59) && (ch!=0x4e));
	return (ch == 0x59); /* True is Yes */
}

#include "ini.h"

extern struct menu level0;

static struct menu *curstate;
static int (*doit)();
static struct menu nullmenu={"",NULL,NULL};

line_init()
{
	roselini();
	EOLN = FALSE;
	if (Prompt) printf("%s",Prompt);
}

int
word_skip(ch)
char **ch;
{
	while ( (**ch == 0x20) && (**ch != NULL) ) (*ch)++;
	EOLN = !(**ch); 
	return **ch;
}

int
word_len(ch)
char *ch;
{
	int l;

	l=0;
	while ( (*ch != 0x20) && (*ch != NULL) ) { ch++; l++; }
	return l;
}

struct menu *
word(tok, err, state)
char **tok;
char **err;
struct menu state[];
{
	int i, j, l;
	static char invcmd[]="Command not found";

	l=0;
	while (l == 0) {
		word_skip(tok);
		if (EOLN) return (struct menu *)EOF;
		l=word_len(*tok);
		if (l == 1 && (**tok == 0x3f)) /* ? - print commands */ {
			printf("\nVaild Commands currently are:\n");
			i=0;
			while (strlen(state[i].cmd)) {
				printf(" %s\n",state[i].cmd);
				i++;
			}
			printf("\n");
			l=0;
			*tok++;	/* Skip the ? */
		}
	}
	j=i=find_sym(*tok, l, state);
	if (i<0) {
		j = (-i) - 1;
		if (state[j].next == NULL) /* No error routine defined */ {
			*err = invcmd;	/* Invalid Command */
			return NULL;
		}
	} else *tok += l;	/* Only advance pointer if no error */
	return &state[j];
}

FILE *
get_file(zfnam)
char zfnam[];
{
	FILE *ptr;

	strcpy(got_file, zfnam);
	ptr = fopen(got_file,"rt");
	if (!ptr) /* Open Error */ {
		strcpy(got_file, DEF_INCL);
		if (zfnam[0] != '\\') strcat(got_file,"\\");
		strcat(got_file, zfnam);
		ptr = fopen(got_file,"rt");
	}
	return ptr;
}

int
main(argc,argv)
int argc;
char *argv[];
{
	char *ch, *in;
	struct menu *nextstate;
	int len, pos;
	int i, j, l, oldst;
	extern char *token();

	State[0] = &level0;
	S_TOP=0;
	Fcn[0] = word;
	F_TOP=0;		/* Now State Machine is init'ed */
	Prompt = NULL;

	printf("%s\n",ROSE);
	in = NULL;
	if (argc == 2) in = argv[1];
	do {
		if (in) /* Name supplied in command line */ {
			fnami=fopen(in,"rt");
			if (fnami == NULL) {
				printf("%s does not exist.\n",in);
				in = NULL;
			}
		} else {
			printf("Node data file name? ");
			getline(fname, 80);
			fnami=fopen(fname,"rt");
		}
	} while (fnami == NULL);
	if (!in) in = fname;

	zarr[0] = 0;
	oldst=0;
	error = NULL;
	fnamii = NULL;	/* Single depth stack for Includes */

	while (!feof(fnami)) /* Read line and parse */ {

		if (Verify) /* User wants to see what is going on */ {
			l= (S_TOP < oldst) ? S_TOP : oldst;
			for (i=0;i<l;i++) printf("   ");	/* Indent */
						/* Print Last command line */
			if (!error) printf("%s\n",zarr);
		}

		l=fgetline(zarr,80,fnami);
		if (l>0) /* Parse line */ {
			nextoken = zarr;
			if (zarr[0] == '*') {
				if (zarr[1] == '<') /* Include file */ {
					fnamii = fnami;
					fnami = get_file(&zarr[2]);
					if (!fnami) /* Open error, give up! */ {
						printf("Include file open error on %s\n", got_file);
						fnami = fnamii;
						fnamii = NULL;
					}
					EOLN = TRUE;	/* Processed whole line */
				} else EOLN=TRUE;	/* Ignore Comment */
			}
			oldst = S_TOP;
			while (!EOLN) /* Process token */ {

				error = NULL;
				nextstate=(*Fcn[F_TOP])(&nextoken, &error,
							State[S_TOP]);
				if (nextstate == (struct menu *) EOF) break;

				if (!nextstate) nextstate = &nullmenu;
				if (error) /* Print error message */ {
					S_TOP=0;
					F_TOP=0;
					printf("%s\n",zarr);
					if ((ch=zarr) != nextoken) ch++;
					while (ch++ != nextoken) printf(" ");
					if (strlen(error) == 0) error=deferr;
					printf("^ *** %s ***\n", error);
					break;
				}

				if (nextstate->fcn != NULL) /* Push */ {
					Fcn[++F_TOP] = nextstate->fcn;
				} else /* Pop */ {
					F_TOP--;
					if (F_TOP < 0) F_TOP=0;
				}
				if (nextstate->next == NULL) /* Pop */ {
					S_TOP--;
					if (S_TOP < 0) S_TOP=0;
				} else /* Push ? */ {
					if (nextstate->next != State[S_TOP]) /* Push */ {
						State[++S_TOP]=nextstate->next;
					}
				}
			}
		}
		if (feof(fnami)) /* EOF, Pop Stack or open console */ {
			fclose(fnami);
			if (fnamii) /* Were in an include file */ {
				fnami = fnamii;
				fnamii = NULL;
			} else {
				fnami=fopen("CON","rt");
				if (fnami) {
					in = NULL;
					Prompt = prmstr;
					printf("%s\n",ROSE);
					printf("Type QUIT to exit\n");
				}
				else /* Error */ {
					printf("Can't Open Console for input!!\n");
					break;
				}
			}
		}
	}
}
