/* Copyright 1989 Xanthus Inc and Thomas A. Moulton, W2VY
   ALL RIGHTS RESERVED!
*/
#include <string.h>
#include <stdio.h>
#include <malloc.h>
#define TRUE 1
#define FALSE 0

#include "rtable.h"
#include "dnic.h"

int vvvv=0;

char altable[16][16];
int maxalt=0;

int
add_alt(adr)
char adr[];
{
	int i, j, l;

	l = adr[0] & 0x0f;
	if (l) l = ((l+1)>>1)&0x0f;
	l += (adr[0]>>4) & 0x0f;

	for (i=0;i<maxalt;i++) /* Find address in table */ {
		for (j=0;j<=l;j++) if (adr[j] != altable[i][j]) break;
		if (j > l) break;	/* Found it! */
	}

	if (i == maxalt) /* New entry */ {
		for (j=0;j<=l;j++) altable[i][j]=adr[j];
		for (	;j<16;j++) altable[i][j]=0;
		maxalt++;
	}
	return i;
}
#if 0
next_alt(ptr,index)
unsigned char ptr[], index;
{	/* ptr points to a routing table entry and index  is 1..15 */
	int i, j;

	i=ptr[0];
	j=i & 0x0f;
	i=i>>4;
	if (index > i) return EOF;
	j += j&1;
	j= (j + --index) >> 1;
	i= ptr[++j];
	if (index&1) i=i & 0x0f;
	else i=(i & 0x0ff) >> 4;
	return i;
}
#endif
int
new_rt(base)
int base;
{
	int i, j;

	i = numrt;
	for (j=base;j<i;j++) if (RTable[j]->cmd >= 90) {
		i = j;
		break;
	}

	if (i+1 == MaxRT) /* Table overflow */ {
		printf("MaxRT not big enough, is %d !! ***\n",MaxRT);
		exit(1);
	}
	if (i == numrt) /* Adding to end of table */ {
	   numrt++;
	   RTable[i] = (struct rt_tab *)malloc(sizeof(struct rt_tab));
	}

	RTable[i]->cmd = 0; /* Default to Invalid Terminator */
	RTable[i]->dta = 0;
	for (j=0;j<10;j++) RTable[i]->next[j]=0;

	return i;
}

add_route(adr,alt)	/* Can have a specific station listed more than once */
unsigned char adr[];
unsigned char alt;
{
	unsigned char j, l, jl, kl;
	int ptr;
	int i, k;
	struct rt_tab *rt;

	if (numrt == 0) new_rt(0);
	ptr=0;
	i=0;	/* Point TO the dnic */

	do {
		rt = RTable[ptr];
		if (i == adr[0]) /* All done! */ {
			rt->cmd = 1;	/* It's Valid! */
			rt->dta = alt;
			if (altable[alt][0] & 0x0f) rt->cmd = 2;
			return;
		}
		k=adr[1+(i>>1)];
		if (!(i&1)) k = k>>4;
		k = k &0x0f;
		i++;
		if (rt->next[k] == 0) rt->next[k] = new_rt(0);
		ptr = rt->next[k];
	} while (ptr != 0);
}

new_ref(old,new)
int old,new;
{
	int i,j,m;

	m = (old > new) ? new : old;
	for (i=0;i<m;i++)
		for (j=0;j<10;j++)
			if (RTable[i]->next[j] == old && (new - i) < 256)
				RTable[i]->next[j] = new;
}

int
first_ref(r)
int r;
{
	int i, j, c;
	struct rt_tab *rt;

	for (i=0;i < numrt;i++) {
		rt = RTable[i];
		if (rt->cmd == 0 || rt->cmd == 1) {
			for (j=0;j<10;j++) {
				c = RTable[i]->next[j];
				if( c == r) return i;
			}
		}
	}
	return -1; 
}

unique_rt(src,low,high)
int src, low, high;
{
	int i, j, l;

	for (i=low;i<high;i++)
	   if ( (RTable[src]->cmd == RTable[i]->cmd) &&
		(RTable[src]->dta == RTable[i]->dta) ) {
	      l = TRUE;
	      for (j=0;j<10;j++)
			if (RTable[src]->next[j] != RTable[i]->next[j]) {
				l = FALSE;
				break;
			}
	      if (l) return i;
	}
	return -1;
}

dump_rt(ch)
char *ch;
{
	int i, j;

	if (vvvv) {
		printf("%s",ch);
		printf("rec cmd dta   Next...\n");
		for (i=0;i < numrt;i++) {
		  printf("%2.2d  %2.2d   %2.2d   ",i,RTable[i]->cmd,RTable[i]->dta);
		  for (j=0;j<10;j++) printf("%2.2d ",RTable[i]->next[j]);
		  printf("\n");
		}
	}
}
int rtp[MaxRT];
int numrtp;
int rtp_todo[MaxRT];
int pos_todo[MaxRT];
int todo;

order_rtr()
{
	int i, j, k, l, nl;
	struct rt_tab *rt;

	l=0;
	while (todo != -1) {
		if (l >= todo) l=0;
		nl = l+1;
		j = rtp_todo[l];
		if ((j != 0) && (rtp[j] == 0)) rtp[j] = ++numrtp;
		rt = RTable[j];
		for (k=pos_todo[l];k<10;k++) {
			if ((i=rt->next[k]) != 0) {
				rtp_todo[todo] = i;
				pos_todo[todo++] = 0;
				nl = 0;
				break;		/* Only add one at a time */
			}
		}
		if (k < 9) {
			pos_todo[l] = k+1;
		}
		else /* All done with this one */ {
			for (k=l;k<todo-1;k++) {
				rtp_todo[k]=rtp_todo[k+1];
				pos_todo[k]=pos_todo[k+1];
			}
			todo--;
		}
		l = nl;
	}
}

#define abs(v) (v<0) ? -v : v

order_rt()
{
	int i, j, k;
	struct rt_tab *rt, *rtpt;

	for (i=0;i<MaxRT;i++) rtp[i] = 0;
	numrtp=todo=0;
	rtp_todo[todo] = 0;	/* Start with root entry */
	pos_todo[todo++] = 0;

	rtp[0] = 0;	/* First record is always first record */
	order_rtr();	/* Tree Sort */

	for (i=0;i<numrtp;i++) /* This may lose memory now */ {
		j=i;
		rtpt = RTable[j];
		k = rtp[j];	/* From J to K */
		while (k > 0)  /* Move the Data */ {
			rt = RTable[k];
			RTable[k] = rtpt;
			rtp[j] = -rtp[j];
			rtpt = rt;
			j = k;
			k = rtp[j];	/* From J to K */
		}
		rt = RTable[i];
		for (j=0;j<10;j++) rt->next[j] = abs(rtp[rt->next[j]]);
	}
}

compress_rt()	/* Only supports cmd=0 or cmd=1 */
{
	int i, j, k, l, cmd;
	struct rt_tab *rt;

	dump_rt("Initial Routing Table\n");
	order_rt();
	dump_rt("Sort Complete\n");

	for (i=0;i<numrt;i++) /* Scan the list */ {

		if (l=(RTable[i]->cmd != 0))
			/* May be a global terminator */
		   for (k=0;k<10;k++) l = l && !RTable[i]->next[k];

		j = 0;
		if (l)
		while ((l=unique_rt(i,j,numrt)) != -1) {
			if ((k = first_ref(i)) == -1) break; /* No ref's! */
			if (l > k ) new_ref(i,l);   /* Found a closer one! */ 
			j = l+1;
		}
		if (first_ref(i) == -1)
			RTable[i]->cmd += 90;	/* void this record */
	}
	dump_rt("Pass 1 - Voided Dup records\n");

	/* now remove the voided records */
	k = 0;	/* Write pos */
	for (i=0;i < numrt;i++) {
		if (RTable[i]->cmd < 90) /* Keep this record */ {
			if (k != i) /* Move record up */ {
				rt = RTable[k];
				RTable[k] = RTable[i];
				RTable[i] = rt;
				RTable[i]->cmd += 90;
				new_ref(i,k);
			}
			k++;
		}
	}
	numrt = k;
	dump_rt("Final Routing Table\n\n");
}
