/* Copyright 1989 Xanthus Inc and Thomas A. Moulton, W2VY
   ALL RIGHTS RESERVED!
*/
#include "ini.h"
#include "rtable.h"
#include "dnic.h"
#include "node.h"

#include <conio.h>
#include <stdio.h>
#define TRUE 1
#define FALSE 0

putxch(val, f)
FILE f;
int val;
{
	char v;

	v= (val >> 4) &0x0f;
	if (v > 9) v += 7;
	fputc(v+0x30, f);
	v=(val & 0x0f);
	if (v > 9) v += 7;
	fputc(v+0x30, f);
}

int
wrap(col, f)
int col;
FILE f;
{
	if (col > 70) {
		fputc(0x0a, f);
		return 1;
	}
	return 0;
}

#define WRITE 01
#define READ 02
#include "config.h"
FILE *fnam;

preamble(cmd, obj, len)
int cmd, obj, len;
{
	fputc(0x3a,fnam);
	putxch(cmd & 0xff, fnam);
	putxch(obj & 0xff, fnam);
	putxch(len & 0xff, fnam);
	putxch((len >> 8) & 0xff, fnam);
}

extern int nnodes, nusers, ndnics, textlen, userport;
extern struct dnicstr DNICS[], *DNIC;
extern struct nodestr Nodes[];
extern char textdata[];
extern char altable[][16];
extern int maxalt;
extern int passlen;
extern char passwd[257];

writefig(fname)
FILE *fname;
{
	int i,j,l,max,pos,ch, checksum, numnod, numnods;

	fnam = fname;
	if (fnam == NULL) {
		printf("No Output File name was supplied!\n");
		return;
	}

	numnod = numnods = nnodes+1;
	if (nusers != 0) numnods = 16 + nusers;
	preamble(WRITE,CALL,numnods*7);
	checksum=0;
	pos=9;
	for (i=0;i<numnods;i++) {
		for (j=0;j<7;j++) {
			ch=Nodes[i].call[j];
			checksum += ch;
			if (wrap(pos, fnam)) pos=0;
			pos += 2;
			putxch(ch,fnam);
		}
	}
	putxch((-checksum) &0xff, fnam);
	fputc(0x0a, fnam);


	/* Now write out the digipeaters */

	preamble(WRITE,DIGI,numnods*7);
	checksum=0;
	pos=9;
	for (i=0;i<numnods;i++) {
		for (j=0;j<7;j++) {
			ch=Nodes[i].digi[j];
			checksum += ch;
			if (wrap(pos, fnam)) pos=0;
			pos += 2;
			putxch(ch,fnam);
		}
	}
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);


	/* Switch Address */

	preamble(WRITE,NODENUM,7);
	checksum=0;
	pos=9;
	for (i=0;i<7;i++) {
		ch=Nodes[0].adr[i];
		checksum += ch;
		if (wrap(pos, fnam)) pos=0;
		pos += 2;
		putxch(ch,fnam);
	}
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);


	/* Now write out the ports */

	preamble(WRITE,PORT,numnods);
	checksum=0;
	pos=9;
	for (i=0;i<numnods;i++) {
		ch=Nodes[i].port;
		checksum += ch;
		if (wrap(pos, fnam)) pos=0;
		pos += 2;
		putxch(ch,fnam);
	}
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);

	/* Now write out the Max Vc's */
	preamble(WRITE,MAXVC,numnods);
	checksum=0;
	pos=9;
	for (i=0;i<numnods;i++) {
		ch=Nodes[i].maxvc;
		checksum += ch;
		if (wrap(pos, fnam)) pos=0;
		pos += 2;
		putxch(ch,fnam);
	}
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);


	/* Next is the Level 3 Packet Window */

	preamble(WRITE,L3WI,numnods);
	checksum=0;
	pos=9;
	for (i=0;i<numnods;i++) {
		ch=Nodes[i].l3w;
		checksum += ch;
		if (wrap(pos, fnam)) pos=0;
		pos += 2;
		putxch(ch,fnam);
	}
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);


	/* Now the link retry delay */

	preamble(WRITE,DELAY,numnod*2);
	checksum=0;
	pos=9;
	for (i=0;i<numnod;i++) {
		j=Nodes[i].timeout;
		ch = j&0xff;
		checksum += ch;
		if (wrap(pos, fnam)) pos=0;
		pos += 2;
		putxch(ch,fnam);
		ch= (j>>8) &0xff;
		checksum += ch;
		if (wrap(pos, fnam)) pos=0;
		pos += 2;
		putxch(ch,fnam);
	}
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);


	/* Routing Table entries */

	if (numrt > 0) /* Routing Table Exists put it out */ {
		compress_rt();
		if (numrt*12 > 2048) printf("*** Warning Routing Table is %d bytes long, switch may only support 2048!!!\n");
		preamble(WRITE,ROUTES,numrt*12);
		checksum=0;

		pos=9;
		max=0;
		for (i=0;i < numrt; i++) {
			ch=RTable[i]->cmd;
			checksum += ch;
			if (wrap(pos, fnam)) pos=0;
			pos += 2;
			putxch(ch,fnam);

			ch=RTable[i]->dta;
			checksum += ch;
			if (wrap(pos, fnam)) pos=0;
			pos += 2;
			putxch(ch,fnam);

			for (j=0;j<10;j++) {
				ch = RTable[i]->next[j];
				if ((ch == i) && (ch != 0))
					printf("*** Error Routing Branch = 0, ch=%d\n",ch);
				if (ch != 0) ch = (ch-i);
				if ((ch < 0) || (ch > 255)) {
					printf("*** Error Displacement = %d ***\n",ch);
					printf("RTable[%d]->next[%d]=%d\n", i, j, RTable[i]->next[j]);
					ch=0;	/* Invalidate Routing */
				}
				else if (ch > max) max = ch;
				ch = ch & 0xff;
				checksum += ch;
				if (wrap(pos, fnam)) pos=0;
				pos += 2;
				putxch(ch,fnam);
			}
		}
		putxch((-checksum) & 0xff, fnam);
		fputc(0x0a, fnam);
		printf("The Largest Displacement used was %d\n",max);
	}


	/* User Port number */

	preamble(WRITE,USERPORT,2);
	checksum=0;
	pos=9;
	j=userport;
	ch = j&0xff;
	checksum += ch;
	if (wrap(pos, fnam)) pos=0;
	pos += 2;
	putxch(ch,fnam);
	ch= (j>>8) &0xff;
	checksum += ch;
	if (wrap(pos, fnam)) pos=0;
	pos += 2;
	putxch(ch,fnam);
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);


	/* USA Routes (the routing alternatives) */

	preamble(WRITE,USAROUTE,16*maxalt);
	checksum=0;
	pos=9;
	for (i=0;i<maxalt;i++) {
		for (j=0;j<16;j++) {
			ch=altable[i][j];
			checksum += ch;
			if (wrap(pos, fnam)) pos=0;
			pos += 2;
			putxch(ch,fnam);
		}
	}
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);

	/* PASSWRD - Password!! */

	if (passlen && passwd[0]) /* Only do this if we got a password */ {
		preamble(WRITE,PASSWRD,passwd[0]+2);
		checksum=0;
		pos=9;
		ch = passlen;
		checksum += ch;
		if (wrap(pos, fnam)) pos=0;
		pos += 2;
		putxch(ch,fnam);

		for (i=0;i<passwd[0]+1;i++) {
			ch=passwd[i];
			checksum += ch;
			if (wrap(pos, fnam)) pos=0;
			pos += 2;
			putxch(ch,fnam);
		}
		putxch((-checksum) & 0xff, fnam);
		fputc(0x0a, fnam);
	}

	/* L2USER Text Message */

	preamble(WRITE,L2USER,textlen);
	checksum=0;
	pos=9;
	for (i=0;i<textlen;i++) {
		ch=textdata[i];
		checksum += ch;
		if (wrap(pos, fnam)) pos=0;
		pos += 2;
		putxch(ch,fnam);
	}
	putxch((-checksum) & 0xff, fnam);
	fputc(0x0a, fnam);
	fputc(0x0a, fnam);

	/* All Done, close file */
	fclose(fnam);
	printf("All Done!\n\n");
}
