#ifndef	SOCK_STREAM

/* IP protocol numbers */
#define	IPPROTO_ICMP	1
#define	IPPROTO_TCP	6
#define	IPPROTO_UDP	17

/* TCP port numbers */
#define	IPPORT_ECHO	7	/* Echo data port */
#define	IPPORT_DISCARD	9	/* Discard data port */
#define	IPPORT_FTPD	20	/* FTP Data port */
#define	IPPORT_FTP	21	/* FTP Control port */
#define IPPORT_TELNET	23	/* Telnet port */
#define IPPORT_SMTP	25	/* Mail port */
#define	IPPORT_FINGER	79	/* Finger port */
#define IPPORT_RLOGIN	513	/* remote login */

/* UDP port numbers */
#define	IPPORT_DOMAIN	53
#define	IPPORT_RIP	520
#define	IPPORT_REMOTE	1234	/* Pulled out of the air */

#define	AF_INET	0
#define	AF_AX25	1
#define AF_NETROM 2

#define	SOCK_STREAM	0
#define	SOCK_DGRAM	1
#define	SOCK_RAW	2
#define SOCK_SEQPACKET	3

/* fcntl(2) parameters */
#define   F_GETFL             3         /* Get file flags */
#define   F_SETFL             4         /* Set file flags */
/* flags for F_GETFL, F_SETFL- copied from <sys/file.h> */
#define   FNDELAY                       00004/* non-blocking reads */

#define	EMFILE	1
#define	EBADF	2
#define	EINVAL	3
#define	ESOCKTNOSUPPORT	4
#define	EAFNOSUPPORT	5
#define	EOPNOTSUPP	6
#define	EFAULT		7
#define	ENOTCONN	8
#define	ECONNREFUSED	9
#define EAFNOSUPP	10
#define	EISCONN		11
#define	EWOULDBLOCK	12
#define	EINTR		13
#define	EADDRINUSE	14
#define	ENOMEM		15
#define EMSGSIZE	16

/* Berkeley format socket address structures. These things were rather
 * poorly thought out, but compatibility is important (or so they say).
 * Note that all the sockaddr variants must be of the same size, 16 bytes
 * to be specific. Although attempts have been made to account for alignment
 * requirements (notably in sockaddr_ax), porters should check each
 * structure.
 */

/* Generic socket address structure */
struct sockaddr {
	short sa_family;
	char sa_data[14];
};

/* This is a structure for "historical" reasons (whatever they are) */
struct in_addr {
	unsigned long s_addr;
};

/* Socket address, DARPA Internet style */
struct sockaddr_in {
	short sin_family;
	unsigned short sin_port;
	struct in_addr sin_addr;
	char sin_zero[8];
};
#endif

enum {
	EXT_PRESENCE,
	EXT_RESOLVE,
	EXT_SOCKET,
	EXT_CONNECT,
	EXT_USPRINTF,
	EXT_WRITE_P,
	EXT_FREE_P,
	EXT_RECV,
	EXT_SEND,
	EXT_CLOSE_S,
	EXT_ERRNO,
	EXT_FCNTL,
	EXT_SOCKLEN,
	EXT_RECVLINE,
};
