unit intutil;
interface

    function mini(a,b:integer):integer;
    function maxi(a,b:integer):integer;
    function random:integer;
    function distribution(minval,maxval:integer):integer;

implementation
  uses dos;

  var shift_register:word; { used in random number generator }

  { mini --- return the minimum value of "a" or "b" }

  function mini;
  begin
    if a < b then mini:=a else mini:=b;
  end;



  { maxi --- return the maximum value of "a" or "b" }

  function maxi;
  begin
    if a > b then maxi:=a else maxi:=b;
  end;


  { random --- return a random number from 0 to 32767 }

  function random;
  { this function uses the CRC-16 algorithm as a pn generator }

  const BITS = 16;
	FEEDBACK = $1021; { CRC-16 intermediate feedback }

  var	temp,carry,i:integer;
	hour,minute,second,sec100:word;
	t:string[8];

  begin { random }
    { if the shift_register is uninitialized then init with the clock }
    if shift_register = 0 then
      begin
	gettime(hour,minute,second,sec100);
	shift_register:=minute + second * 8 + sec100 * 64;
      end;

    temp:=0;

    { compute the random number by cranking the CRC-16 algorithm }
    for i:=1 to BITS - 1 do
      begin
	{ set carry if the last bit in the shift register is a one }
	carry:=ord((shift_register and $8000) > 0);

	{ shift random number and add carry }
	temp:=2 * temp + carry;

	if carry = 1
	   then { shift register left by 1 bit with intermediate feedback }
	     begin
	       { strip off msb to prevent overflow }
	       shift_register:=shift_register and $7FFF;

	       { shift left }
	       shift_register:=shift_register * 2;

	       { apply intermediate feedback }
	       shift_register:=shift_register xor FEEDBACK;
	     end
	   else { shift register left }
	       shift_register:=shift_register * 2;
        random:=temp;
      end;
  end;	{ random }


  { distribution --- returns a random number between minval and maxval }

  function distribution;
  begin
    distribution:=minval + random mod (maxval - minval + 1)
  end;

begin
  shift_register:=0;
end.
