
Kenwood Computer Interface Instructions
_______________________________________

     These Instructions are TS-440 specific, but the basics also
apply to the TS-940, TS-811 and TS-711.

     It is possible to save yourself a few dollars and lose nothing
in quality by buying the parts to upgrade your Kenwood radio for
computer control. Just purchase the parts were you find them and
install them using the instructions in the Radio's Manual.

     IC 54 is a uPD-8251-AC   Serial Communications Interface.
                Commonly called an 8251A    ($1.89 Mail Order)
     IC 55 is a TC-4040-BP    12 Stage CMOS Divider.
                Commonly called a 4040      ($0.69 Mail Order)

     The IC-10 Interface Kit from Kenwood Contains ONLY these two parts
and less instructions than are in this file.  The only thing you are
going to miss, is the $22+ price tag on the IC-10 Kit.

 Signals are    TTL levels  (NOT RS-232)
Baud rate is    4800 (1200 Opt.)
   Format is    ASCII Serial;  1 Start, 8 Data, 2 Stops

   The Baud rate may be changed to 1200 Baud by removing jumper W50
and installing a jumper from the left pad to the center pad as viewed
from the front of the radio.  This will become obvious once you have
the radio opened up.  Many other Baud rates are possible, just look
at the schematic.

     As long as you are in the radio, lift D-60 to enable the
10 Hz. display.  The main tuning knob is varing this digit, so
you might as well see it.  It also helps when using RIT/XIT as
the RIT/XIT display does not resolve the 0.01 KHz. digit.  This 
Modification is in the Radio's Book.

     Not in the book is the fact that if you lift D-80 and do
an MPU reset, you will be able to transmit on any frequency
between 1.5 and 30.0 MHz.  This means you will be able to 
work the Mars nets, Etc.  Do not transmit out of band.  It is
illegal even if it is accidental.

     Some computers use TTL levels on their serial ports.  If so,
here is a time when you will not have to convert it to RS-232.

  The IF-232 Interface from Kenwood is a 1488 and a 1489 chip
in a box.  These are an RS-232 Quad Line Driver and Receiver
and are available at Radio Shack for $1.29 Each.  Here is an
easy project that will save you a lot over the $69+ Kenwood price 
of the IF-232 Interface.  The 1488 needs a + and - supply.
Unregulated + and - 12vdc is just fine. Get the +5 vdc for the
1489 by putting a 7805 regulator on the +12 vdc supply.  100 ma.
is about the max you'll draw, so the smallest transformer you
can find will still be plenty large.  Don't forget to series up
two of each gate to cancel the inversion that the 1480's produce.



ACC-1  Connector                  Use a 6 Pin DIN Connector.
                                         (Radio Shack $1.29)
Pin     Signal  Comments
________________________

1       Gnd     Signal Ground
2       TXD     Serial Data from Radio to Computer
3       RXD     Serial Data from Computer to Radio
4       CTS     Computer Ready;  (Radio Input)
5       RTS     Radio Ready;    (Radio Output)
6               No Connection

Pins 4 and 5 may be left Unconnected.






***** Command Description for Kenwood Computer Interface *****
______________________________________________________________

                Auto Information
                ________________
AIn; 
                The Radio Will Send the Status Info Automatically
                Whenever the Operator Manually Varies any Function
                on the Radio which is Covered in the IF; Command
                        Where   n = 0 for Auto Info OFF
                                    1 for Auto Info On

                The Status Information Will be Sent in the Form :
                        As defined in the IF; Command


                Display Memory
                ______________
DMnnnn;
                This is a Factory Diagnostic Function
                and is of no practical use to the operator

                The Contents of the MPU Memory will be Read
                        Where   nnnn = MPU Address (0000 Thru FFFF (HEX))

                The Contents of the MPU Memory Will be Sent in the Form :
                 DMnnnn-aabbccddeeffgghhiijjkk;
                        Where   nnnn = MPU Address (0000 Thru FFFF (HEX))
                              aa~~kk = Hex Number Pairs Of Next 16 Locations


                Down
                ____
DN;
                The Frequency or Memory Channel
                Will Decrement One Step


                Frequency VFO A / VFO B Request
                _______________________________
FA;
FB;
                The Frequency in the Selected VFO Will be Read

                The Frequency Will be Sent in the Form:
                 FAggmmmkkkhhh;   or
                 FBggmmmkkkhhh;
                        Where    gg = GHz. Value
                                mmm = MHz. Value
                                kkk = kHz. Value
                                hhh =  Hz. Value


                Frequency VFO A / VFO B Select
                ______________________________
FAggmmmkkkhhh;
FBggmmmkkkhhh;
                The VFO Selected Will be Set to the Frequency Defined
                        Where    gg = GHz. Value (May be sent As 00 or Spaces)
                                mmm = MHz. Value
                                kkk = kHz. Value
                                hhh =  Hz. Value


                Function Select
                _______________
FNn;
                The Function Defined Will be Selected
                        Where   n = 0 for VFO A
                                    1 for VFO B
                                    2 for MEMORY

                Identify Model Request
                ______________________
ID;
                The Model of the Radio Will be sent in the Form :
                 ID00n;
                        Where : n = 1 for a TS-940 (*)
                                n = 2 for a TS-811 (*)
                                n = 3 for a TS-711 (*)
                                n = 4 for a TS-440


                Read Information Request
                ________________________
IF;
                The Status Information Will be Sent in the Form :
                 IFggmmmkkkhhh     snnnzrx yytdfcp
                        Where   gg~~hhh = Value as defined in FA Command
                                      s = "+" or "-" Value of RIT/XIT
                                    nnn = Value of RIT/XIT (n.nn kHz.)
                                      z = "0"  (Not Used in TS-440)
                                      r = Value as defined in RT Command
                                      x = Value as defined in XT Command
                                     yy = Memory Channel No.
                                      t = 0 for Receive
                                          1 for Transmit
                                      d = Value as defined in MD Command
                                      f = Value as defined in FN Command  
                                      c = Value as defined in SC Command
                                      p = Value as defined in SP Command  


                Lock Knob
                _________
LKn;
                The Manual Frequency Control Functions Will be Disabled
                        Where   n = 0 for Lock OFF
                                    1 for Lock ON


                Memory Channel Select
                _____________________
MCxmm;
                The Memory Channel Defined Will be Selected
                        Where:  x = Don't Care   (Use "0" or Space)
                               mm = Memory Channel No. (00 thru 99)


                Mode Select
                ___________
MDn;
                The Mode Defined Will Be Selected
                        Where:  n = 1 for LSB
                                    2 for USB
                                    3 for CW
                                    4 for FM
                                    5 for AM
                                    6 for FSK


                Memory Read
                ____________
MRnxrr;
                The Memory Channel Defined Will be Read
                        Where:  n = 0 for RX VFO
                                    1 FOR TX VFO (Split Channels Only)
                                x = Don't Care      (Use "0" or Space)
                               rr = Memory Channel No.    (00 thru 99)

                The Memory Information will be sent in the Form :
                 MRn rrggmmmkkkhhhdz    ;
                        Where:  n = 0 for RX VFO
                                    1 FOR TX VFO (Split Channels Only)
                               rr = Memory Channel No.    (00 thru 99)
                         gg~~hhh = Value as defined in FA Command
                                d = Value as defined in MD Command
                                z = "0"  (Not Used in TS-440)
                        (Note: Four trailing Spaces)


                Memory Write           
                ____________
MWnxrrggmmmkkkhhhdzxxxx;
                The Memory Selected Will be Set to the Frequency Defined
                        Where:  n = 0 for RX VFO
                                    1 for TX VFO (Split Channels Only)
                                x = Don't Care  (Use "0" or Space)
                               rr = Memory Channel No.    (00 thru 99)
                          gg~~hhh = Value as defined in FA Command
                                d = Value as defined in MD Command
                                z = "0" (Not Used in TS-440)


                RIT/XIT Clear
                _____________
RC;
                The RIT/XIT will be set to 0.00 kHz.


                RIT/XIT Down
                ____________
RD;
                The RIT/XIT will Decrement by 0.01 KHz. (10 Hz.)


                RIT/XIT UP
                __________
RU;
                The RIT/XIT will Increment by 0.01 KHz. (10 Hz.)


                RIT (ON/OFF)
                ____________
RTn;
                The RIT Status Will be Selected
                        Where   n = 0 for RIT OFF
                                    1 for RIT ON


                Receive
                _______
RX;
                Radio Will Enter Receive Mode     (PTT Released)


                Scan (ON/OFF)
                _____________
SCn;
                The Scan Status Will be Selected
                        Where   n = 0 for Scan OFF
                                    1 for Scan ON


                Split (ON/OFF)
                ______________
SPn;
                The Split Status Will be Selected
                        Where   n = 0 for Split OFF
                                    1 for Split ON


                Transmit
                ________
TX;
                Radio Will Enter Transmit Mode   (PTT Depressed)


                Up
                __
UP;
                The Frequency or Memory Channel
                Will Increment One Step


                Voice Recall
                ____________
VR;
                The Frequency Will Be Spoken (*)


                XIT (ON/OFF)
                ____________
XTn;
                The XIT Function Will be Selected
                        Where   n = 0 for XIT OFF
                                    1 for XIT ON

                (Note: XIT is Co-Affected by the RC, RD and RU Commands)


(*)  Denotes this Command or Function has not been Tested.
_______________________________________________________________




     These additional Kenwood Commands do not apply to the TS-440 and
as such were not defined;  but are used in one or more of the other
models and are presented here for your experimentation.

AT      Antenna Tuner (Standby)
DI      DCL ID (Readout of Callsign)
DS      DCL System (On/Off)
HD      Scan Hold
LO      Local (TS-940 : Remote control of SLOPE, TUNE, VBT)
MS      Memory Scan
OS      Offset
SH      Slope Tune High
SL      Slope Tune Low
ST      Step
TN      Tone Number (SubTone)
TO      Tone (SubTone On/Off)
VB      VBT


(end)


