#include <string.h>
#undef NULL
#include <conio.h>
#include <stdio.h>
#define TRUE 1
#define FALSE 0
#include <dos.h>

struct ax25_parms {
	char version;			/* Default protocol version	*/
	int frack;			/* Initial T1 timer value, sec.	*/
	int resptime;			/* Initial T2 timer value, sec.	*/
	int check;			/* Initial T3 timer value, sec.	*/
	int retry;			/* Initial N2 count		*/
	char maxframe;			/* Maximum # of outstanding frames*/
	int framesize;			/* Maximum I-field length	*/
};

FILE *fnami, *fnamo, *fnamm;
char zin[80], zout[80], zmach[80], fname[80];
char *in, *out, *machine;
char zarr[80];

char rosezsw[]="ROSEZSW.BIN";
char rosehex[]="ROSEZSW.HEX";
char roseupd[]="ROSEUPD.TBL";

char rzsw[]="ROSEZSW.OVR";
char tnc2[]="TNC2.OVR";
char tnc320[]="TNC320.OVR";
char dr200[]="DR200.OVR";
char pk88[]="PK88.OVR";
char hp[]="HANDIPKT.OVR";

char *tncs[] = { tnc2, tnc320, dr200, pk88, hp };
char *outfiles[] = {rosezsw, rosehex, roseupd};

int tick_tab[] = { 600, 300, 300, 600 , 150};	/* Frequency in Cycles */
int led_tab[] = { 0, 0x04, 0, 0x09, 0};
int flag_tab[] = {1, 2, 4, 8, 16};
int rbaud_tab[] = {1200, 300, 1200, 1200, 1200};
int tbaud_tab[] = {9600, 9600, 1200, 9600, 9600};

#define sds_dw 3
#define sds_txd 5
#define sds_flag 10
#define sds_flag_full 2

#define tnc2_ok 0x01
#define tnc320_ok 0x02
#define dr200_ok 0x04
#define pk88_ok 0x08
#define hp_ok 0x10
#define all_ok 0x1f

struct opt {
	char *name;		/* Word associated with this item */
	unsigned char flags;	/* Machines this is valid for */
};

struct opt yes_no[] = {
	{ "No", 0 },
	{ "Yes", 0 },
	{ "OFf", 0 },
	{ "ON", 0 },
	{ "0", 0 },
	{ "1", 0 },
	{ "", 0 }
};

struct opt modes[] = {
	{ "BINary", 0},
	{ "HEX",0},
/*	{ "UPDate",0}, */
	{ "", 0 }
};

struct opt tnc_names[] = {
	{ "TNC2", 0 },
	{ "TNC320", 0 },
	{ "DR200", 0 },
	{ "PK88", 0 },
	{ "HP", 0 },
	{ "", 0 }
};

struct opt modem_typ[] = {
	{ "VHF", 0 },
	{ "HF", 0},
	{ "", 0}
};

struct opt options[] = {
	{ "HEX", all_ok },
	{ "BINary", all_ok },
	{ "SWitch", all_ok },
	{ "CALL", all_ok },
	{ "DIGI", all_ok },
	{ "ADDress", all_ok },
	{ "TNC", all_ok },
	{ "CPU", tnc320_ok+pk88_ok+hp_ok },
	{ "TICK", tnc320_ok+pk88_ok+hp_ok },
	{ "1BAud", tnc320_ok+pk88_ok+hp_ok },
	{ "0BAud", tnc320_ok+pk88_ok+hp_ok },
	{ "LED", tnc320_ok+pk88_ok },
	{ "OUTput", all_ok },
	{ "NODISPlay", all_ok },
	{ "HELP", all_ok },
	{ "MODEM", tnc320_ok },
	{ "1TXDelay", all_ok },
	{ "0TXDelay", all_ok },
	{ "1DWait", all_ok },
	{ "0DWait", all_ok },
	{ "1FULL", all_ok },
	{ "0FULL", all_ok },
	{ "L2FRack", all_ok },
	{ "L2RESptime", all_ok },
	{ "L2CHeck", all_ok },
	{ "L2RETry", all_ok },
	{ "L2MAXframe", all_ok },
	{ "L3FRack", all_ok },
	{ "L3RESptime", all_ok },
	{ "L3CHeck", all_ok },
	{ "L3RETry", all_ok },
	{ "L3MAXframe", all_ok },
	{ "MODE", all_ok },
	{ "SETUP", all_ok },
	{ "COMPlete", all_ok },
	{ "",0}
};

unsigned char memory[32768];
unsigned int maxmem;
unsigned int adr_call, adr_digi, adr_addr, adr_l2parms, adr_l3parms;
unsigned int adr_sds0, adr_sds1, adr_tick, adr_tbaud, adr_rbaud, adr_ileds;
unsigned int adr_setup, adr_complete;

struct ax25_parms
l2parms={
	1,	/* AX25L2 Version 2, default */
	5,	/* T1, frack */
	3,	/* T2, resptime */
	300,	/* T3, check (5 mins.) */
	8,	/* N2, retry */
	4,	/* W, maxframe */
	256	/* N1, framesize */
};

struct ax25_parms
l3parms={
	1,	/* AX25L2 Version 2, default */
	5,	/* T1, frack */
	2,	/* T2, resptime */
	600,	/* T3, check (10 mins.) */
	8,	/* N2, retry */
	3,	/* W, maxframe */
	256	/* N1, framesize */
};

unsigned char setup[40] = "Call being Setup";
unsigned char complete[40] = "Call Complete to ";

unsigned char call[7];
unsigned char digi[7];
unsigned char add[16];
int mach, modem320, mode;
int tick, term, radio;
int txd_term, txd_radio, dw_term, dw_radio, full_term, full_radio;
int led, nodisplay;
long int clk;
int interactive;

unsigned char rose[6] = {0xa4, 0x9e, 0xa6, 0x8a, 0x40, 0x40};

int
home()
{
	printf("\033[H");
}

int
cls()
{
	printf("\033[2J");
}

int
hexhi(ch)
char ch;
{
	int i;

	i = (ch>>4)&15;
	return (i > 9 ? i+0x37 : i+0x30);
}

int
hexlo(ch)
char ch;
{
	int i;

	i = ch&15;
	return (i > 9 ? i+0x37 : i+0x30);
}

int
getlin(str,max)
char *str;
int max;
{
	int ch, pos;

	ch=pos=0;
	while (ch != 0x0a && pos<max) {
		ch=getchar();
		if (ch == -1) return -1;
		str[pos++]=ch;
		str[pos]=0;
	}
	if (ch== 0x0a) str[pos-1]=0;
	return (strlen(str));
}

#if 0
int
getline(str,max)
char *str;
int max;
{
	int l;

	while ((l=getlin(str, max)) == 0) ;
	return l;
}
#endif

intel(loc, mem, f)
unsigned int loc;
unsigned char *mem;
FILE *f;
{
	int i, j, sum;
	char *ch, buf[80];

	ch = buf;
	*ch++ = ':';
	*ch++ = '2';
	*ch++ = '0';
	sum = 32;
	j = (loc>>8)&255;
	sum += j;
	*ch++ = hexhi(j);
	*ch++ = hexlo(j);
	j = loc&255;
	sum += j;
	*ch++ = hexhi(j);
	*ch++ = hexlo(j);
	*ch++ = '0';
	*ch++ = '0';
	for (i=0;i<32;i++) {
		sum += *mem;
		*ch++ = hexhi(*mem);
		*ch++ = hexlo(*mem);
		mem++;
	}
	j = (-sum) & 255;
	*ch++ = hexhi(j);
	*ch++ = hexlo(j);
	*ch++ = 13;	/* CR */
	*ch++ = 10;	/* LF */
	*ch++ = 0;
	fputs(buf, fnamo);
}

get_call(adr, len, stn)
char adr[], stn[];	/* stn is really struct ax25_adr * */
int len;
{
	int i,j;

	j = 0; /* Source pos */

	for (i=0;i<6;i++) {
		adr[j]=toupper(adr[j]);
		if ((j==len) || (adr[j] == 0x2d))
			stn[i]=0x40;
		else /* Normal ch */
			stn[i]=(adr[j++]<<1);
	}
	stn[i]=0;
	if (adr[j++] == 0x2d && j <= len && adr[j] >= 0x30 && adr[j] <= 0x39) {
		stn[i]=(adr[j++]-0x30)<<1;
		if (j <= len && adr[j] >= 0x30 && adr[j] <= 0x39) {
			stn[i] = stn[i]*10 + ((adr[j] - 0x30)<<1);
		}
		if (stn[i] > 30) stn[i]=0;
	}
	stn[i] |= 0x60;		/* Set Reserved bits */
	return 0;
}

call_str(stn, str)
unsigned char stn[], *str;
{
	int i;

	*str = NULL;
	for (i=0; i<6; i++) /* Copy callsign to str */ {
		if ( (stn[i] == 0x40) || (stn[i] == 0) ) break;
		*str++ = (stn[i]) >> 1;
	}
	i = (stn[6]>>1) & 0x0f;
	if (i) /* SSID present */ {
		*str++ = 0x2d;	/* Dash */
		if (i > 9) {
			*str++ = 0x31;
			i -= 10;
		}
		*str++ = i+0x30;
	}
	*str = NULL;
}

adr_copy(src,istr,des,ostr)
int src;
char istr[16];
int des;
char ostr[16];

{
	int ipos, opos, ilow, olow, len, i, acc;

	if(src) /* Copy High order call (calling address) */ {
		ilow=istr[0]&1;
		ipos= ( (istr[0] & 0x0f) + ilow) >> 1;
		len=(istr[0] & 0x0f0)>>4;
		if (!ilow) ipos++;
	}
	else /* Copy low order call (called address) */ {
		ipos=1;
		ilow=0;
		len=istr[0] & 0x0f;
	}
	if (des) /* Copy to high order call (calling) */ {
		olow=ostr[0] & 1;
		opos=( (ostr[0] & 0x0f) + olow) >> 1;
		ostr[0]=ostr[0] & 0x0f | len<<4;
		if (!olow) opos++;
	}
	else /* Copy to low order call (called) */ {
		olow=0;
		opos=1;
		ostr[0]=ostr[0] & 0xf0 | len;
	}
	acc=0;
	if (olow)
		acc=ostr[opos] & 0xf0; /* Init acc */
	for (i=1;i<=len;i++) {
		if (ilow) acc += istr[ipos++] & 0x0f;
		else acc += (istr[ipos] & 0x0f0) >> 4;
		ilow = !ilow;
		if (olow) /* Output a byte */ {
			ostr[opos++]=acc;
			acc=0;
		}
		else acc=acc<<4;
		olow = !olow;
	}
	if (olow) ostr[opos]=acc;
}

x121_adr(str,x121)
char str[];
char x121[16];
{
	int i,len,ch,hi;
	char x[16];

	x121[0]=len=0;
	len=strlen(str);
	for (i=0;i<len;i++) /* Insure valid numbers */ {
		ch=str[i];
		if (ch == 0) break; /* End of address */
		if ((ch < 0x30) || (ch > 0x39)) return 0; /* Non-digit */
	}

	x[0]=len;
	ch=0;
	hi=0;
	for (i=0;i<len;i++) {
		hi = !hi;
		if (hi) ch = (str[i] - 0x30) << 4;
		else {
			ch = ch | (str[i] - 0x30);
			x[ (i>>1) + 1 ]= ch;
		}
	}
	if (hi) x[ (i>>1) + 1 ]= ch;
	adr_copy(0,x,1,x121);
	x121[0]=((x121[0] & 0x0f) + ((x121[0] & 0x0f0) >> 4));
	return len;
}

x121_str(x121, str)
char x121[], *str;
{
	int l, i, ch;

	l = x121[0] & 0x0f;	/* Only Supports low order address */
	for (i=0; i<l; i++) /* Copy and convert address */ {
		ch = x121[ 1+(i>>1) ];
		if (i & 1) *str++ = 0x30 + (ch & 0x0f); /* Low digit */
		else *str++ = 0x30 + ( (ch>>4) & 0x0f); /* High Digit */
	}
	*str = NULL;
	return;
}

init()
{
	int i;

	mach = 0;	/* TNC-2 */
	clk = 4915200;
	term = 9600;
	radio = 1200;
	tick = tick_tab[mach];
	led = led_tab[mach];
	modem320 = 0;
	mode = 0;
	nodisplay = FALSE;
	txd_term = 0;
	txd_radio = 400;
	dw_term = dw_radio = 0;
	full_term = full_radio = 0;
	for (i=1;i<16;i++) add[i]=0;
	add[0]=10;
	add[1]=0x31;	/* 10, 3100000000 */
	for (i=0;i<6;i++) {
		call[i] = rose[i];	/* ROSE- */
		digi[i] = rose[i];
	}
	call[6] = 0x66;	/* -3 */
	digi[6] = 0x64;	/* -2 */
}

int
isupper(ch)
char ch;
{
	ch = ch&0x7f;
	return (ch>0x40 && ch<0x5b);
}

int
find_sym(sym, len, tab)	/* Find the string SYM in the TABle */
char *sym;
int len;
struct opt tab[];
{
	static int f, i, j, l;

	i=0;
	while (l=strlen(tab[i].name)) {
		if (l >= len) {
			f=TRUE;
			for (j=0;j<len;j++)
				if (toupper(sym[j]) != toupper(tab[i].name[j]))
					f=FALSE;
			if (f) {
				if (l == len) return i; /* Exact Match */
				if (!isupper(tab[i].name[j])) return i;
			}
		}
		i++;
	}
	i++;	/* Incase First is open */
	return -i;
}

int
cmd_options(argc, argv)
int argc;
char *argv[];
{
	int i;

	for (i=1;i<argc;i++) /* Check all args */ {
		if (do_opt(argv[i]) == -1) return -1;
	}
}

do_digits(ch, len, loc, def)
char *ch;
int len;
int *loc;
int def;
{
	if (len) /* CMD = n */ {
		if (sscanf(ch, "%d", loc) != 1) {
			*loc = def;
		}
	}
}

do_syms(ch, len, loc, syms)
char *ch;
int len;
int *loc;
struct opt *syms;
{
	int i;

	if (len) {
		i = find_sym(ch, len, syms);
		if (i != -1) *loc = i;
	}
}

do_case6(ch, l)
char *ch;
int l;
{
	int i;

	i = find_sym(ch, l, tnc_names);
	if (i != -1) {
		if (mach != i && interactive) cls();
		mach = i;
		machine = tncs[mach];
		tick = tick_tab[mach];
		led = led_tab[mach];
		radio = rbaud_tab[mach];
		term = tbaud_tab[mach];
		if (mach == 1) {
			modem320 = 1;	/* HF Modem */
		}
	}
}

do_case10(ch)
char *ch;
{
	if (sscanf(ch, "%d", &radio) != 1) {
		if (mach != 1) radio = rbaud_tab[mach];
		else {
			if (modem320) radio = 300;
			else radio = 1200;
		}
	}
}

int
do_opt(chx)
char *chx;
{
	int i, j, l, m;
	char *ch, str[80];

	ch = chx;
	if (*ch == '/' || *ch == '-') ch++;
	m = strlen(ch);
	l=0;
	for (j=0;j<m;j++) /* Find length of option name */ {
		if (ch[j] == '=' || ch[j] == 0 || ch[j] == ' ') break;
		l++;
	}
	j = find_sym(ch, l, options);
	if (j < 0) /* Invalid option */ {
		return -1;
	}
	if (!options[j].flags & flag_tab[mach]) /* Error */ {
		printf("Option %s is not allowed for the %s machine!\n",
				chx, tnc_names[mach].name);
		printf("You may need to specify /TNC=xxx before this option\n");
		return -1;
	}
	ch += l;
	if (*ch == '=') ch++;
	else while (*ch && *ch == ' ') ch++;
	l = strlen(ch);
	switch (j) {
		case 0: if (out == outfiles[mode]) out = outfiles[0];
			mode = 0;
			break;
		case 1: if (out == outfiles[mode]) out = outfiles[1];
			mode = 1;
			break;
		case 2:	strcpy(zin, ch);
			in = zin;
			break;
		case 3: if (l) get_call(ch, l, call);
			break;
		case 4: if (l) get_call(ch, l, digi);
			break;
		case 5: if (l) x121_adr(ch, add);
			break;
		case 6: if (l) do_case6(ch, l);
			break;
		case 7: if (l) if (sscanf(ch,"%ld", &clk) != 1) {
				clk = 4915200;
			}
			break;
		case 8: do_digits(ch, l, &tick, tick_tab[mach]);
			break;
		case 9: do_digits(ch, l, &term, tbaud_tab[mach]);
			break;
		case 10: if (l) do_case10(ch);
			break;
		case 11: do_digits(ch, l, &led, led_tab[mach]);
			break;
		case 12: if (l) /* Output file name */ {
				strcpy(zout, ch);
				out = zout;
			}
			break;
		case 13: nodisplay = TRUE;
			break;
		case 14:	/* Help */
			return -1;
			break;
		case 15: i = modem320; /* MODEM=HF | VHF for tnc320 */
			do_syms(ch, l, &modem320, modem_typ);
			if (i != modem320) /* Modem changed */ {
				if (modem320) radio = 300;
				else radio = 1200;
			}
			break;
		case 16: do_digits(ch, l, &txd_term, 400);
			break;
		case 17: do_digits(ch, l, &txd_radio, 400);
			break;
		case 18: do_digits(ch, l, &dw_term, 0);
			break;
		case 19: do_digits(ch, l, &dw_radio, 0);
			break;
		case 20: do_syms(ch, l, &full_term, yes_no); /* FULL ON/OFf */
			break;
		case 21: do_syms(ch, l, &full_radio, yes_no); /* FULL ON/OFf */
			break;
		case 22: do_digits(ch, l, &l2parms.frack, l2parms.frack);
			break;
		case 23: do_digits(ch, l, &l2parms.resptime, l2parms.resptime);
			break;
		case 24: do_digits(ch, l, &l2parms.check, l2parms.check);
			break;
		case 25: do_digits(ch, l, &l2parms.retry, l2parms.retry);
			break;
		case 26: do_digits(ch, l, &l2parms.maxframe, l2parms.maxframe);
			break;
		case 27: do_digits(ch, l, &l3parms.frack, l3parms.frack);
			break;
		case 28: do_digits(ch, l, &l3parms.resptime, l3parms.resptime);
			break;
		case 29: do_digits(ch, l, &l3parms.check, l3parms.check);
			break;
		case 30: do_digits(ch, l, &l3parms.retry, l3parms.retry);
			break;
		case 31: do_digits(ch, l, &l3parms.maxframe, l3parms.maxframe);
			break;
		case 32: i = mode;	/* So we can do some clean up... */
			do_syms(ch, l, &mode, modes); /* MODE BIN | HEX | UPDATE */
			if (mode != i) /* It changed */ {
				if (out == outfiles[i]) /* Was Default name */ {
					out = outfiles[mode]; /* Use Default */
				}
			}
			break;
		case 33: if (l > 0 && l < 39) /* Looks OK */ {
				for (i=0;i<39;i++) setup[i]=0;
				i=0;
				while (*ch) setup[i++] = *ch++;
			}
			break;
		case 34: if (l > 0 && l < 40) /* Looks OK */ {
				for (i=0;i<40;i++) complete[i]=0;
				i=0;
				while (*ch) complete[i++] = *ch++;
			}
			break;
		default:
			return -1;
	}
	return 0;
}

char tprt[]="DB25/DE9)", rprt[]="5 Pin Din)";
char dr0[]="By RESET Pin)", dr1[]="Other/DR100)";

prt_pretty()
{
	char s1[20], s2[20], s3[20], *z, *prt0, *prt1;
	unsigned int anspos, prmpos;

   while (1) {
   	prt0 = rprt;
   	prt1 = tprt;
   	if (mach == 2) /* DR-200 */ {
   		prt0 = dr0;
   		prt1 = dr1;
   	}
	home();
	printf("ROSE Z80 X.25 Packet Switch EPROM Creation Program\033[K\n\033[K\n");
	printf("TNC type %-15s SWitch %-15s OUTput %-20s\033[K\n",machine, in, out);
/*	printf("output MODE %-15s (BINary | HEX | UPDate)\033[K\n\033[K\n", modes[mode].name); */
	printf("output MODE %-15s (BINary | HEX)\033[K\n\033[K\n", modes[mode].name);
	call_str(call, s1);
	call_str(digi, s2);
	x121_str(add, s3);
	printf("CALLsign = %-12s DIGIpeat call = %-12s ADDress = %-16s\033[K\n", s1, s2, s3);
	printf("messages:  SETUP    %-39s\033[K\n", setup);
	printf("           COMPlete %-40s\033[K\n", complete);
	printf("L2FRack %3d   L2RESptime %3d   L2CHeck %5d   L2RETry %3d   L2MAXframe %3d\033[K\n", l2parms.frack, l2parms.resptime, l2parms.check, l2parms.retry, l2parms.maxframe);
	printf("L3FRack %3d   L3RESptime %3d   L3CHeck %5d   L3RETry %3d   L3MAXframe %3d\033[K\n\033[K\n", l3parms.frack, l3parms.resptime, l3parms.check, l3parms.retry, l3parms.maxframe);
	printf("           PORT 0 (%-14s            PORT 1 (%-14s\033[K\n",prt0, prt1);
	printf("TX Delay (0TXDelay) %5d ms.              (1TXDelay) %5d ms.\033[K\n", txd_radio, txd_term);
	printf("DWait    (0DWait)   %5d ms.              (1DWait)   %5d ms.\033[K\n", dw_radio, dw_term);
	printf("FULLdup  (0FULL)    %5s                  (1FULL)    %5s\033[K\n",full_radio ? " ON " : "OFF", full_term ? " ON " : "OFF");
	if (mach == 1 || mach == 3 || mach == 4) /* TNC320 or PK88 or HandiPacket */ {
		printf("Speed    (0BAud)    %5d Baud             (1BAud)    %5d Baud\033[K\n", radio, term);
		if (mach == 1) /* TNC 320 */ {
			printf("HF/VHF   (MODEM)    %3s\033[K\n", modem320 ? "HF " : "VHF");
		}
		printf("CPU clock       %10ld Hz   TICK   %5d Hz   LED %X\033[K\n", clk, tick, led&0xff);
	}
	printf("\033[K\nType OK to accept the current settings or, QUIT (all CAPS) to exit to DOS\033[K\n");
	printf("To make changes, type the command followed by the new value\033[K\n");
	printf("Type the portion of the command that is in CAPS.\033[K\n\033[K\n\033[K\n\033[K\033[A");
	printf("EPROM>");
	getlin(zarr, 80);
	z = zarr;
	while (*z && *z == ' ') z++;
	if ((z[0] == 'O' || z[0] == 'o') && (z[1] == 'K' || z[1] == 'k')) return 0;
	if (z[0] == 'Q' && z[1] == 'U' && z[2] == 'I' && z[3] == 'T') exit(4);
	if (*z) {
		if (do_opt(z) == -1) {
			printf("Invalid Command, hit Return");
			getlin(zarr, 80);
		}
	}
   }
}

usage(nam)
char *nam;
{
		printf("\nusage:\n %s [options]\n\n", nam);
		printf("Options are as follows:\n");
		printf("   /HELP        - PRINT THIS LIST!\n");
		printf("   /NODISPLAY   - Supress menu selection screen\n");
		printf("   /MODE=BIN    - Format of OUTput file. HEX | BIN, see /HEX and /BIN\n");
		printf("   /HEX         - Output file in Intel Hex format\n");
		printf("   /BINary      - Output file in Binary Image format\n");
		printf("   /SWitch=name - Switch Overlay from file name\n");
		printf("   /CALL=ROSE-3 - EPROM Callsign of Switch\n");
		printf("   /DIGI=ROSE-2 - EPROM Digi Callsign\n");
		printf("   /ADDress=3100000000 - X.121 Address of switch\n");
		printf("   /TNC=TNC2    - Define machine type, can be TNC2 | TNC320 | DR200 | PK88\n");
		printf("   /OUTput=name - Put output in file name\n");
		printf("   /0TXDelay=ms - TXDelay (in MS) for Port 0 (Radio)\n");
		printf("   /1TXDelay=ms - TXDelay (in MS) for Port 1 (Terminal)\n");
		printf("   /0DWait=ms   - DWait (in MS) for Port 0\n");
		printf("   /1DWait=ms   - DWait (in MS) for Port 1\n");
		printf("   /0FULL       - Set Port 0 for Full Duplex operation\n");
		printf("   /1FULL       - Set Port 1 for Full Duplex operation\n");
		printf("Hit Return to continue");
		getlin(zarr, 80);
		printf("   /L2FRack     - FRack (T1) for Level 2 Users\n");
		printf("   /L2RESptime  - RESptime (T2) for Level 2 Users\n");
		printf("   /L2CHeck     - CHeck (T3) for Level 2 Users\n");
		printf("   /L2RETry     - RETry (N2) for Level 2 Users\n");
		printf("   /L2MAXframe  - MAXframe (W) for Level 2 Users\n");
		printf("   /L3FRack     - FRack (T1) for X.25 Networking Trunks\n");
		printf("   /L3RESptime  - RESptime (T2) for X.25 Networking Trunks\n");
		printf("   /L3CHeck     - CHeck (T3) for X.25 Networking Trunks\n");
		printf("   /L3RETry     - RETry (N2) for X.25 Networking Trunks\n");
		printf("   /L3MAXframe  - MAXframe (W) for X.25 Networking Trunks\n");
		printf("  IF TNC=TNC320 or TNC=HP or TNC=PK88 then the following are valid:\n");
		printf("        /CPU=4915200    - CPU Clock frequency in HERTZ\n");
		printf("        /TICK=1200      - Frequency of clock on SYNCB or CTSB\n");
		printf("        /0BAUD=1200     - Radio Baud Rate\n");
		printf("        /1BAUD=9600     - Terminal Baud Rate\n");
		printf("  IF TNC=TNC320 or TNC=PK88\n");
		printf("        /LEDS=4         - Initial LED bit pattern\n\n");
		printf("  IF TNC=TNC320\n");
		printf("        /MODEM=HF | VHF - Specify which modem should be used.\n");
		exit(1);
}

do_files()
{
	char *ch;
	int i;

	do {
		if (out) /* Name supplied in command line */ {
			ch = out;
		} else {
			printf("Output file for Binary Image? ");
			getlin(fname, 80);
			ch = fname;
		}
		fnamo=fopen(ch,"wb");
		if (fnamo == NULL) {
			printf("Can't write to %s\n",ch);
			if (ch == out) out = NULL;
		}
	} while (fnamo == NULL);
	strcpy(zout, ch);
	out = zout;
	printf("Output file will be: %s\n", ch);

	do {
		if (in) /* Name supplied in command line */ {
			ch = in;
		} else {
			printf("Switch Overlay File name (ROSEZSW.OVR) ? ");
			getlin(fname, 80);
			ch = fname;
		}
		fnami=fopen(ch,"rb");
		if (fnami == NULL) {
			printf("%s does not exist.\n",ch);
			if (ch == in) in = NULL;
		}
	} while (fnami == NULL);
	strcpy(zin, ch);
	in = zin;
	printf("Switch Overlay is  : %s\n", ch);

	do {
		if (machine) /* Name supplied in command line */ {
			ch = machine;
		} else {
			printf("TNC Type (TNC2 | TNC320 | HP | DR200 | PK88) ? ");
			getlin(fname, 80);
			ch = NULL;
			i = find_sym(fname, strlen(fname), tnc_names);
			if (i >= 0) {
				ch = tncs[i];
				mach = i;
				tick = tick_tab[mach];
				led = led_tab[mach];
			}
		}
		fnamm=fopen(ch,"rb");
		if (fnamm == NULL) {
			printf("%s does not exist.\n",ch);
			if (ch == machine) machine = NULL;
		}
	} while (fnamm == NULL);
	strcpy(zmach, ch);
	machine = zmach;
	printf("Machine Model used : %s\n\n", ch);

}

int
main(argc,argv)
int argc;
char *argv[];
{
	char *ch2, *ch3;
	unsigned int l, i, loc;

	interactive = FALSE;
	init();

	out = outfiles[mode];

	in = rzsw;

	if (cmd_options(argc, argv) == -1) /* Had bad options */ {
		usage(argv[0]);
	}

	machine = tncs[mach];

	if (!nodisplay) /* Print Pretty menu so we can change things */ {
		interactive = TRUE;
		cls();
		prt_pretty();
	}

	do_files();

	for (l=0;l<32768;l++) memory[l] = 255;

	maxmem = fread(&memory[0], 1, 16384, fnami);
	maxmem += fread(&memory[16384], 1, 16384, fnami);
	fclose(fnami);
	printf("The highest location used is %X\n", maxmem);

	adr_call = memory[0]+(memory[1]<<8);
	adr_digi = memory[2]+(memory[3]<<8);
	adr_addr = memory[4]+(memory[5]<<8);
	adr_l2parms = memory[6]+(memory[7]<<8);
	adr_l3parms = memory[8]+(memory[9]<<8);
	adr_setup = memory[10]+(memory[11]<<8);
	adr_complete = memory[12]+(memory[13]<<8);
	for (i=0;i<14;i++) memory[i] = 255;

	i = 0;
	while (!feof(fnamm)) {
		l=fgetc(fnamm);
		if (memory[i] != 255) printf("*** Warning: Non-blank location (%X) updated ***\n", i);
		memory[i++] = l;
	}
	fclose(fnamm);

	adr_tick = 0x3d;
	adr_tbaud = memory[0x3e]+(memory[0x3f]<<8);
	adr_rbaud = memory[0x40]+(memory[0x41]<<8);
	adr_ileds = 0x42;
	adr_sds0 = memory[0x43]+(memory[0x44]<<8);
	adr_sds1 = memory[0x45]+(memory[0x46]<<8);

	switch (mach) /* See what special stuff we may have to do... */ {
		case 0:	/* TNC-2 or Clone */
		case 2: /* DR-200 */
			break;	/* Nothing to be done... */
		case 1:	/* TNC-320 */
		case 3: /* PK-88 */
#if 0
			if (clk != -1) /* Non-Default CPU Clocking */ {
				if (term == -1) term = 9600;
				if (radio == -1) radio = 1200;
			} else if (term > 0 || radio > 0) clk = 4915200;
#endif
			if (term > 0) /* Set Terminal Baud Rate */ {
				l = (((clk/term)/32)-2);
				printf("Terminal Baud Rate = %d [%d]\n",term,l);
				memory[adr_tbaud] = l&0xff;
				if (l>255) /* Very Slow?! */ {
					l = l>>8;
					memory[adr_tbaud+2] = l&0xff;
				}
			}
			if (radio > 0) /* Set Radio Baud Rate */ {
				l = (((clk/radio)/64)-2);
				printf("Radio Baud Rate = %d [%d]\n",radio,l);
				memory[adr_rbaud] = l&0xff;
				if (l>255) /* Very Slow?! */ {
					l = l>>8;
					memory[adr_rbaud+2] = l&0xff;
				}
			}
			if (tick > 0) /* Set TICK Rate */ {
				l = tick*2/100;
				printf("Tick Rate = %d [%d]\n",tick,l);
				memory[adr_tick] = l&0xff;
			}
			if (led > 0) /* Modify LED Pattern */ {
				printf("LED Pattern %X\n", led);
				memory[adr_ileds] = led&0xff;
			}
			if (mach == 1) /* TNC-320, Select Port (HF or VHF) */ {
				loc = memory[0x47]+(memory[0x48]<<8);
				if (modem320 == 0) memory[loc] &= 0x7f;
				else memory[loc] |= 0x80;
			}
			break;
	}

	/* Now modify the Switch parameters */

	for (i=0;i<7;i++) {
		memory[adr_call+i] = call[i];
		memory[adr_digi+i] = digi[i];
		memory[adr_addr+i] = add[i];
	}
	ch2 = (char *)&l2parms;
	ch3 = (char *)&l3parms;
	for (i=0;i<12;i++) {
		memory[adr_l2parms+i] = *ch2++;
		memory[adr_l3parms+i] = *ch3++;
		if (i == 0 || i == 9) {
			ch2++;	/* MACHINE DEPENDENT BETWEEN MS C and Z80 */
			ch3++;
		}
	}

	i = strlen(setup);
	setup[i] = 0x0d;	/* Must have a CR Here */
	for (i=0;i<40;i++) {
		memory[adr_setup+i] = setup[i];
		memory[adr_complete+i] = complete[i];
	}

	i = dw_radio/10;
	memory[adr_sds0+sds_dw] = (i&0xff);
	memory[adr_sds0+sds_dw+1] = (i>>8)&0xff;

	i = dw_term/10;
	memory[adr_sds1+sds_dw] = (i&0xff);
	memory[adr_sds1+sds_dw+1] = (i>>8)&0xff;

	i = txd_radio/10;
	memory[adr_sds0+sds_txd] = (i&0xff);
	memory[adr_sds0+sds_txd+1] = (i>>8)&0xff;

	i = txd_term/10;
	memory[adr_sds1+sds_txd] = (i&0xff);
	memory[adr_sds1+sds_txd+1] = (i>>8)&0xff;

	if (full_radio) memory[adr_sds0+sds_flag] |= sds_flag_full;
	else memory[adr_sds0+sds_flag] &= ~sds_flag_full;

	if (full_term) memory[adr_sds1+sds_flag] |= sds_flag_full;
	else memory[adr_sds1+sds_flag] &= ~sds_flag_full;

	i=0;
	loc=0;
	while (loc != 32768) i = i + memory[loc++];
	printf("EPROM Checksum is %X\n", i);

	switch (mode) {
	case 0: /* Binary Image output file */
		if (fwrite(&memory[0], 1, 16384, fnamo) != 16384) {
			printf("*** Warning: Truncated output file ***\n");
		}
		if (fwrite(&memory[16384], 1, 16384, fnamo) != 16384) {
			printf("*** Warning: Truncated output file ***\n");
		}
		break;
	case 1: /* Hex output file desired */
		for (l=0; l != 32768; l=l+32) intel(l, &memory[l], fnamo);
		fputs(":00000001FF", fnamo);
		fputc(13, fnamo);
		fputc(10, fnamo);
		break;
#if 0
	case 2: /* Update .TBL File desired */
		break;
#endif
	default:
		printf("Invalid MODE Setting, no file created!\n");
		exit(5);
		break;
	}
	fclose(fnamo);
	return 0;
}
