#include <string.h>
#undef NULL
#include <conio.h>
#include <stdio.h>
#define TRUE 1
#define FALSE 0

FILE *fnami, *fnamo;
char zarr[80], zar[80], fname[80];

putxch(val, f)
FILE f;
int val;
{
	char v;

	v= (val >> 4) &0x0f;
	if (v > 9) v += 7;
	fputc(v+0x30, f);
	v=(val & 0x0f);
	if (v > 9) v += 7;
	fputc(v+0x30, f);
}

int
wrap(col, f)
int col;
FILE f;
{
	if (col > 70) {
		fputc(0x0a, f);
		return 1;
	}
	return 0;
}

preamble(cmd, obj, len)
int cmd, obj, len;
{
	fputc(0x3a,fnamo);
	putxch(cmd & 0xff, fnamo);
	putxch(obj & 0xff, fnamo);
	putxch(len & 0xff, fnamo);
	putxch((len >> 8) & 0xff, fnamo);
}

int
getlin(str,max)
char *str;
int max;
{
	int ch, pos;

	ch=pos=0;
	while (ch != 0x0a && pos<max) {
		ch=getchar();
		if (ch == -1) return -1;
		str[pos++]=ch;
		str[pos]=0;
	}
	if (ch== 0x0a) str[pos-1]=0;
	return (strlen(str));
}

int
getline(str,max)
char *str;
int max;
{
	int l;

	while ((l=getlin(str, max)) == 0) ;
	return l;
}

unsigned int
gethex(ch)
char **ch;
{
	unsigned int v;
	int i,j;
	register char *c;

	c = *ch;
	v = 0;
	while (*c == 0x20) c++;
	while (*c) {
		i = toupper(*c++);
		v = v<<4;
		if (i >=0x30 && i <= 0x39) v += (i&0x0f);
		else if (i >= 0x41 && i <= 0x46) v += (9 + (i&0x0f));
		else break;
		if (*c == 0x20) break;
	}
	while (*c == 0x20) c++;
	*ch = c;
	return v;
}

unsigned char mem[16000];
unsigned int reloc[1000];
int membase, memsiz, memmax, relmax;
int state, segtyp, segbase;
/* State	Action
    0		Reading Low byte of length
    1		Reading High byte of length
    2		Reading Segment type
    3		Reading low byte of base
    4		Reading high byte of base
    5		Skipping useless seg
    6		Loading code/data into memory
    7		processing relocation info
    8		expecting eof (END)
*/

int
main(argc,argv)
int argc;
char *argv[];
{
	int i, j, l, len, checksum, pos, c;
	unsigned int v;
	char *ch, *in, *out;

	in = out = NULL;
	if (argc == 3) {
		in = argv[1];
		out = argv[2];
	}
	do {
		if (in) /* Name supplied in command line */ {
			fnami=fopen(in,"rb");
			if (fnami == NULL) {
				printf("%s does not exist.\n",in);
				in = NULL;
			}
		} else {
			printf("Object file to read? ");
			getline(fname, 80);
			fnami=fopen(fname,"rb");
		}
	} while (fnami == NULL);

	do {
		if (out) /* Name supplied in command line */ {
			fnamo=fopen(out,"wb");
			if (fnamo == NULL) {
				printf("Can't write to %s\n",out);
				out = NULL;
			}
		} else {
			printf("Equate file to create? ");
			getline(fname, 80);
			fnamo=fopen(fname,"wb");
		}
	} while (fnamo == NULL);

	memmax=relmax=0;

	state=0;
	while (!feof(fnami)) {
		l=fgetc(fnami);
		switch (state) {
			case 0: memsiz = l;
				state++;
				len = 0;
				break;
			case 1: memsiz += (l<<8);
				state++;
				break;
			case 2: segtyp = l;
				if (segtyp == 7 || segtyp == 5) state++;
				else if (segtyp == 1) state = 4;
				else if (segtyp == 3) state = 10;
				else if (segtyp == 6) state = 15;
				else {
					printf("Unknown segment type %d\n",l);
					state++;
				}
				break;
			case 3: if (++len == memsiz) state = 0;
				break;
			case 4: membase = l;
				state++;
				len++;
				break;
			case 5: membase += (l<<8);
				if (memmax < membase+memsiz-9) memmax=membase+memsiz-9;
			case 6:
			case 7:
			case 12:
				state++;
				len++;
				break;
			case 8:
			case 13:
				if (!l) state++;
				len++;
				if (state == 14) {
					reloc[relmax++]=membase+segbase;
					if (len == memsiz) state = 0;
					else state = 10;
				}
				break;
			case 9:	mem[membase+len-9] = l;
				len++;
				if (len == memsiz) state = 0;
				break;
			case 10:
				segbase = l;
				state=11;
				len++;
				break;
			case 11: segbase += (l<<8);
				state++;
				len++;
			case 15: break;
			default: printf("illegal state %d\n",state);
		}
	}
	if (state != 15) printf("Unexpected EOF!\n");
	else {
		preamble(1,1,4);
		checksum=0;
		pos=9;

		c = memmax&0xff;
		checksum += c;
		if (wrap(pos, fnamo)) pos=0;
		pos += 2;
		putxch(c,fnamo);

		c = memmax>>8;
		checksum += c;
		if (wrap(pos, fnamo)) pos=0;
		pos += 2;
		putxch(c,fnamo);

		c = relmax&0xff;
		checksum += c;
		if (wrap(pos, fnamo)) pos=0;
		pos += 2;
		putxch(c,fnamo);

		c = relmax>>8;
		checksum += c;
		if (wrap(pos, fnamo)) pos=0;
		pos += 2;
		putxch(c,fnamo);

		putxch((-checksum) & 0xff, fnamo);
		fputc(0x0a, fnamo);

		preamble(1,2,memmax);
		checksum=0;
		pos=9;
		for (i=0;i<memmax;i++) {
			c=mem[i];
			checksum += c;
			if (wrap(pos, fnamo)) pos=0;
			pos += 2;
			putxch(c,fnamo);
		}
		putxch((-checksum) & 0xff, fnamo);
		fputc(0x0a, fnamo);

		preamble(1,3,relmax*2);
		checksum=0;
		pos=9;
		for (i=0;i<relmax;i++) {
			c=reloc[i]&0xff;
			checksum += c;
			if (wrap(pos, fnamo)) pos=0;
			pos += 2;
			putxch(c,fnamo);

			c=reloc[i]>>8;
			checksum += c;
			if (wrap(pos, fnamo)) pos=0;
			pos += 2;
			putxch(c,fnamo);
		}
		putxch((-checksum) & 0xff, fnamo);
		fputc(0x0a, fnamo);
		fputc(0x0a, fnamo);
	}

	fclose(fnami);

	/* All Done, close files */
	fclose(fnamo);
	return 0;
}
