{$I-,V-}
unit nrdjour;

interface
  uses crt, dos, graph, screen, nrdio, nrdutil;
  procedure do_journal;

implementation
  const LOWER_WINDOW:integer = 24;

  procedure do_journal;
  var ch:char;
      i:integer;
      new:integer;
      found:boolean;
      dummy:integer;
      orig_x,orig_y:integer;


    procedure clr_prompt;
    begin
      gotoxy(1,1); clreol;
    end;

    procedure do_select(s:string; var new:integer; var found:boolean);
    var dummy1,dummy2:boolean;
        i, j, code, cmd:integer;
        ch:char;
        t,t1,t2:string;
    begin
      window(1,1,80,LOWER_WINDOW);
      repeat
        clr_prompt;
        t2:='Enter log name or number ' + s + ' (Enter for none):';
        write(output,t2);
        t:='';
        editfield(length(t2) + 1,0,6,FALSE,dummy1,dummy2,t);
        t:=upcasestr(t);

        { search for duplicate }
        found:=FALSE;
        i:=0;
        while (i < MAXLOGS) and not found do
          begin
            inc(i);
            with loglist.log[i] do if t = logname then found:=TRUE;
          end;

        if not found then {see if they entered the log # instead of the name}
          begin
            t2:='';
            for i:=1 to length(t) do
              if (t[i] in ['0'..'9']) then t2:=t2 + t[i];
            val(t2, cmd, code);
            if code = 0 then
              begin
                i:=0; j:=0;
                while (j < cmd) and (i < MAXLOGS) do
                  begin
                    inc(i);
                    inc(j);
                    while (i < MAXLOGS) and (loglist.log[i].logname = '') do
                       inc(i);
                  end;
                found:=loglist.log[i].logname <> '';
              end;
          end;

        if not found and (t[1] <> ' ') and (loglist.logcount > 0) then
          begin
            clr_prompt;
            write(output,'Log not found <SPACE> to continue:');
            ch:=fetch;
            clr_prompt;
          end;
      until found or (t[1] = ' ') or (loglist.logcount = 0);
      if not found then i:=loglist.currentlog;
      new:=i;
      clr_prompt;
    end;

    procedure do_create(var found:boolean; var filenum:integer);
    var i:integer;
        s:short_str;
        dummy1,dummy2:boolean;
        ch:char;
    begin
      s:='';
      repeat
        clr_prompt;
        write('Enter new log name: ');
        editfield(22,0,6,FALSE,dummy1,dummy2,s);
        s:=upcasestr(s);

        { search for duplicate }
        found:=FALSE;
        for i:=1 to MAXLOGS do
          if s = upcasestr(loglist.log[i].logname) then found:=TRUE;
        if found then
          begin
            clr_prompt;
            write(output,s,': Duplicate log name <SPACE> to continue:');
            ch:=fetch;
            clr_prompt;
          end;
      until not found;

      { add name if not full }
      i:=0;
      while (i < MAXLOGS) and not found do
        begin
          i:=i + 1;
          if loglist.log[i].logname = '' then
            begin
              found:=TRUE;
              loglist.log[i].logname:=s;
              loglist.log[i].records:=0;
              loglist.log[i].rec:=1;
              inc(loglist.logcount);
              put_loglist(loglist);
              reccnt[i]:=0;
              filenum:=i;
            end;
        end;
        if not found then
          begin
            clr_prompt;
            write(output,'Maximum number of logs exist <SPACE> to cont:');
            ch:=fetch;
            clr_prompt;
          end;
    end;

    procedure do_import;
    const db_name1 = 'SWSKED';

    var ch:char;

      procedure import(s:string);
      var found:boolean;
          rslt,i,j:integer;
          end_found:boolean;

        procedure move_db(logcnt:integer; var rslt:integer);
        var f:file;
            ch:char;
            i:integer;
            logdat:logtype;
            
          function read_file(chars:integer):string;
          var buf:array[1..255] of char;
              s:string;
              i:integer;
          begin
            rslt:=ioresult;
            s:='';
            if rslt <> 0 then read_file:=' '
            else
              begin
                blockread(f,buf,chars);
                for i:=1 to chars do s:=s + upcase(buf[i]);
                read_file:=s;
              end;
          end;

          procedure strip_header;
          var buf:array[1..610] of char;
          begin
            { strip off first 610 characters and discard }
            blockread(f,buf,610);
            rslt:=ioresult;
          end;

          procedure get_entry(logcnt:integer);
          var logdat: logtype;
              freqs:array[1..10] of real;
              comments:array[1..10] of string[COMMENTLEN];
              i:integer;

            procedure get_location;
            var s:string;
                i:integer;
                test:boolean;

              function str_compare(s1,s2:string):boolean;
              var i:integer;
                  match:boolean;
              begin
                match:=length(s1) = length(s2);
                if match then for i:=1 to length(s1) do
                  if match then match:= s1[i] = s2[i];
                str_compare:=match;
              end;

            begin
              s:=read_file(20);
              end_found:= pos(chr(26),s) <> 0;
              while length(s) < LOCATIONLEN do s:=s + ' ';
              logdat.location:=s;
            end;

            procedure get_station_id;
            var s:string;
            begin
              s:=read_file(24);
              while length(s) < CALLSIGNLEN do s:=s + ' ';
              logdat.callsign:=s;
            end;

            procedure get_start_time;
            begin
              logdat.begin_time:=read_file(4);
            end;

            procedure get_end_time;
            begin
              logdat.end_time:=read_file(4);
            end;

            function  get_freq:real;
            var freq:real;
                i:integer;
                s:string;
            begin
              freq:=0.0;
              s:=read_file(5);
              for i:=1 to 5 do
                begin
                  if (s[i] in ['0'..'9'])
                     then freq:=freq * 10 + (ord(s[i]) - ord('0'));
                end;
              get_freq:=freq;
            end;

            procedure get_comment;
            var s:string;
                i:integer;
                ch:char;

              procedure parse_comment(var s:string);
              var num1,num2,i,j:integer;
                  ch,separator:char;
                  s1,cmd:string;
                  found:boolean;

                procedure get_num(var s:string; var num:integer);
                var i:integer;
                    found:boolean;
                begin
                  num:=0;
                  found:=FALSE;
                  while not found do
                    begin
                      num:=num * 10 + ord(s[1]) - ord('0');
                      delete(s,1,1);
                      found:=(s = '') or not (s[1] in ['0'..'9']);
                    end;
                end;

                procedure get_next_comment(var str:string);
                var i:integer;
                begin
                  i:=pos('#',s) - 1;
                  if i<=0 then i:=length(s);
                  str:=copy(s,1,i);
                  delete(s,1,i);
                end;

                procedure do_range; { case: #n-m }
                var i:integer;
                    str:string;
                begin
                  get_next_comment(str);
                  for i:=num1 to num2 do comments[i]:=comments[i] + str;
                  { handle case #m-n,o,... }
                  if cmd <> '' then while cmd[1] = ',' do
                    begin
                      delete(cmd,1,1);
                      get_num(cmd,num1);
                      comments[num1]:=comments[num1] + str;
                    end;
                end;

                procedure do_list; { case: #n,o,p...}
                var i:integer;
                    str:string;
                begin
                  get_next_comment(str);
                  comments[num1]:=comments[num1] + str;
                  comments[num2]:=comments[num2] + str;
                  if cmd <> '' then while cmd[1] = ',' do
                    begin
                      delete(cmd,1,1);
                      get_num(cmd,num1);
                      comments[num1]:=comments[num1] + str;
                    end;
                end;

                procedure do_entry; { case: #n }
                var str:string;
                begin
                  get_next_comment(str);
                  comments[num1]:=comments[num1] + str;
                end;

                procedure do_both; { case: #n&m }
                var i:integer;
                    str:string;
                begin
                  get_next_comment(str);
                  comments[num1]:=comments[num1] + str;
                  comments[num2]:=comments[num2] + str;
                  if cmd <> '' then while cmd[1] = '&' do
                    begin
                      delete(cmd,1,1);
                      get_num(cmd,num1);
                      comments[num1]:=comments[num1] + str;
                    end;
                end;

              begin { parse comment }
                { check for comment unique to entries }
                i:=pos('#',s);
                if i = 0 then i:=length(s) + 1;
                { copy message up to command to each comment }
                s1:=copy(s,1,i - 1);
                for j:=1 to 10 do comments[j]:=comments[j] + s1;

                { get comments unique to entry eg #4&5 }
                cmd:='';
                j:=i + 1;
                found:=FALSE;
                while (j < length(s)) and not found do
                  begin
                    found:=s[j] in [' ','#'];
                    if not found then
                      begin
                        cmd:=cmd + s[j];
                        inc(j);
                      end;
                  end;
                delete(s,1,j - 1);

                { decode unique comments and assign }
                {   known formats: #n, #n&m, #n,m,...,#n-m }
                get_num(cmd,num1);
                if cmd <> '' then
                  begin
                    separator:=cmd[1];
                    delete(cmd,1,1);
                    get_num(cmd,num2);
                  end;
                case separator of
                  '-': do_range;
                  '&': do_both;
                  ',': do_list;
                  else do_entry;
                end;
              end;

            begin { get_comment }
              for i:=1 to 10 do comments[i]:='';
              s:='Target:' + read_file(40);
              { parse comments for individual entries }
              while length(s) > 0 do parse_comment(s);
              for i:=1 to 10 do while length(comments[i]) < COMMENTLEN do
                 comments[i]:=comments[i] + ' ';
            end;

            procedure get_date;
            var s:string;
            begin
              s:=read_file(2); { discard decade ie 19 }
              logdat.date:=read_file(6);
            end;

            procedure skip;
            var dummy:string;
            begin
              dummy:=read_file(9);
            end;

          begin { get_entry }
            { set variables that won't change for the duration }
            with logdat do
              begin
                agc:=FAST;
                mode:=USB;
                bandwidth:=INTER;
              end;
            get_location;
            if end_found then exit;
            get_station_id;
            get_start_time;
            get_end_time;
            for i:=1 to 10 do freqs[i]:=get_freq;
            get_comment;
            get_date;
            skip;
            for i:=1 to 10 do
              begin
                if freqs[i] <> 0.0 then
                  begin
                    with loglist.log[logcnt] do
                      begin
                        inc(records);
                        dot;
                        if records < MAXREC then
                          begin
                            logdat.comment:=comments[i];
                            logdat.frequency:=freqs[i];
                            logdat.attenuator:=NO;
                            put_log(logbuf,logdat,records);
                          end;
                      end;
                  end;
              end;
          end;

        begin { move_db }
          assign(f,PATH+S+'.DBF');
          reset(f,1);
          rslt:=ioresult;
          if rslt <> 0 then
            begin
              writeln(output,
                   'Must have ',PATH+S+'.DBF in directory to import');
              hndlerr(TRUE,ch,rslt);
              exit;
            end;
          strip_header;
          home;
          write(output,'Reading / parsing database');
          end_found:=false;
          while (rslt = 0) and not end_found do get_entry(logcnt);
          close(f);
          records:=loglist.log[loglist.currentlog].records;
          for i:=1 to MAXREC do
            begin
              recdata.recptr[i]:=i;
              recdata.recstat[i]:=SHOW;
            end;
          put_recdata(loglist.currentlog,recdata);
          put_loglist(loglist);
          reccnt[loglist.currentlog]:=records;
          rslt:=0;
        end;

        procedure eliminate_dups(lognum:integer);
        { collapse entries with time overlap }
        var rec1ptr,i,j,t,rslt:integer;
            logdata1,logdata2:logtype;
        begin
          home;
          write(output,'Crunching duplicate entries');
          get_log(logbuf,logdata1,recdata.recptr[1]);
          rec1ptr:=1;
          i:=2;
          while (i < loglist.log[lognum].records) do
            begin
              if recdata.recstat[recdata.recptr[i]] = DELETED then exit;
              get_log(logbuf,logdata2,recdata.recptr[i]);
              dot;
              if (logdata2.frequency  = logdata1.frequency) and
                 (logdata2.begin_time = logdata1.end_time)  and
                 (logdata2.comment    = logdata1.comment)   and
                 (logdata2.location   = logdata1.location)  and
                 (logdata2.callsign   = logdata1.callsign) then
                begin
                  logdata1.end_time:=logdata2.end_time;
                  put_log(logbuf,logdata1,recdata.recptr[rec1ptr]);
                  t:=recdata.recptr[i];
                  recdata.recstat[t]:=DELETED;
                  for j:=i to records - 1 do with recdata do
                     recptr[j]:=recptr[j + 1];
                  recdata.recptr[records]:=t;
                  dec(reccnt[loglist.currentlog]);
                end
              else { no match }
                begin
                  logdata1:=logdata2;
                  rec1ptr:=i;
                  inc(i);
                end;
            end;
        end;

      begin { import }
        home;
        found:=FALSE;
        i:=0;
        while not found and (i < MAXLOGS) do
          begin
            inc(i);
            if s = upcasestr(loglist.log[i].logname) then found:=TRUE;
          end;
        if found then
          begin
            with loglist.log[i] do
               begin
                 logname:=s;
                 records:=0;
                 rec:=1;
               end;
          end
        else { add name if not full }
          begin
            i:=0;
            while (i < MAXLOGS) and not found do
              begin
                i:=i + 1;
                if loglist.log[i].logname = '' then
                  begin
                    found:=TRUE;
                    inc(loglist.logcount);
                    put_loglist(loglist);
                  end;
              end;
            if not found then
              begin
                clr_prompt;
                write(output,'Maximum number of logs exist <SPACE> to cont:');
                ch:=fetch;
                clr_prompt;
                exit;
              end;
            with loglist.log[i] do
               begin
                 logname:=s;
                 records:=0;
                 rec:=1;
               end;
          end;
        loglist.currentlog:=i;
        open_log(logbuf,i,rslt);
        move_db(i,rslt);
        if rslt = 0 then
          begin
            home;
            do_sort(TRUE);
            eliminate_dups(i);
            put_recdata(loglist.currentlog,recdata);
          end;
        close(logbuf);
      end;

      procedure ascii_import;
      var s:string;
          inbuf:text;
          filenum:integer;
          ok,dummy1,dummy2:boolean;
          logbuf:file;
          logdat:logtype;

        function open_in(var s:string):boolean;
        begin
          if pos('.',s) = 0 then s:=s + '.log';
          assign(inbuf,PATH + s);
          reset(inbuf);
          rslt:=ioresult;
          if rslt > 0 then
            begin
              home;
              writeln(output,'File name:',PATH + s);
              hndlerr(TRUE,ch,rslt);
            end;
          open_in:=rslt = 0;
        end;

        procedure do_import;
        var s:string;

          procedure parse(s:string; var logdat:logtype);
          var s1:string;
              dummy:integer;

            procedure grab(var s:string; var field:string; len:integer);
            var l:integer;
            begin
              l:=length(s);
              if l >= len then { normal case; string is not truncated }
                begin
                  field:=copy(s,1,len);
                  delete(s,1,len + 1);
                end
              else { handle truncated string }
                begin
                  field:=s;
                  s:='';
                  while length(field) < len do field:=field + ' ';
                end;
            end;

          begin { parse }
            with logdat do
              begin
                grab(s,date,DATELEN);
                grab(s,begin_time,TIMELEN);
                grab(s,end_time,TIMELEN);
                grab(s,s1,8);
                val(s1,frequency,dummy);
                grab(s,callsign,CALLSIGNLEN);
                grab(s,location,LOCATIONLEN);
                grab(s,comment,COMMENTLEN);
                grab(s,s1,1);
                case s1[1] of
                   'R':mode:=RTTY;
                   'C':mode:=CW;
                   'U':mode:=USB;
                   'L':mode:=LSB;
                   'A':mode:=AM;
                   'F':mode:=FM;
                   'X':mode:=FAX;
                   'u':mode:=ECSS_USB;
                   'l':mode:=ECSS_LSB;
                  else mode:=USB;
                end;
                grab(s,s1,1);
                case s1[1] of
                   'I':bandwidth:=INTER;
                   'W':bandwidth:=WIDE;
                   'A':bandwidth:=AUX;
                  else bandwidth:=INTER;
                end;
                grab(s,s1,1);
                case s1[1] of
                   'F':agc:=FAST;
                   'S':agc:=SLOW;
                  else agc:=FAST;
                end;
                grab(s,s1,1);
                case s1[1] of
                   'Y':attenuator:=YES;
                   'N':attenuator:=NO;
                  else attenuator:=NO;
                end;
              end;
          end;

          procedure writeout(logdat:logtype);
          begin
            inc(loglist.log[filenum].records);
            dot;
            if loglist.log[filenum].records < MAXREC
               then put_log(logbuf,logdat,loglist.log[filenum].records);
          end;

        begin { do_import }
          while not eof(inbuf) do
            begin
              readln(inbuf,s);
              parse(s,logdat);
              writeout(logdat);
            end;
          close(inbuf);
          reccnt[filenum]:=loglist.log[filenum].records;
          last_log:=loglist.currentlog;
          last_log:=filenum;
          put_loglist(loglist);
          close(logbuf);
        end;

        procedure init_log(filenum:integer; var rslt:integer);
        var i:integer;

            recdata:recdatatype;
        begin
          for i:=1 to MAXREC do
            begin
              recdata.recptr[i]:=i;
              recdata.recstat[i]:=SHOW;
            end;
          put_recdata(filenum,recdata);
        end;

      begin
        clr_prompt;
        write('Enter filename for Import file: ');
        s:='';
        editfield(33,0,12,FALSE,dummy1,dummy2,s);
        writea(LIGHTGRAY,FOREGROUND);
        writea(BLACK, BACKGROUND);
        s:=upcasestr(s);
        if s[1] = ' ' then exit;
        ok:=open_in(s);
        if not ok then
          begin
            home;
            exit;
          end;
        do_create(found,filenum);
        open_log(logbuf,filenum,rslt);
        if rslt <> 0 then exit;
        init_log(filenum,rslt);
        if rslt <> 0 then exit;
        writea(BLACK,BACKGROUND);
        writea(LIGHTGRAY,FOREGROUND);
        if loglist.currentlog = 0 then { leave instruction on screen }
          begin
            gotoxy(1,2);
            call_crt(ERASEOL);
          end
        else home;
        write(output,'Reading.');
        do_import;
      end;

    begin
      repeat
        write_prompt('Import: A(scii, S(wsked.dbf, Q(uit');
        ch:=upcase(fetch);
        window(1,1,80,LOWER_WINDOW);
        case ch of
          'A': ascii_import;
          'S': import(db_name1);
        end;
      until (ch in ['A','S','Q']);
    end;

    procedure do_export;
    var i:integer;
        dummy,dummy1,dummy2:boolean;
        logdata:logtype;
        outbuf:text;
        s:string;
        rslt:integer;

      procedure open_out(s:string; var rslt:integer);
      var ch:char;
      begin
        if pos('.',s) = 0 then s:=s + '.log';
        assign(outbuf,PATH + s);
        rewrite(outbuf);
        rslt:=ioresult;
        hndlerr(TRUE,ch,rslt);
      end;

      procedure write_record(logdata:logtype);
      var s:string;

        procedure format_and_send(s:string; len:integer);
        begin
          while length(s) < len do s:=s + ' ';
          write(outbuf,s,' ');
        end;

      begin
        with logdata do
          begin
            format_and_send(date,DATELEN);
            format_and_send(begin_time,TIMELEN);
            format_and_send(end_time,TIMELEN);
            str(frequency:8:2,s);
            format_and_send(s,8);
            format_and_send(callsign,CALLSIGNLEN);
            format_and_send(location,LOCATIONLEN);
            format_and_send(comment,COMMENTLEN);
            case mode of
              RTTY:     s:='R';
              CW:       s:='C';
              USB:      s:='U';
              LSB:      s:='L';
              AM:       s:='A';
              FM:       s:='F';
              FAX:      s:='X';
              ECSS_USB: s:='u';
              ECSS_LSB: s:='l';
            end;
            format_and_send(s,1);
            case bandwidth of
              NARR:  s:='N';
              INTER: s:='I';
              WIDE:  s:='W';
              AUX:   s:='A';
            end;
            format_and_send(s,1);
            case agc of
              FAST:  s:='F';
              SLOW:  s:='S';
            end;
            format_and_send(s,1);
            case attenuator of
              YES:   s:='Y';
              NO:    s:='N';
            end;
            writeln(outbuf,s);
          end;
      end;

    begin
      i:=0;
      writea(BLACK,BACKGROUND);
      writea(LIGHTGRAY,FOREGROUND);
      home;
      write(output,'Enter filename for Export file:');
      s:='';
      editfield(33,0,12,FALSE,dummy1,dummy2,s);
      writea(BLACK,BACKGROUND);
      writea(LIGHTGRAY,FOREGROUND);
      s:=upcasestr(s);
      if s[1] = ' ' then exit;
      open_log(logbuf,loglist.currentlog,rslt);
      if rslt <> 0 then exit;
      open_out(s,rslt);
      if rslt <> 0 then exit;
      home;
      while (i < records) do
        begin
          dot;
          dummy:=precess(i,1);
          get_log(logbuf,logdata,recdata.recptr[i]);
          write_record(logdata);
        end;
      close(logbuf);
      close(outbuf);
      home;
    end;

    procedure do_delete;
    var i:integer;
        s1:short_str;
        dummy1,dummy2,found:boolean;
        ch:char;
        f:file;
    begin
      do_select('to DELETE',i,found);
      if found then
        begin
          clr_prompt;
          write(output,'DELETE ',upcasestr(loglist.log[i].logname),'?');
          ch:=upcase(fetch);
          clr_prompt;
          if ch = 'Y' then
            begin
              loglist.log[i].logname:='';
              loglist.log[i].records:=0;
              loglist.log[i].rec:=0;
              loglist.logcount:=loglist.logcount - 1;
              if loglist.currentlog = i then loglist.currentlog:=0;
              if last_log = i then last_log:=0;
              put_loglist(loglist);
              str(i,s1);
              if length(s1) = 1 then s1:='0' + s1;
              s1:=s1 + '.DAT';
              assign(f,PATH + RECDATAFILE + s1);
              reset(f);
              rslt:=ioresult;
              if rslt = 0 then
                begin
                  close(f);
                  erase(f);
                end;
              assign(f,PATH + LOGFILE + s1);
              reset(f);
              rslt:=ioresult;
              if rslt = 0 then
                begin
                   close(f);
                   erase(f);
                end;
              reccnt[i]:=0;
            end;
        end;
    end;

    procedure display_logs;
    var x,y,i,j,k,deletions:integer;
        t:string;
        recdata:recdatatype;
    begin
      gotoxy(1,3);
      j:=0; y:=2; x:=1;
      for i:=1 to MAXLOGS do
        begin
          t:=loglist.log[i].logname;
          if t <> '' then { display it }
            begin
              inc(j);
              if (j in [22, 43, 64]) then
                begin
                  x:=20 * (j div 20);
                  y:=2;
                end;
              inc(y);
              gotoxy(x,y);
              deletions:=0;
              write(output,j:3,'  ',t,' ',reccnt[i]);
            end;
        end;
    end;

    procedure move_record(marked, move:boolean; dest, from:byte);
    var x_pos,y_pos:integer;
      t,recnum:integer;
      ch:char;
      i,j:integer;
      dummy:boolean;
      logdata:logtype;
      to_recdata,from_recdata:recdatatype;
      found:boolean;
      from_buf,to_buf:file;

      function get_logentry(i:integer;var logdata:logtype):boolean;
      var found:boolean;
          j,k,l:integer;
      begin
        found:=TRUE;
        j:=from_recdata.recptr[i];
        if marked then found:=mark_array[j];
        found:=found and (from_recdata.recstat[j] = SHOW);
        if found then
          begin
            get_log(from_buf,logdata,j);
            if move then { delete old entry }
              begin
                from_recdata.recstat[j]:=DELETED;
                dec(reccnt[from]);
              end;
          end;
        get_logentry:=found;
      end;

      procedure put_logentry(var i:integer; logdata:logtype);
      var j:integer;
      begin
        while (i < loglist.log[dest].records)
          and (to_recdata.recstat[to_recdata.recptr[i]] <> DELETED)
                  do inc(i);
        if (i >= loglist.log[dest].records)
           and (to_recdata.recstat[to_recdata.recptr[i]] <> DELETED) then
        { insert new entry here }
          begin
            inc(loglist.log[dest].records);
            i:=loglist.log[dest].records;
            to_recdata.recptr[i]:=i;
            if recnum = 0 then recnum:=1;
          end;
        t:=to_recdata.recptr[i];
        for j:=i downto recnum + 1 do with to_recdata do
          recptr[j]:=recptr[j - 1];
        to_recdata.recptr[recnum]:=t;
        to_recdata.recstat[t]:=SHOW;
        put_log(to_buf,logdata,to_recdata.recptr[recnum]);
        inc(recnum);
        inc(reccnt[dest]);
      end;

      procedure push_delete;
      { push deleted records to the end of the chain }
      var i,j,k,cnt,last:integer;
      begin
        last:=loglist.log[from].records;
        i:=1; cnt:=1;
        while (cnt < last) do
        { move deletions to the top of the stack; "cnt" limits iterations }
          begin
            j:=from_recdata.recptr[i];
            if from_recdata.recstat[j] = DELETED then
              begin
                for k:=i to last - 1 do
                  from_recdata.recptr[k]:=from_recdata.recptr[k + 1];
                from_recdata.recptr[last]:=j;
              end
            else inc(i);
            inc(cnt);
          end;
      end;

    begin {move_record }
      recnum:=loglist.log[dest].rec;
      get_recdata(from,from_recdata);
      get_recdata(dest,to_recdata);
      open_log(from_buf,from,rslt); if rslt > 0 then exit;
      open_log(to_buf,dest,rslt);   if rslt > 0 then exit;
      j:=1;
      for i:=1 to loglist.log[from].records do
        begin
          found:=get_logentry(i,logdata);
          if found then put_logentry(j,logdata);
        end;
      if move then push_delete;
      close(to_buf);
      close(from_buf);
      put_recdata(dest,to_recdata);
      put_recdata(from,from_recdata);
      put_loglist(loglist);
    end;

    procedure do_the_write;
    var dest:integer;
        found:boolean;
    begin
      do_select('to write to',dest, found);
      if found then move_record(TRUE,FALSE,dest,loglist.currentlog);
    end;

    procedure do_move;
    var dest:integer;
        found:boolean;
    begin
      do_select('to move to',dest, found);
      if found then
        begin
          move_record(TRUE,TRUE,dest,loglist.currentlog);
          do_unmark_all(FALSE);
        end;
    end;

    procedure do_print;

    const LINESPERPAGE = 60;

    var pbuf:text;
        i,cnt:integer;
        dummy:boolean;
        logdata:logtype;
        s:short_str;
        s1:string;
        logbuf:file;
        rslt:integer;
        all:boolean;
        ch:char;

      procedure printhdr;
      begin
        write(pbuf,'Num   Date  Strt End  Freq     '+
                          'Station ID          Location');
        writeln(pbuf,'Comment':25,'MB':35);
        cnt:=1;
      end;

    begin
      if loglist.currentlog = 0 then exit;
      repeat
        write_prompt
             ('A(ll lines to print, M(arked lines only to print, Q(uit');
        ch:=upcase(fetch);
      until ch in ['A','M','Q'];
      window(1,1,80,LOWER_WINDOW);
      if ch = 'Q' then exit;
      all:=ch = 'A';

      assign(pbuf,'LPT1');
      rewrite(pbuf);
      write(pbuf,print_code); { compressed mode }
      printhdr;
      i:=0;
      open_log(logbuf,loglist.currentlog,rslt);
      while (i < records) do
        begin
          dummy:=precess(i,1);
          get_log(logbuf,logdata,recdata.recptr[i]);
          if all or mark_array[recdata.recptr[i]] then
            begin
              inc(cnt);
              if cnt > LINESPERPAGE then
                begin
                  write(pbuf,chr(12)); { form feed }
                  printhdr;
                end;
              with logdata do
                begin
                  write(pbuf,i:4,date:DATELEN + 1,begin_time:TIMELEN + 1);
                  write(pbuf,end_time:TIMELEN + 1);
                  write(pbuf,frequency:9:2,callsign:CALLSIGNLEN + 1);
                  s1:=copy(location,1,25);
                  while length(s1) < 25 do s1:=s1 + ' ';
                  write(pbuf,s1:26);
                  s1:=copy(comment,1,39);
                  while length(s1) < 39 do s1:=s1 + ' ';
                  write(pbuf,s1:40);
                  case mode of
                    RTTY:     s:='R';
                    CW:       s:='C';
                    USB:      s:='U';
                    LSB:      s:='L';
                    AM:       s:='A';
                    FM:       s:='F';
                    FAX:      s:='X';
                    ECSS_USB: s:='u';
                    ECSS_LSB: s:='l';
                  end;
                  write(pbuf,s:2);
                  case bandwidth of
                    NARR:  s:='N';
                    INTER: s:='I';
                    WIDE:  s:='W';
                    AUX:   s:='A';
                  end;
                  writeln(pbuf,s:1);
                end;
            end;
        end;
      close(pbuf);
      close(logbuf);
    end;

  begin
    save_cursor_pos;
    orig_x:=x_pos; orig_y:=y_pos;
    information_mode_off;

    { special case: leave room for directions if they have no logs }
    if loglist.currentlog = 0 then LOWER_WINDOW:=10 else LOWER_WINDOW:=24;

    sync_loglist;
    if loglist.logcount > 0 then close(logbuf);
    repeat
      window(1,1,80,LOWER_WINDOW);
      writea(BLACK,BACKGROUND);
      home;
      write_prompt('Journal: '+
   'S(elect, C(reate, D(el, E(xport, I(mport, W(rite, M(ove, P(rint, Q(uit');
      window(1,1,80,LOWER_WINDOW);
      display_logs;
      gotoxy(80,1);
      repeat
        { check for timer tick }
        time_date_stamp(mon_str,day_str,year_str,time_str,FALSE);
        if time_str <> old_time_str then
          begin
            update_time_status;
            old_time_str:=time_str;
            window(1,1,80,LOWER_WINDOW);
            gotoxy(80,1);
          end;
      until keypressed;
      ch:=upcase(fetch);
      case ch of
        'S','Q':begin
                  do_select('to switch to', new, found);
                  last_log:=new;
                  if loglist.currentlog = last_log then last_log:=0;
                  put_loglist(loglist);
                  x_pos:=orig_x; y_pos:=orig_y; {fix timer clobbering cursor}
                  init_crt;
                  cmd_prompt(prompt_num);
                  bottom_window;
                  gotoxy(x_pos,y_pos);
                  do_alternate;
                  information_mode_on;
                  exit;
                end;
        'C': do_create(found,dummy);
        'D': do_delete;
        'W': do_the_write;
        'M': do_move;
        'P': do_print;
        'I': do_import;
        'E': do_export;
      end;
    until (ch = 'Q');
  end;

begin
end.