{$I-,V-}
unit nrdscan;

interface
  uses crt, dos, graph, screen, async, nrdio, nrdutil;

  procedure do_inc;
  procedure do_dec;

implementation

  procedure display_for_inc(frequency:real);
  { find displayed line matching freq - used with inc routines }
  var found,lt:boolean;
      j:integer;
  begin
    j:=0; found:=FALSE; lt:=FALSE;
    while (j < LINES - REC_WIN_Y_BOTTOM - 1) and not found do
      begin
        inc(j);
        if frequency > displayed_freq[j] then lt:=TRUE; {condition for fnd}
        found:=frequency <= displayed_freq[j];
      end;
    if found and lt then { found it and its on the screen }
      begin
        y_pos:=j;
        gotoxy(x_pos,y_pos);
        show_log(rec,FALSE,TRUE);
      end
    else { new screen }
      begin
        rec:=find_rec(rec, frequency);
        y_pos:=1;
        gotoxy(x_pos,y_pos);
        show_log(rec,TRUE,TRUE);
      end;
  end;

  procedure display_for_dec(frequency:real);
  { find displayed line matching freq - used with dec routines }
  var found,lt:boolean;
      j:integer;
  begin
    j:=LINES - REC_WIN_Y_BOTTOM; found:=FALSE; lt:=FALSE;
    while (j > 1) and not found do
      begin
        dec(j);
        if frequency < displayed_freq[j] then lt:=TRUE;{condition for fnd}
        found:=frequency >= displayed_freq[j];
      end;
    if found and lt then { found it and its on the screen }
      begin
        y_pos:=j;
        gotoxy(x_pos,y_pos);
        show_log(rec,FALSE,TRUE);
      end
    else { new screen }
      begin
        rec:=find_rec(rec, frequency);
        rec:=rec - LINES + REC_WIN_Y_BOTTOM + 2;
        if rec < 1 then rec:=1;
        y_pos:=1;
        gotoxy(x_pos,y_pos);
        show_log(rec,TRUE,TRUE);
        show_log(rec,FALSE,FALSE);
        y_pos:=0; found:=FALSE;
        while not found and (y_pos < LINES - REC_WIN_Y_BOTTOM - 1) do
          begin
            inc(y_pos);
            found:=displayed_freq[y_pos] >=frequency;
          end;
        gotoxy(x_pos,y_pos);
        show_log(rec,FALSE,TRUE);
      end;
  end;

  procedure do_sample(var ave:integer);
  const SAMPLES = 10;
  var k:integer;
  begin
    ave:=0;
    for k:=1 to SAMPLES do ave:=ave + get_s_reading;
    ave:=round(ave / SAMPLES);
  end;

  procedure do_s_meter(s_val:integer);
  var reading:real;
  begin
    save_cursor_pos;
    if radio_type <> 535 then exit;
    reading:=convert_s_to_db(s_val);
    top_window;
    gotoxy(42,3);
    writea(LIGHTGRAY,FOREGROUND);
    write(output,'S-Meter:');
    if (reading > 9.0)
      then writea(RED,FOREGROUND)
      else writea(CYAN,FOREGROUND);
    if reading >= 10.0
      then write(output,reading:2:0,' ')
      else write(output,reading:2:1);
    bottom_window;
  end;

  procedure check_signal(squelch_mode:boolean; var squelch:boolean;
                          var ave:integer);
  begin
    if squelch_mode
      then { special case; set at 0dB; use s meter }
        begin
          squelch:=squelch_check;
        end
      else
        begin
          do_sample(ave);
          if tick then do_s_meter(ave);
        end;
  end;


  procedure bump_freq_next_marked(scan:boolean; increment:boolean);
  var i,j,ave:integer;
      logdata:logtype;
      fail:boolean;
      squelch:boolean;
      squelch_mode:boolean;

    procedure find_next_marked(var i:integer; var fail:boolean;
                                   increment:boolean);
    var loops:integer;
    begin
      loops:=0;
      fail:=FALSE;
      if increment then
        begin
          repeat
            inc(i);
            if i > records then
              begin
                i:=1;
                inc(loops);
              end;
            if mark_array[recdata.recptr[i]] then exit;{fnd nxt marked ent}
          until loops >=2; { exit if no marked values found }
        end
      else { decrement }
        begin
          repeat
            dec(i);
            if i < 1 then
              begin
                i:=records;
                inc(loops);
              end;
            if mark_array[recdata.recptr[i]] then exit;{fnd nxt marked value}
          until loops >=2; { exit if no marked values found }
        end;
      fail:=TRUE;
    end;

  begin
    squelch_mode:=scan_threshold >= 250; { special case; use squelch }
    with receiverstat do
      begin
        remote_on;
        y_pos:=1;
        gotoxy(x_pos,y_pos);
        repeat
          if scan then
            begin
              write_prompt('Scanning: Hit any key to cancel');
              bottom_window;
            end;
          repeat
            find_next_marked(rec,fail,increment);
            if fail then { no marked entries dummy }
              begin
                remote_off(0);
                toggle_remote;
                show_receiver;
                cmd_prompt(prompt_num);
                bottom_window;
                show_log(rec,TRUE,TRUE); { restore line highlight }
                exit;
              end;
            get_log(logbuf,logdata,recdata.recptr[rec]);
            with logdata do
              set_all(199,attenuator,bandwidth,mode,frequency,agc);
            receiverstat.attenuator:=logdata.attenuator;
            receiverstat.bandwidth :=logdata.bandwidth;
            receiverstat.mode      :=logdata.mode;
            receiverstat.frequency :=logdata.frequency;
            receiverstat.agc       :=logdata.agc;
            show_receiver;
            show_log(rec,TRUE,TRUE);
            check_signal(squelch_mode,squelch,ave);
          until (squelch_mode and squelch) or ((not squelch_mode) and
                     (ave <= scan_threshold)) or keypressed;
          if scan and not keypressed then
            begin
              write_prompt('Signal acquired: Hit any key to exit');
              show_receiver;
              bottom_window;
              repeat { wait until signal below threshold or keypressed }
                check_signal(squelch_mode,squelch,ave);
              until keypressed or (squelch_mode and not squelch)
                  or (not squelch_mode and (ave > scan_threshold));
            end;
          if scan and keypressed then { check for + or - }
            begin
              ch:=fetch;
              if ch = '+' then increment:=TRUE
              else if ch = '-' then increment:=FALSE
              else scan:=FALSE; { force exit condition }
            end;
        until not scan or keypressed;
        while keypressed do ch:=fetch; { discard }
        cmd_prompt(prompt_num);
        if not enable_s_meter then clear_meter;
        bottom_window;
        remote_off(0);
        toggle_remote;
      end;
  end;

  procedure inc_freq;
  var s:string;
      orig_freq:real;

  begin {inc_freq}
    gotoxy(x_pos,y_pos);
    show_log(rec,FALSE,FALSE); { unhighlight current cursor line }
    with receiverstat do
      begin
        remote_on;
        orig_freq:=frequency;
        if loglist.inc_amount = 5.0 then
          begin
            frequency:=trunc(frequency/10.0) * 10.0;
            if orig_freq - frequency >= 5.0 then frequency:=frequency + 5.0;
            case mode of
              USB: set_freq(frequency + 4.0);
              LSB: set_freq(frequency + 6.0);
              AM:
              else
                begin
                  for i:=1 to 4 do
                    begin
                      set_freq(frequency + i);
                      delay(150);
                    end;
                end;
            end;
            delay(200);
          end;
        frequency:=frequency + loglist.inc_amount;
        if map then frequency:=frequency + MAP_OFFSET;
        set_freq(frequency);
        remote_off(0);
        toggle_remote;
        if (radio_type = 535) and not enable_s_meter then show_receiver;
        display_for_inc(frequency);
      end;
  end;

  procedure inc_freq_next; { find next frequency > threshold }
  var s:string;
      reading,i,ave:integer;
      orig_freq:real;
      old_stat:receivertype;
      ch:char;
      dummy:boolean;
      squelch_mode,squelch:boolean;

  begin {inc_freq_next}
    show_log(rec,FALSE,FALSE); { unhighlight current cursor line }
    old_stat:=receiverstat;
    squelch_mode:=scan_threshold >= 250; { special case; use squelch }
    with receiverstat do
      begin
        remote_on;
        attenuator:=NO;
        bandwidth:=NARR;
        mode:=CW;
        agc:=FAST;
        orig_freq:=frequency;
        if loglist.inc_amount = 5.0 then
          begin
            frequency:=trunc(frequency/10.0) * 10.0;
            if orig_freq - frequency >= 5.0 then frequency:=frequency + 5.0;
          end;
        repeat
          frequency:=frequency + loglist.inc_amount;
          set_all(199,attenuator,bandwidth,mode,frequency,agc);
          show_receiver;
          delay(150);
          check_signal(squelch_mode,squelch,ave);
        until (squelch_mode and squelch) or
              (not squelch_mode and (ave <= scan_threshold)) or keypressed;
        old_stat.frequency:=receiverstat.frequency;
        receiverstat:=old_stat;
        with receiverstat do
          set_all(199,attenuator, bandwidth, mode, frequency, agc);
        if keypressed then ch:=fetch; { discard }
        remote_off(0);
        toggle_remote;
        if not enable_s_meter then clear_meter;
        show_receiver;
        display_for_inc(frequency);
      end;
  end;

  procedure do_inc;
  begin
     save_cursor_pos;
     window(1,25,80,25);
     inc_class_status(TRUE);
     bottom_window;
     case inc_class of
      FIXED_OFFSET:inc_freq;
      NEXT_FREQ:   inc_freq_next;
      NEXT_MARKED: bump_freq_next_marked(FALSE,TRUE);
      SCAN_MARKED: bump_freq_next_marked(TRUE,TRUE);
    end;
    window(1,25,80,25);
    inc_class_status(FALSE);
    bottom_window;
  end;

  procedure dec_freq;
  var s:string;
      i:integer;
      orig_freq:real;

  begin {dec_freq}
    gotoxy(x_pos,y_pos);
    show_log(rec,FALSE,FALSE); { unhighlight current cursor line }
    with receiverstat do
      begin
        remote_on;
        orig_freq:=frequency;
        if loglist.inc_amount = 5.0 then
          begin
            frequency:=trunc(frequency/10.0) * 10.0;
            if orig_freq - frequency > 5.0 then frequency:=frequency + 10.0
            else if orig_freq-frequency > 0.0 then frequency:=frequency+5.0;
            case mode of
              USB: set_freq(frequency - 6.0);
              LSB: set_freq(frequency - 4.0);
              AM:
              else
                begin
                  for i:=1 to 4 do
                    begin
                      set_freq(frequency - i);
                      delay(150);
                    end;
                end;
            end;
            delay(200);
          end;
        frequency:=frequency - loglist.inc_amount;
        if map then frequency:= frequency + MAP_OFFSET;
        set_freq(frequency);
        remote_off(0);
        toggle_remote;
        if (radio_type = 535) and not enable_s_meter then show_receiver;
        display_for_dec(receiverstat.frequency);
      end;
  end;

  procedure dec_freq_next; { find next frequency > threshold }
  const SAMPLES = 15;
  var s:string;
      reading,ave,i,k:integer;
      orig_freq:real;
      old_stat:receivertype;
      ch:char;
      dummy:boolean;

  begin {dec_freq_next}
    show_log(rec,FALSE,FALSE); { unhighlight current cursor line }
    old_stat:=receiverstat;
    with receiverstat do
      begin
        remote_on;
        attenuator:=NO;
        bandwidth:=NARR;
        mode:=CW;
        agc:=FAST;
        orig_freq:=frequency;
        if loglist.inc_amount = 5.0 then
          begin
            frequency:=trunc(frequency/10.0) * 10.0;
            if orig_freq - frequency > 5.0 then frequency:=frequency + 10.0
            else if orig_freq-frequency > 0.0 then frequency:=frequency+5.0;
          end;
        repeat
          frequency:=frequency - loglist.inc_amount;
          set_all(199,attenuator,bandwidth,mode,frequency,agc);
          show_receiver;
          delay(150);
          do_sample(ave);
          if tick then do_s_meter(ave);
        until (ave <= scan_threshold) or keypressed;
        old_stat.frequency:=receiverstat.frequency;
        receiverstat:=old_stat;
        with receiverstat do
          set_all(199,attenuator, bandwidth, mode, frequency, agc);
        if keypressed then ch:=fetch; { discard }
        remote_off(0);
        toggle_remote;
        if not enable_s_meter then clear_meter;
        show_receiver;
        display_for_dec(frequency);
      end;
  end;

  procedure do_dec;
  begin
    save_cursor_pos;
    window(1,25,80,25);
    inc_class_status(TRUE);
    bottom_window;
    case inc_class of
      FIXED_OFFSET:dec_freq;
      NEXT_FREQ:   dec_freq_next;
      NEXT_MARKED: bump_freq_next_marked(FALSE,FALSE);
      SCAN_MARKED: bump_freq_next_marked(TRUE,FALSE);
    end;
    window(1,25,80,25);
    inc_class_status(FALSE);
    bottom_window;
  end;

begin
end.