'ARRL Sweepstakes Contest Loggin' Machine
'
'Copyright (C) 1989 by Arthur L. Burke, Jr. - NE4F
'
'--------------------------------------------------------------------------
'
'  PROGRAM NAME:     SWEEP.BAS
'  LANGUAGE:         QuickBASIC 4.0
'  COMPILER:         Microsoft QuickBASIC 4.0 command line
'                    compiler, BC.EXE
'  LIBRARIES:        Microsoft QuickBASIC 4.0 and
'                    ProBAS 4.1 from Hammerly Computer Services, Inc. (HCSI)
'
'--------------------------------------------------------------------------
'
'******************************************************
'*                     INITIALIZE                     *
'******************************************************
'
DEFINT A-Z
REM $DYNAMIC
'----------------------------------------------------------------------------
'
'  All fields within the following RecordType were left as strings
'  so the file could be view/edited with standard ASCII techniques.
'  The binary tree file will not normally be viewed/printed, so, where
'  appropriate, the fields are integers instead of strings.
'
'----------------------------------------------------------------------------
TYPE RecordType
   Band AS STRING * 3                                             'meter band - 10,15,20,40,80,160
   Date AS STRING * 8
   TimeOnOff AS STRING * 4
   Time AS STRING * 4
   SentNum AS STRING * 5
   RCVDNum AS STRING * 4
   Precedence AS STRING * 1                                       'A = low power  B = high power  Q = QRP
   RCVDCall AS STRING * 11
   Check AS STRING * 2                                            'year in which the op was first licensed
   Section AS STRING * 3                                          'ARRL Section
   CarReturn AS STRING * 1                                        'carriage return
   LineFeed AS STRING * 1
END TYPE

TYPE TreeType
   LeftPointer AS INTEGER
   RightPointer AS INTEGER
   CallSign AS STRING * 11
END TYPE

COMMON SHARED SPREC$, ID$, CK$, SEC$, MO$, CONTEST$, Dupe$, EntryFlag, WriteFlag
COMMON SHARED NumberOfSections, CallAreas(), Sections$(), SectionCounter()
COMMON SHARED SectionsWorked, SCREEN1(), FileFlag, Handle, Handle1, Handle2, Handle3

DECLARE FUNCTION ISTR$ (BYVAL I)                                  'replacement function for STR$

DECLARE SUB AlphaForm (QSOCounter, SSTree AS TreeType, File$)
DECLARE SUB AnyKey ()
DECLARE SUB CleanLine (Row, Col)
DECLARE SUB Cleanup (F(), Fields$(), TempFields$)
DECLARE SUB DataEntry (BA$, SS AS RecordType, QSOCounter, FileName$, FileName1$, FileName2$, File$, FileFlag, SSTree AS TreeType, Fields$())
DECLARE SUB DeadWindow ()
DECLARE SUB DoWindow (Ecode, FIL$, ULR, ULC, LRR, LRC, FORE, BACK, LABEL, LABEL$)
DECLARE SUB EntryInput (F())
DECLARE SUB EntryScreen (MenuLoc, BA$, SS AS RecordType, QSOCounter, SSTree AS TreeType, Clock, Fields$())
DECLARE SUB ErrWindow (LABEL$, ST1$)
DECLARE SUB FileError (FIL$, Ecode)
DECLARE SUB FileFound (FIL$)
DECLARE SUB Filter (Row, Col, IN$, CL, BA$, Clock, Fields$())
DECLARE SUB Klaxon ()
DECLARE SUB LoadTree (BA$, SS AS RecordType, QSOCounter, C$, SSTree AS TreeType, PR$, NUM$, CH$, SE$)
DECLARE SUB LocateIt (Row, Column)
DECLARE SUB RptForm (SS AS RecordType, QSOCounter)
DECLARE SUB ScreenRestore ()
DECLARE SUB ScreenSave ()
DECLARE SUB SetBand (BA$, Clock, Fields$())

KEY 16, CHR$(12) + CHR$(83)                                       'trap CTRL-ALT-DEL
ON KEY(16) GOSUB NONO
KEY(16) ON

READ NumberOfSections                                             'currently 77 sections
DIM CallAreas(10)                                                 '10 call areas + Canada
REDIM Sections$(NumberOfSections)                                 'physical data
REDIM SectionCounter(NumberOfSections)                            '"0" means not yet worked
Size = 2000                                                       '"1" used to show a qso
REDIM SCREEN1(Size)                                               'used to save and restore screen when "windowing"

FOR J = 0 TO 10
   READ CallAreas(J)                                              'how many sections in each area?
NEXT J

FOR N = 1 TO NumberOfSections
   READ Sections$(N)                                              'read sections into array
   SectionCounter(N) = 0                                          'initialize the tracking data
NEXT N

DIM SS AS RecordType
DIM SSTree AS TreeType
DIM Fields$(5)                                                    'this array is used in the EntryScreen
                                                                  ' to keep track of the individual entries
CLS                                                               ' to determine if all fields have entries

MenuLoc = 1                                                       'Where am I on the menu?
QSOCounter = 0
WriteFlag = 0                                                     'tell me if the user added new data
BA$ = ""                                                          'Band Selection
File$ = ""                                                        'vdisk file name
FileName$ = ""                                                    'name for main data
FileName1$ = ""                                                   'name for binary tree data
FileName2$ = ""                                                   'name for "configuration" data
FileFlag = 0                                                      'Used to identify errors and empty file status
Clock = 0                                                         'Display the time?
EntryFlag = 0                                                     'Accept or reject fields?
SectionsWorked = 0                                                'Number of sections worked
'************************************************
'*           SECTION LIST                       *
'************************************************
'
'the first entry in the first data line below
' identifies the total number of sections
'
'the numbers following show how many sections are in each call
' area beginning with call area zero and ending with the VEs
'
DATA 77,8,7,5,4,11,8,10,10,3,3,8
DATA "CO ","IA ","KS ","MN ","MO ","NE ","ND ","SD "
DATA "CT ","EMA","ME ","NH ","RI ","VT ","WMA"                          : REM 1's
DATA "ENY","NLI","NNJ","SNJ","WNY"                                      : REM 2's
DATA "EPA","DE ","MDC","WPA"                                            : REM 3's
DATA "AL ","GA ","KY ","NC ","NFL","PR ","SC ","SFL","TN ","VA ","VI "  : REM 4's
DATA "AR ","LA ","MS ","NM ","NTX","OK ","STX","WTX"                    : REM 5's
DATA "EB ","LAX","ORG","SB ","SCV","SDG","SF ","SJV","SV ","PAC"        : REM 6's
DATA "AK ","AZ ","EWA","ID ","MT ","NV ","OR ","UT ","WWA","WY "        : REM 7's
DATA "MI ","OH ","WV "                                                  : REM 8's
DATA "IL ","IN ","WI "                                                  : REM 9's
DATA "MAR","PQ ","ON ","MB ","SK ","AB ","BC ","VE8"                    : REM VE's

DO
   CALL LocateIt(5, 30)
   PRINT "INITIALIZATION"
   CALL LocateIt(7, 20)
   PRINT "New contest or resume? (N/R) ";
   COLOR 23: PRINT CHR$(254); : COLOR 7                           'create a flashing cursor
   CONTEST$ = ""                                                  ' since the normal cursor has
   WHILE LEN(CONTEST$) = 0                                        ' been turned off
      CONTEST$ = UCASE$(INKEY$)
      IF CONTEST$ = "R" THEN                                      'user restarting?
         EXIT DO
      ELSEIF CONTEST$ <> "N" THEN                                 'reject anything other than
         CONTEST$ = ""                                            ' N or R
      END IF
   WEND
  
   CALL LocateIt(7, 20)
   PRINT STRING$(32, 32)                                          'print blanks to erase line
  
   SPREC$ = ""                                                    'get user Precedence
   DO                                                             ' A = low power
      CALL LocateIt(10, 20)                                       ' B = high power
      PRINT "Precedence? ";                                       ' Q = QRP
      Row = CSRLIN                                                'save current row
      Col = POS(0)                                                'save current column
      IN$ = ""                                                    'starting input string
      CL = 1                                                      'permissible length of precedence field
      CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
      IF LEN(IN$) THEN SPREC$ = IN$                               'something was input!
      valid = INSTR("ABQ", SPREC$)                                'list of valid input chars
      IF valid = 0 THEN
         CALL LocateIt(23, 20)                                    'invalid entry
         CALL Klaxon
         PRINT "Precedence must be A, B, or Q      Any key to continue...";
         CALL AnyKey
         Row = 23
         Col = 20
         CALL CleanLine(Row, Col)                                 'erase error message
         CALL LocateIt(10, 32)
         PRINT STRING$(3, 32)                                     'erase original entry
         SPREC$ = ""                                              'reset variable to nul
      END IF
   LOOP UNTIL LEN(SPREC$)                                         'do this until the user enters
                                                                  ' a legal entry
   ID$ = ""
   DO                                                             'get the sending callsign
      LOCATE , 20
      PRINT "Call ?      ";
      Row = CSRLIN                                                'save current row
      Col = POS(0)                                                'save current column
      IN$ = ""                                                    'starting input field
      CL = 11                                                     'allow up to 11 char for call sign
      CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
      IF LEN(IN$) THEN ID$ = IN$                                  'something was input
      IF LEN(ID$) = 0 THEN                                        'no callsign entered
         CALL Klaxon                                              'sound alarm!
         CALL LocateIt(11, 20)                                    'put cursor back to beginning of field
      END IF
   LOOP UNTIL LEN(ID$)                                            'do this until a call is input

   CK$ = ""                                                       'get the check number - the two
   DO                                                             ' digits that represent the year
      LOCATE , 20                                                 ' the user was first licensed
      PRINT "Check ?     ";
      Row = CSRLIN                                                'save current row
      Col = POS(0)                                                'save current column
      IN$ = ""                                                    'starting input field
      CL = 2                                                      'allow 2 char for check field
      CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
      IF LEN(IN$) THEN CK$ = IN$                                  'something was input
      IF LEN(CK$) = 0 THEN                                        'nothing entered
         CALL Klaxon                                              'honk the horn
         CALL LocateIt(12, 20)                                    'put cursor back at start
      END IF
   LOOP UNTIL LEN(CK$)                                            'stay until check is entered
 
   SEC$ = ""                                                      'get the ARRL Section code
   DO
      LOCATE , 20
      PRINT "Section ?   ";
      Row = CSRLIN                                                'save current row
      Col = POS(0)                                                'save current column
      IN$ = ""                                                    'starting string input variable
      CL = 3                                                      'allow max of 3 char for section
      CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
      IF LEN(IN$) THEN SEC$ = IN$                                 'something was input
 
      IF LEN(SEC$) < 3 THEN                                       'force section to three characters
         SEC$ = SEC$ + " "
      END IF

      FOR N = 1 TO NumberOfSections                               'check all the sections
         IF SEC$ = Sections$(N) THEN                              ' and make sure this entry
            EXIT DO                                               ' is valid
         END IF
      NEXT N
      CALL Klaxon
      CALL LocateIt(23, 20)
      PRINT "INVALID SECTION!!   Any key to continue..."
      CALL AnyKey
      Row = 23
      Col = 20
      CALL CleanLine(Row, Col)                                    'erase the invalid section entry
      SEC$ = ""                                                   'reset the section variable
      CALL LocateIt(13, 32)
      PRINT STRING$(3, 32);                                       'erase the incorrect entry
      CALL LocateIt(13, 20)                                       'place cursor back at original input location
   LOOP UNTIL LEN(SEC$)                                           'stay until a valid section is entered

   MO$ = ""                                                       'get the operating mode
   DO                                                             ' either CW or SSB
      LOCATE , 20
      PRINT "Mode ?      ";
      Row = CSRLIN                                                'current row
      Col = POS(0)                                                'current column
      IN$ = ""                                                    'input field for filter
      CL = 3                                                      'allow max of 3 char - either CW or SSB
      CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
      IF LEN(IN$) THEN MO$ = IN$                                  'something was input
      IF MO$ <> "CW" THEN                                         'was something other than CW entered?
         IF MO$ <> "SSB" THEN                                     'was it SSB?
            MO$ = ""                                              'nope! - nul the variable
            CALL LocateIt(23, 20)
            CALL Klaxon                                           'alert user
            PRINT "Only CW or SSB are valid modes.   Any key to continue...";
            CALL AnyKey
            Row = 23
            Col = 20
            CALL CleanLine(Row, Col)                              'erase the error message
            CALL LocateIt(14, 32)
            PRINT STRING$(4, 32);                                 'erase invalid entry
         END IF
      END IF
   LOOP UNTIL LEN(MO$)                                            'stay until a mode is entered
 
   PRINT
   LOCATE , 20
   PRINT "All OK? (Y/N) ";
   COLOR 23: PRINT CHR$(254); : COLOR 7                           'flashing cursor
   RE$ = ""
   WHILE LEN(RE$) = 0                                             'stay until user responds
      RE$ = UCASE$(INKEY$)                                        'capitalize the user response
      IF RE$ = "Y" THEN EXIT DO                                   'answer was yes - exit and go to menu
   WEND                                                           'if user answers no
   CLS                                                            '  they will stay in the loop
LOOP                                                              '  and start the process over
CLS                                                               '  (no big deal to start over - it's only 5 entries

'************************************************
'*               MENU  ROUTINE                  *
'************************************************

DO
   COLOR , 9                                                      'light blue
   CLS
   TITLE$ = "ARRL SWEEPSTAKES CONTEST LOGGIN' MACHINE"
   LOCATE 6, 40 - (LEN(TITLE$)) / 2                               'calculate center for title
   PRINT TITLE$;                                                  '  then print title and menu options
   CALL LocateIt(10, 33)
   PRINT "SET/CHANGE BAND"
   CALL LocateIt(12, 29)
   PRINT "INITIAL START/RE-START"
   CALL LocateIt(14, 32)
   PRINT "PRINT LOG SHEETS"
   CALL LocateIt(16, 32)
   PRINT "PRINT DUPE SHEETS"
   CALL LocateIt(18, 31)
   PRINT "QUIT (Return to DOS)"
   CALL LocateIt(21, 22)
   PRINT "USE ARROWS - SELECT WITH ENTER KEY"

'****************************************************
'*  identify where the cursor should be on the menu *
'****************************************************

   SELECT CASE MenuLoc
      CASE 1                                                      'Set/Change Band
         'ULR=Upper Left Row
         'ULC=Upper Left Column
         'LRR=Lower Right Row
         'LRC=Lower Right Column
         ULR = 10: ULC = 33: LRR = 10: LRC = 47
      CASE 2                                                      'Start/Re-Start
         ULR = 12: ULC = 29: LRR = 12: LRC = 50
      CASE 3                                                      'Print Log Sheets
         ULR = 14: ULC = 32: LRR = 14: LRC = 47
      CASE 4                                                      'Print Dupe Sheets
         ULR = 16: ULC = 32: LRR = 16: LRC = 48
      CASE 5                                                      'Quit
         ULR = 18: ULC = 31: LRR = 18: LRC = 50
   END SELECT
  
FORE = 15                                                         'bright white foreground
BACK = 1                                                          'blue background
PAGE = 0                                                          'screen page 0
SCRMODE = -1                                                      'fast screen write - no snow checking
CALL CALCATTR(FORE, BACK, ATTR)
NEWATTR = ATTR                                                    'newattr is the "highlighted" color
CALL RecolorArea(ULR, ULC, LRR, LRC, NEWATTR, PAGE, SCRMODE)      'highlight the current menu selection
FORE = 7                                                          'white foreground
BACK = 1                                                          'blue background
CALL CALCATTR(FORE, BACK, ATTR)                                   'calculate normal color attribute
OLDATTR = ATTR                                                    'oldattr is the "normal" color

'********************************
'*                              *
'*        READ  ARROWS          *
'*                              *
'*  chr$(72) = up arrow         *
'*  chr$(80) = dn arrow         *
'*                              *
'********************************

   DO UNTIL Arrow$ = CHR$(13)                                     'stay with the menu routine until
      Arrow$ = INKEY$                                             ' user hits enter
      IF LEN(Arrow$) = 2 THEN                                     'arrow keys are "extended" keys
         Arrow$ = RIGHT$(Arrow$, 1)
      END IF

      IF (Arrow$ = CHR$(72) AND MenuLoc = 1) THEN                 'NewColor highlights the menu selection
         MenuLoc = 5                                              'OldColor restores the original colors
         ULR = 10: ULC = 33: LRR = 10: LRC = 47                   'wrap from Set/ChangeBand down to
         GOSUB OldColor                                           'Quit
         ULR = 18: ULC = 31: LRR = 18: LRC = 50
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(80) AND MenuLoc = 1) THEN
         MenuLoc = 2
         ULR = 10: ULC = 33: LRR = 10: LRC = 47                   'move from Set/Change Band down to
         GOSUB OldColor                                           'Start/Re-Start
         ULR = 12: ULC = 29: LRR = 12: LRC = 50
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(72) AND MenuLoc = 2) THEN
         MenuLoc = 1
         ULR = 12: ULC = 29: LRR = 12: LRC = 50                   'move from Start/Re-start up to
         GOSUB OldColor                                           'Set/Change Band
         ULR = 10: ULC = 33: LRR = 10: LRC = 47
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(80) AND MenuLoc = 2) THEN
         MenuLoc = 3
         ULR = 12: ULC = 29: LRR = 12: LRC = 50                   'move from Start/Re-Start down to
         GOSUB OldColor                                           'Print Log Sheets
         ULR = 14: ULC = 32: LRR = 14: LRC = 47
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(72) AND MenuLoc = 3) THEN
         MenuLoc = 2
         ULR = 14: ULC = 32: LRR = 14: LRC = 47                   'move from Print Log Sheets up to
         GOSUB OldColor                                           'Start/Re-Start
         ULR = 12: ULC = 29: LRR = 12: LRC = 50
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(80) AND MenuLoc = 3) THEN
         MenuLoc = 4
         ULR = 14: ULC = 32: LRR = 14: LRC = 47                   'move from Print Log Sheets down to
         GOSUB OldColor                                           'Print Dupe Sheets
         ULR = 16: ULC = 32: LRR = 16: LRC = 48
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(72) AND MenuLoc = 4) THEN
         MenuLoc = 3
         ULR = 16: ULC = 32: LRR = 16: LRC = 48                   'move from Print Dupe Sheets up to
         GOSUB OldColor                                           'Print Log Sheets
         ULR = 14: ULC = 32: LRR = 14: LRC = 47
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(80) AND MenuLoc = 4) THEN
         MenuLoc = 5
         ULR = 16: ULC = 32: LRR = 16: LRC = 48                   'move from Print Dupe Sheets down to
         GOSUB OldColor                                           'Quit
         ULR = 18: ULC = 31: LRR = 18: LRC = 50
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(72) AND MenuLoc = 5) THEN
         MenuLoc = 4
         ULR = 18: ULC = 31: LRR = 18: LRC = 50                   'move from Quit up to
         GOSUB OldColor                                           'Print Dupe Sheets
         ULR = 16: ULC = 32: LRR = 16: LRC = 48
         GOSUB NewColor
      ELSEIF (Arrow$ = CHR$(80) AND MenuLoc = 5) THEN
         MenuLoc = 1
         ULR = 18: ULC = 31: LRR = 18: LRC = 50                   'wrap around from Quit up to
         GOSUB OldColor                                           'Set/Change Band
         ULR = 10: ULC = 33: LRR = 10: LRC = 47
         GOSUB NewColor
      END IF
   LOOP

'**************************
'* Handle Menu Selection  *
'**************************

   IF MenuLoc = 1 THEN
      CALL SetBand(BA$, Clock, Fields$())
   ELSEIF MenuLoc = 2 THEN
      CALL DataEntry(BA$, SS, QSOCounter, FileName$, FileName1$, FileName2$, File$, FileFlag, SSTree, Fields$())
      IF FileFlag = 0 THEN
         CALL EntryScreen(MenuLoc, BA$, SS, QSOCounter, SSTree, Clock, Fields$())
         IF FileFlag = 1 THEN
            CALL DeadWindow
            SYSTEM
         END IF
      ELSE
         FileFlag = 0                                             'no filename entered
         FileName$ = ""                                           'make sure they're all nulled
         File$ = ""
      END IF
   ELSEIF MenuLoc = 3 THEN                                        'go print the logsheets
      CALL RptForm(SS, QSOCounter)
   ELSEIF MenuLoc = 4 THEN                                        'print the dupe sheets
      CALL AlphaForm(QSOCounter, SSTree, File$)
   ELSEIF MenuLoc = 5 THEN                                        'quit
      EXIT DO
   END IF
   Arrow$ = ""
LOOP
CLS
IF WriteFlag = 1 THEN                                             'data file was written to
   CALL LocateIt(10, 12)
   PRINT "........Saving data files.";
   OPEN FileName2$ FOR OUTPUT AS #2                               'save the "configuration" data
   WRITE #2, SPREC$, ID$, CK$, SEC$, MO$, SectionsWorked
   FOR N = 1 TO NumberOfSections
      WRITE #2, SectionCounter(N)
   NEXT N
   CLOSE #2                                                       'copy the file in the ramdrive
   CALL FCLOSE(Handle)                                            'in case the user wants to continue later
   CALL FCLOSE(Handle1)
   CALL FCLOSE(Handle3)
   CALL CopyFile(File$, FileName1$, Ecode)                        'copy ram drive file to disk
END IF
CLOSE
IF File$ <> "" THEN
   KILL File$                                                     'delete the ram drive file
END IF
COLOR , 8                                                         'reset colors
CLS
END

NONO:                                                             'this is the trap for CTRL-ALT-DEL
   Row = 23
   Col = 20
   CALL LocateIt(Row, Col)
   PRINT "Please exit to reboot!  ...any key";
   CALL AnyKey
   CALL CleanLine(Row, Col)
   RETURN

NewColor:                                                         'subroutine used to show the currently
   CALL RecolorArea(ULR, ULC, LRR, LRC, NEWATTR, PAGE, SCRMODE)   '  highlighted menu selection
   RETURN

OldColor:                                                         'subroutine to restore the "normal" color
   CALL RecolorArea(ULR, ULC, LRR, LRC, OLDATTR, PAGE, SCRMODE)   '  to the remaining menu lines
   RETURN

'*************************************************
'*                                               *
'*  SUB AlphaForm                                *
'*                                               *
'*  This sub procedure creates an alphabetical   *
'*  report of the callsigns worked.              *
'*                                               *
'*  This is the DUPE SHEET!!                     *
'*                                               *
'*************************************************
'
SUB AlphaForm (QSOCounter, SSTree AS TreeType, File$)

'---------------------------------------------------------------------------
'
'  There is a "quirk" in the program as it currently exists.  When a user
'  wants to print either the Log Sheets or the Dupe Sheets, the program
'  does not assume the appropriate files have been opened.  If the user
'  has exited the program since operating has ceased, re-starts the program,
'  and wants to print either of the reports mentioned, he will have to
'  enter the main data file name and the VDISK designator.  The VDISK is
'  is necessary since that's where the calls are read to do the sort.
'
'  It may be appropriate to check if there is a file opened, and if there
'  isn't, to prompt the user accordingly.  It may also be feasible to read
'  the calls from the main file instead of the VDISK.  If that's the case,
'  be sure some sort of trap exists to prevent the user from trying to
'  get the program going without a VDISK!
'
'----------------------------------------------------------------------------
'
PRTPORT = 1
CALL PRTCHECK(PRTPORT, STATUS)                                    'check to see if printer is ready
IF STATUS = 0 THEN
   LABEL$ = "PRINTER ERROR"
   ST1$ = "Printer not ready!"
   CALL ErrWindow(LABEL$, ST1$)
   EXIT SUB
END IF


IF QSOCounter < 2 THEN                                            'QSOCounter "wakes up" at 1 !!
   LABEL$ = "DATA ERROR"                                          '  therefore, there's no data
   ST1$ = "Please load data files!"
   CALL ErrWindow(LABEL$, ST1$)
   EXIT SUB
END IF

CLS
CALL LocateIt(12, 20)

LPRINT CHR$(18);                                                  'set standard print
LPRINT CHR$(27) + "3" + CHR$(36);
LPRINT CHR$(27) + CHR$(2);                                        'reset to 6 lpi
WIDTH LPRINT 80


CLS                                                               'clear the screen

CALL LocateIt(12, 20)
PRINT "Reading data file......"

CallLen = 11                                                      'length of allowable callsign
Bytes = 32000                                                     'buffer size for reading files
RecordPointer = 1                                                 'pointer for FSETREC routine
REDIM Farray(Bytes)                                               'array for reading a chunk of the file
REDIM Darray(((QSOCounter - 1) \ 2) + 1, CallLen)                 'array to capture callsigns from binary tree record
ST$ = SPACE$(LEN(SSTree))                                         'fix the string to record length
CA$ = SPACE$(CallLen)                                             'fix the string to the call sign size
RecsPerPass = 2000                                                'read a max of 2,000 records at any one pass
IF RecsPerPass > (QSOCounter - 1) THEN                            'not enough records for a full pass?
   RecsPerPass = (QSOCounter - 1)                                 'set to appropriate number
END IF
NumPasses = ((QSOCounter - 1) \ RecsPerPass) - (((QSOCounter - 1) MOD RecsPerPass) <> 0)    'how many passes do we need?
IF NumPasses = 1 THEN                                             'is it a perfect match?
   RecsLastPass = RecsPerPass                                     'yes - read the full amount
ELSE
   RecsLastPass = (QSOCounter - 1) MOD RecsPerPass                'no - calculate the difference required
END IF
FOR X = 1 TO NumPasses                                            'start reading the file
   IF X < NumPasses THEN                                          'if not the last pass
      RecsThisPass = RecsPerPass                                  'do the full complement
   ELSE                                                           'the last pass may have
      RecsThisPass = RecsLastPass                                 '  fewer records to do
   END IF
   IF RecsThisPass = 0 THEN                                       'did the arithmetic come out perfectly even?
      RecsThisPass = RecsPerPass                                  '  yes - read a full bucket
   END IF
   CALL FSETREC(Handle3, LEN(SSTree), RecordPointer)              'set record locator in file
   DSEG = VARSEG(Farray(1))
   DOFS = VARPTR(Farray(1))
   CALL DFREAD(Handle3, DSEG, DOFS, RecsThisPass * LEN(SSTree), BytesRead, Ecode)'read a chunk of the file
   FOR N = 1 TO RecsThisPass
      DSEG = VARSEG(Farray(1))                                    'capture the callsign only from the
      DOFS = VARPTR(Farray(1))                                    'buffer into the actual callsign data array
      CALL DGETREC(DSEG, DOFS, N, ST$)                            'get the full record
      CA$ = RIGHT$(ST$, 11)                                       'create the call sign
      DSEG = VARSEG(Darray(1, 1))
      DOFS = VARPTR(Darray(1, 1))
      CALL DPUTREC(DSEG, DOFS, N + ((X - 1) * RecsPerPass), CA$)  'put call sign into data array
   NEXT N
   RecordPointer = RecordPointer + RecsPerPass                    'increment pointer for FSETREC
NEXT X
ERASE Farray                                                      'clear the buffer space

CALL LocateIt(12, 20)
PRINT "Sorting callsign array..."

SFSTART = 1                                                       'sort field beginning at char 1
SFEND = 11                                                        'sort field ends at char 11
REDIM Parray(QSOCounter - 1)                                      'create a pointer array for sorting
PSEG = VARSEG(Parray(1))
POFS = VARPTR(Parray(1))
CALL INITPTR(PSEG, POFS, QSOCounter - 1)                          'initialize pointer array
DSEG = VARSEG(Darray(1, 1))
DOFS = VARPTR(Darray(1, 1))
CALL DPTRSORT(DSEG, DOFS, PSEG, POFS, CallLen, SFSTART, SFEND, QSOCounter - 1)    'do the sort

CALL LocateIt(12, 20)
PRINT "Printing the dupe sheets."
PRINT
LOCATE , 20
PRINT "ESCape to stop printing."
RE$ = ""                                                          'use RE$ for user response
N = 1                                                             'callsign counter
ReqdPages = ((QSOCounter - 1) \ 392) + 1                          '392 calls per page
Counter = 1                                                       'page counter
DO
   IF Counter > 1 THEN
      LPRINT CHR$(12);                                            'form feed
   END IF
   LPRINT
   LPRINT "ARRL SWEEPSTAKES - DUPE SHEETS FOR "; ID$;
   LPRINT TAB(53);
   LPRINT "Page "; Counter; " of "; ReqdPages; " Pages"
   LPRINT STRING$(75, 61)                                         'print 75 "="
   LPRINT
   FOR PAGE = 1 TO 56                                             'allow 56 lines per page
      FOR Row = 1 TO 7                                            '7 calls per row
         RE$ = INKEY$                                             'user want to quit?
        
         IF RE$ = CHR$(27) THEN                                   'user pressed escape
            EXIT DO                                               'quit
         END IF

         DSEG = VARSEG(Darray(1, 1))
         DOFS = VARPTR(Darray(1, 1))
         CALL DGETREC(DSEG, DOFS, Parray(N), CA$)                 'get a callsign to print
         LPRINT CA$;                                              'print it
         N = N + 1                                                'increment counter
         IF N = QSOCounter THEN                                   'out of calls?
            EXIT DO
         END IF
      NEXT Row                                                    'print another group of 7 calls
   NEXT PAGE                                                      'do the next page
   Counter = Counter + 1                                          'increment page counter
LOOP
LPRINT CHR$(12);                                                  'form feed
ERASE Parray                                                      'erase pointer array
ERASE Darray                                                      'erase data array
END SUB

'************************************************
'*                                              *
'*  SUB AnyKey                                  *
'*                                              *
'*  This sub procedure waits for any key to     *
'*  be pressed to continue processing.          *
'*                                              *
'************************************************
'
SUB AnyKey

DO
LOOP UNTIL LEN(INKEY$)

END SUB

'*******************************************
'*                                         *
'*  SUB CleanLine                          *
'*                                         *
'*  This sub procedure is used to "erase"  *
'*  old data from the input area at the    *
'*  bottom of the data entry screen.       *
'*                                         *
'*******************************************
'
SUB CleanLine (Row, Col)

CALL LocateIt(Row, Col)
PRINT STRING$(79 - Col, 32)                                       'print a bunch of spaces

END SUB

'************************************************
'*                                              *
'*  SUB CleanUp                                 *
'*                                              *
'*  This sub procedure is used at the end of    *
'*  the EntryScreen sub procedure to erase all  *
'*  the entry fields and reset the appropriate  *
'*  variables prior to the next entry.          *
'*                                              *
'************************************************
'
SUB Cleanup (F(), Fields$(), TempFields$)

EntryFlag = 0                                                     'reset entry flag
FOR N = 1 TO 5
   F(N) = 0                                                       'set entry counter to 0
   Fields$(N) = ""                                                'clear all fields
   TempFields$ = ""                                               ' and erase them
   LOCATE 14 + N, 14
   PRINT STRING$(13, 32);                                         'erase by printing blanks
NEXT N

END SUB

'***********************************************
'*                                             *
'*  SUB DataEntry                              *
'*                                             *
'*  This sub procedure prompts for the         *
'*  band and file name and then calls          *
'*  the EntryScreen where data is actually     *
'*  entered.                                   *
'*                                             *
'***********************************************
'
SUB DataEntry (BA$, SS AS RecordType, QSOCounter, FileName$, FileName1$, FileName2$, File$, FileFlag, SSTree AS TreeType, Fields$())

'*****************************************************************************
'
'  BA$ is the current band
'  SS is the main record
'  QSOCounter keeps track of the number for the next QSO
'  FileName$ is the file name for the .SWS file
'  FileName1$ is the file name for the .DAT file (pointer file)
'  FileName2$ is the file name for the .CFG file (sending and sections worked)
'  File$ is the name for the ram drive file
'  FileFlag identifies that there was a file error
'  SSTree is the binary tree record
'  Fields$() are temporary fields
'
'*****************************************************************************
'
IF LEN(FileName$) > 0 THEN                                        'if file name has already been set
   EXIT SUB                                                       'do a re-start and go directly to
END IF                                                            'entries

DO WHILE FileName$ = ""                                           'this assumes a file name has not been set
   Row = 23
   Col = 20
   CALL CleanLine(Row, Col)                                       'erase any messages
   CALL LocateIt(Row, Col)
   PRINT "File Name: ";                                           'get data file name
   Col = POS(0)
   CL = 25                                                        'allow 25 char for file name
   DO
      IN$ = "B:\"                                                 'initial input field for filter routine
      CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())

      IF LEN(IN$) = 0 THEN                                        'no file name entered
         FileFlag = 1                                             'set file error flag
         EXIT SUB                                                 'back to menu
      END IF

      IF IN$ = "B:\" THEN                                         'no file name entered here
         FileFlag = 1                                             'just the default path
         EXIT SUB                                                 'set error flag and get out
      ELSE
         FileName$ = IN$ + ".SWS"                                 'main data file
         FileName1$ = IN$ + ".DAT"                                'pointer data file from ram drive
         FileName2$ = IN$ + ".CFG"                                'sending and section data
         EXIT DO
      END IF
   LOOP
   CALL LocateIt(23, 20)
   PRINT STRING$(42, 32);                                         'print blanks to "erase" line
   LOCATE , 20
   PRINT "VDISK Drive: ";                                         'where is the ram drive?
   Row = CSRLIN
   Col = POS(0)
   CL = 1                                                         'only one letter allowed!
   IN$ = ""
   CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
   VDISK$ = IN$                                                   'set VDISK$ to whatever was returned from filter
   IF LEN(VDISK$) = 0 THEN                                        'no ram drive id entered
      File$ = ""                                                  'set file name to null
      FileFlag = 1                                                'set file error flag
      FileName$ = ""                                              'clear the file name originally set
      EXIT SUB                                                    ' and go back to the menu
   ELSE
      File$ = VDISK$ + ":\TREE.DAT"                               'file name was entered
   END IF
  
   Handle = 0                                                     'file handle for .SWS main file
   Handle1 = 0                                                    'file handle for .DAT pointer file
   Handle2 = 0                                                    'file handle for .CFG section file
   Handle3 = 0                                                    'file handle for ram drive file

   IF CONTEST$ = "R" THEN                                         'is the user re-starting?
      CALL FOPEN(FileName$, 2, 0, Handle, Ecode)                  'open the .SWS main file
      IF Ecode THEN                                               'error opening the file?
         FIL$ = FileName$
         CALL FileError(FIL$, Ecode)                              'open window - tell user about error
         EXIT SUB
      END IF
      CALL FOPEN(FileName2$, 2, 0, Handle2, Ecode)                'open the section .CFG file
      IF Ecode THEN                                               'error opening the file?
         FIL$ = FileName2$
         CALL FileError(FIL$, Ecode)                              'open error window for user
         EXIT SUB
      ELSE
         CALL FCLOSE(Handle2)                                     'close the file
         OPEN FileName2$ FOR INPUT AS #1                          'and open it with BASIC
         INPUT #1, SPREC$, ID$, CK$, SEC$, MO$, SectionsWorked
         FOR N = 1 TO NumberOfSections
            INPUT #1, SectionCounter(N)
         NEXT
         CLOSE #1
      END IF
      CALL FOPEN(FileName1$, 2, 0, Handle1, Ecode)                'open pointer .DAT file
      IF Ecode THEN                                               'error opening the file?
         FIL$ = FileName1$
         CALL FileError(FIL$, Ecode)                              'open error window for user
         EXIT SUB
      ELSE
         CALL FCREATE(File$, 0, Handle3, Ecode)                   'create the ram drive file
         IF Ecode THEN                                            'error creating the file?
            FIL$ = File$
            CALL FileError(FIL$, Ecode)                           'open error window for user
            EXIT SUB
         ELSE
            CALL FCLOSE(Handle3)                                  'close the file before attempting copy operation
            CALL LocateIt(23, 20)
            PRINT "Recovering data file...please wait.";
            CALL CopyFile(FileName1$, File$, Ecode)               'copy pointer file into ram drive
            CALL FOPEN(File$, 2, 0, Handle3, Ecode)               'open ram drive file
            IF Ecode THEN                                         'error opening the file?
               FIL$ = File$
               CALL FileError(FIL$, Ecode)
               EXIT SUB
            END IF
         END IF
      END IF
   ELSE                                                           'starting for the first time
      FIL$ = FileName$
      CALL EXIST(FIL$, FOUND)                                     'does the file already exist?
      IF FOUND THEN                                               'yes - user was perhaps mistaken
         CALL FileFound(FIL$)                                     'ask user to try again
         EXIT SUB
      ELSE
         CALL FCREATE(FileName$, 0, Handle, Ecode)                'create the new file
         IF Ecode THEN                                            'error creating the file?
            FIL$ = FileName$
            CALL FileError(FIL$, Ecode)
            EXIT SUB
         END IF
         FIL$ = File$
         CALL EXIST(FIL$, FOUND)                                  'ram drive file still there?
         IF FOUND THEN                                            'yes
            CALL FileFound(FIL$)                                  'same as above - probably a user mistake
            EXIT SUB
         ELSE
            CALL FCREATE(File$, 0, Handle3, Ecode)                'create the ram drive file
            IF Ecode THEN                                         'creation error?
               FIL$ = File$
               CALL FileError(FIL$, Ecode)
               EXIT SUB
            END IF
         END IF
      END IF
   END IF
   CALL FSIZE(Handle, Bytes&)                                     'how big is the main file?
   QSOCounter = (Bytes& \ LEN(SS)) + 1                            'QSOCounter = # of records + 1
   Row = 23
   Col = 20
   CALL CleanLine(Row, Col)                                       'erase any messages
LOOP
END SUB

'*************************************************
'*                                               *
'*   SUB DeadWindow                              *
'*                                               *
'*   If the user ends up here, he/she is in a    *
'*   lot of trouble!  Arrival here means that a  *
'*   disk write operation took place and created *
'*   an error that indicates the disk is full!   *
'*   Since the user was not smart enough to pay  *
'*   attention at the beginning of the program   *
'*   when they were warned about how much space  *
'*   existed on the drive(s), throw them out!    *
'*                                               *
'*   This window will give them the message and  *
'*   and when they return to the routine that    *
'*   called this window, they will be exited to  *
'*   the SYSTEM.                                 *
'*                                               *
'*************************************************
'
SUB DeadWindow

   ULR = 5: ULC = 10: LRR = 18: LRC = 60                          'row and column designators
   FORE = 11: BACK = 0                                            'light cyan on black background
   LABEL = 15: LABEL$ = "MAJOR BOOBOO!"                           'bright white label
   FRAME = 2                                                      'double-line frame
   GROW = 0                                                       'no explosion as window appears
   SHADOW = -2                                                    'true shadow to the left
   PAGE = 0                                                       'screen page
   SCRMODE = -1                                                   'don't check for snow
   CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
   CALL CALCATTR(FORE, BACK, ATTR)                                'calc colors for window print
   REDIM ST$(9)
   ST$(1) = "You have created the major OOPS of this package!"
   ST$(2) = "The warnings that were posted at the beginning"
   ST$(3) = "stated how much disk space you had and what the"
   ST$(4) = "limitations were.  You have exceeded those"
   ST$(5) = "dimensions and have no more disk space for your"
   ST$(6) = "data."
   ST$(7) = " "
   ST$(8) = "It is with extreme regret that I now inform you"
   ST$(9) = "there is nothing else left to do but stop."
   Counter = 1
   FOR N = 7 TO 15
      CALL XQPRINT(ST$(Counter), N, 11, ATTR, PAGE, SCRMODE)      'print messages in window
      Counter = Counter + 1
   NEXT
   CALL FCLOSE(Handle)                                            'close all files
   CALL FCLOSE(Handle1)
   CALL FCLOSE(Handle3)
   SYSTEM

END SUB

'************************************************************
'*                                                          *
'*  SUB DoWindow                                            *
'*                                                          *
'*  This sub procedure creates a window for the FileError   *
'*  procedure.  Some of the necessary parameters are passed *
'*  from the FileError routine.  Other parameters that are  *
'*  not pertinent to FileError are set here.                *
'*                                                          *
'************************************************************
'
SUB DoWindow (Ecode, FIL$, ULR, ULC, LRR, LRC, FORE, BACK, LABEL, LABEL$)

   FRAME = 2                                                      'double-line frame
   GROW = 0                                                       'no explosion as window appears
   SHADOW = -2                                                    'true shadow to the left
   PAGE = 0                                                       'screen page
   SCRMODE = -1                                                   'don't check for snow
   CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
   CALL CALCATTR(FORE, BACK, ATTR)                                'calc colors for window print
   Size = 4
   REDIM ST$(Size)                                                'array for strings to print in the window
   SELECT CASE Ecode                                              'check for errors
      CASE -1
         ST$(2) = "Read/Write File Error"
      CASE 2
         ST$(2) = "File not found"
      CASE 3
         ST$(2) = "Path not found"
      CASE 21
         ST$(2) = "Disk drive not ready"
      CASE ELSE
         ST$(2) = "General File Error"
   END SELECT
   ST$(0) = "Error Code: "
   ST$(1) = FIL$
   IF Ecode = 21 THEN
      ST$(3) = "Please check drive/disk/door"
   ELSE
      ST$(3) = "Please check filname and/or path"
   END IF
   ST$(4) = "...any key"
   Counter = 0
   FOR N = 12 TO 15
      CALL XQPRINT(ST$(Counter), N, 22, ATTR, PAGE, SCRMODE)      'print messages in window
      Counter = Counter + 1
   NEXT
   A$ = ISTR$(Ecode)
   CALL XQPRINT(A$, 12, 22 + LEN(ST$(0)), ATTR, PAGE, SCRMODE)    'print the error code
   CALL XQPRINT(ST$(4), 17, 54, ATTR, PAGE, SCRMODE)              'print the ...any key message
   CALL AnyKey
   CALL ScreenRestore                                             'remove window and restore screen
END SUB

'************************************************
'*                                              *
'*  SUB EntryInput                              *
'*                                              *
'*  This sub procedure checks for entries in    *
'*  the input screen (EntryScreen) to see if    *
'*  all entries have been completed.            *
'*                                              *
'************************************************
'
SUB EntryInput (F())

SUM = 0
FOR N = 1 TO 5                                                    'has data been entered
   SUM = SUM + F(N)                                               'in all fields?
   IF SUM = 15 THEN                                               'if sum = 15 - YES
      EntryFlag = 1                                               'set the completed flag
   END IF
NEXT N

END SUB

'******************************************************
'*                                                    *
'*  SUB EntryScreen                                   *
'*                                                    *
'*  This sub procedure is where the information       *
'*  is physically entered.  Each field must have      *
'*  information in it to be "accepted" by the         *
'*  loading subroutine.  PF-4 is used for the         *
'*  "acceptance" flag.  If the user wishes to         *
'*  abort the entry, the PF-8 key is used.            *
'*                                                    *
'******************************************************
'
SUB EntryScreen (MenuLoc, BA$, SS AS RecordType, QSOCounter, SSTree AS TreeType, Clock, Fields$())

TotalScore& = 0                                                   'long integer

IF BA$ = "" THEN                                                  'no band has been designated
   MenuLoc = 1                                                    'return to menu and let user set
   EXIT SUB                                                       'the band preference
END IF

SS.TimeOnOff = LEFT$(TIME$, 2) + MID$(TIME$, 4, 2)                'identify that the the run clock is on
Clock = 1                                                         'turn the clock on
C$ = ""                                                           'temp call sign
PR$ = ""                                                          'temp precedence
NUM$ = ""                                                         'temp received number
CH$ = ""                                                          'temp check number
SE$ = ""                                                          'temp section
DIM F(5)                                                          'F is the counting array to help determine if
valid = 0                                                         '               all the fields have entries
FOR N = 1 TO 5
   F(N) = 0                                                       'set all the counters and
   Fields$(N) = ""                                                'counter fields to 0
NEXT N

QSOMultiplier& = QSOCounter                                       'determine current score
SectionMultiplier& = SectionsWorked

IF MO$ = "CW" THEN                                                'if mode is CW
   TotalScore& = (QSOMultiplier& - 1) * 2 * SectionMultiplier&    '  score = QSO * 2 * Sections Worked
ELSE                                                              '  else
   TotalScore& = (QSOMultiplier& - 1) * SectionMultiplier&        '  mode is SSB and Score = QSO * Sections Worked
END IF

TempFields$ = ""                                                  'establish a "holding" variable for entries
CLS                                                               'clear the screen
CALL LocateIt(25, 1)
COLOR 15, 4                                                        'white letters on red background
PRINT "F-1 QSY F-4 ACCEPT F-8 ABORT F-10 EXIT  <CTRL> BACKSPACE TO ERASE FIELD ";      'print "status lines"
COLOR 7, 1                                                        'reset colors to white on blue

ULR = 3: ULC = 70: LRR = 3: LRC = 76                              'row/col values
FRAME = 2: FORE = 7: BACK = 1                                     'double-lined frame - white on blue
GROW = 0: SHADOW = 0                                              'instant window - no shadow
LABEL = 15: LABEL$ = "BAND"                                       'bright white label
PAGE = 0: SCRMODE = -1                                            'screen page 0 - no snow checking
CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
CALL LocateIt(3, 70)
COLOR 15, 0                                                       'bright white on black
PRINT "       ";                                                  'establish window area as black
CALL LocateIt(3, 72)
PRINT BA$;                                                        'print the current band setting
COLOR 7, 1                                                        'reset colors to white on blue

CALL LocateIt(3, 1)
PRINT "                  "; : COLOR 3, 0: PRINT " ͻ "; : COLOR 7, 1
PRINT "                  "; : COLOR 3, 0: PRINT "             SENDING INFORMATION               "; : COLOR 7, 1
PRINT "                  "; : COLOR 3, 0: PRINT "                                               "; : COLOR 7, 1
PRINT "                  "; : COLOR 3, 0: PRINT "  NUMBER   PREC     CALL     CHECK    SECTION  "; : COLOR 7, 1
PRINT "                  "; : COLOR 3, 0: PRINT " ͼ "; : COLOR 7, 1
PRINT "                  "; : COLOR 3, 0: PRINT "                                                 "; : COLOR 7, 1

ULR = 11: ULC = 5: LRR = 12: LRC = 27                             'row/col values
LABEL = 15: LABEL$ = "SUMMARY"                                    'bright white window label
CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)

CALL LocateIt(11, 6)
PRINT "Sections: "; SectionsWorked;                               'show the current # of
CALL LocateIt(12, 6)                                              '   sections worked
PRINT "Score: ";                                                  '   and current score
LOCATE , 16
PRINT TotalScore&;                                                'display current score
LOCATE 8, 27 - (LEN(ISTR$(QSOCounter)))
COLOR 15, 0                                                       'bright white on black
PRINT QSOCounter;                                                 'show user the next QSO number
COLOR 14, 0                                                       'yellow on black
PRINT TAB(33);
PRINT SPREC$; TAB(42 - (LEN(ID$) \ 2)); ID$; TAB(51); CK$; TAB(60); SEC$;      'print Precedence, Call, Check, and Section
COLOR 7, 1                                                        'white on blue

ULR = 3: ULC = 3: LRR = 3: LRC = 12                               'row/col values
LABEL = 15: LABEL$ = "CLOCK"                                      'bright white window label
CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)

ULR = 11: ULC = 31: LRR = 21: LRC = 79                            'row/col values
LABEL = 15: LABEL$ = "ARRL SECTIONS"                              'bright white window label
CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)

A = 11                                                            'locate start line for sections
B = 32                                                            'locate starting col for sections
Section = 1
FOR J = 0 TO 10                                                   'call area
   CALL LocateIt(A, B)
   TB = 4                                                         'tab counter
   IF J = 10 THEN
      PRINT "VE";                                                 'call area "10" is Canada
   ELSE
      PRINT J;
   END IF
   LOCATE A, B + TB
   FOR K = 1 TO CallAreas(J)                                      'loop within call area
      IF SectionCounter(Section) THEN                             'section worked?
         COLOR 7, 1                                               'yes - print in normal colors (white on blue)
      ELSE
         COLOR 0, 11                                              'no - highlight it (black on light cyan)
      END IF
      PRINT Sections$(Section);                                   'print the section
      COLOR 7, 1                                                  'reset color to white on blue
      PRINT " ";                                                  'print the space between sections
      Section = Section + 1
   NEXT K
   A = A + 1                                                      'increment the row
   B = 32                                                         'reset column counter
NEXT J                                                            'do the next call area

ULR = 15: ULC = 5: LRR = 19: LRC = 27                             'row/col values
FORE = 14: BACK = 0: SHADOW = -2                                  'yellow on black with true shadow to left
LABEL = 15: LABEL$ = "INPUT"                                      'bright white window label
CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)

ULR = 15: ULC = 6: LRR = 19: LRC = 27                             'row/col values
FORE = 7: BACK = 1                                                'white on blue
CALL CALCATTR(FORE, BACK, ATTR)
CALL RecolorArea(ULR, ULC, LRR, LRC, ATTR, PAGE, SCRMODE)         'color the interior of the input screen

CALL LocateIt(15, 6)                                              'Entry Fields for:
PRINT "Call:    "                                                 '   Call Sign
LOCATE , 6
PRINT "Number:  "                                                 '   Received Number
LOCATE , 6
PRINT "Prec.:   "                                                 '   Received Precedence
LOCATE , 6
PRINT "Check:   "                                                 '   Received Check #
LOCATE , 6
PRINT "Section: "                                                 '   Received Section
'
'****************************************************************************
'
'                     EXPLANATION OF THE LOGIC IN THIS SECTION
'
'  As you can see by the section immediately above this, there are 5 major
'  pieces to this sub procedure, one for each of the entries required for the
'  contest exchange.  As each "field" is encountered, a temporary field is
'  established for the string that represents the entry for that particular
'  field.  When the filter returns the appropriate characters, the temp field
'  is set equal to whatever comes back.  If the field is not empty the sub
'  procedure EntryInput will increment a counter to record the fact that the
'  field has data in it.  Once all the fields have entries, the sum of those
'  five fields (which will now total 15) will allow EntryInput to set the
'  EntryFlag to 1 (instead of zero).  Now, if the user presses F4, the filter,
'  knowing that all fields have data, will set the EntryFlag to 2.  When control
'  passes back from Filter to EntryScreen, it will move down to the Accept
'  region.  If everything is normal (EntryFlag = 2) the data file will be
'  written to, the ram drive will get updated with the appropriate pointers
'  and the screen will be erased in preparation for the next entry.
'
'  If no callsign is entered, the LoadTree procedure will not be called to
'  check for a dupe.  When a call is finally entered, LoadTree will be called
'  only to check for a duplicate callsign.  If no dupe is found, everything
'  continues normally until all fields have entries.  Once the F4 confirms that
'  everything is done, LoadTree is called again, this time to determine where
'  the call goes in the binary tree and what numbers the left and/or right
'  pointers will be set to.
'
'  If a dupe is found, the EntryFlag is set to 3 and a message will appear on
'  the screen indicating it is a dupe.  The user responds, and the message and
'  the input fields are cleared for further action.  If the user enters a call,
'  continues with other field entry and then later changes the call, LoadTree
'  will be called again to check for a dupe.  That's the main reason why the
'  temp fields are used.
'
'  If the user decides he made a boo-boo, can't complete the exchange, or some
'  other reason, and wants to clear the current entries, he can press F8 and
'  all fields get cleared and everything starts over.
'
'  While using the program in the 1989 CW Sweepstakes contest, a couple of
'  annoying features became obvious.  At the time, I had decided that a null
'  entry in the callsign field would be the signal to exit, record the time
'  off and return to the menu.  What a mistake!  I modified the program to let
'  the user enter any field, whether or not he got the callsign right off the
'  bat.  Once all is complete, all else is still the same.  If, at any time,
'  the user wants to exit and record the time off, F10 may be pressed.  This
'  will set EntryFlag = 4.  When the program cycles to Accept, the time off
'  will be recorded, written to the data file and then return to the menu.
'
'*****************************************************************************

DO
   CALL LocateIt(15, 15)
   Row = CSRLIN
   Col = POS(0)                                                   'CallSign
   CL = 11
   IN$ = Fields$(1)                                               'set field equal to whatever was there last
   CALL EntryInput(F())                                           'increment field counter
   CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
   C$ = IN$                                                       'establish the callsign
   TempFields$ = C$                                               'establish the temporary field

   IF C$ = "" THEN                                                'no callsign
      IF EntryFlag = 3 THEN                                       'it might have been changed
         GOTO Accept                                              'go check it out
      END IF
   END IF

   IF QSOCounter > 1 THEN                                         'call was changed - check it again
      IF TempFields$ <> Fields$(1) THEN
         CALL LoadTree(BA$, SS, QSOCounter, C$, SSTree, PR$, NUM$, CH$, SE$)
      END IF
   END IF

   IF C$ = "" THEN                                                'the LoadTree routine
      IF EntryFlag = 3 THEN                                       ' discovered a duplicate
         GOTO Accept                                              ' check it out
      END IF
   END IF

   Fields$(1) = C$                                                'set first field = callsign
   IF Fields$(1) <> "" THEN
      F(1) = 1                                                    'establish field counter
   END IF
  
   IF EntryFlag > 1 THEN GOTO Accept                              'dupe or all done?

   CALL LocateIt(16, 15)
   Row = CSRLIN
   Col = POS(0)                                                   'QSO Number
   IN$ = Fields$(2)
   CL = 4
   CALL EntryInput(F())                                           'all data entered yet?
   CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
   NUM$ = IN$
   Fields$(2) = NUM$                                              'fill field with number

   IF Fields$(2) <> "" THEN                                       'if the number was valid
      F(2) = 2                                                    'then establish the next field counter
   END IF

   IF EntryFlag > 1 THEN GOTO Accept                              'done yet?

   CALL LocateIt(17, 15)
   Row = CSRLIN                                                   'Precedence (A,B, or Q)
   Col = POS(0)
   IN$ = Fields$(3)
   CL = 1
   CALL EntryInput(F())                                           'count em up again!
   CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
   PR$ = IN$
   Fields$(3) = PR$                                               'set the precedence

   IF Fields$(3) <> "" THEN                                       'if it isn't empty
      F(3) = 3                                                    'then establish the next field counter
   END IF

   IF EntryFlag > 1 THEN GOTO Accept                              'done yet?

Check:
   CALL LocateIt(18, 15)
   Row = CSRLIN
   Col = POS(0)
   IN$ = Fields$(4)                                               'Check
   CL = 2
   CALL EntryInput(F())                                           'count em up again!
   CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
   CH$ = IN$
   Fields$(4) = CH$

   IF Fields$(4) <> "" THEN                                       'if a valid check # was entered
      IF LEN(Fields$(4)) < 2 THEN                                 'what if only 1 number was entered?
         LABEL$ = "CHECK ERROR"
         ST1$ = "Invalid Check Number!"
         CALL ErrWindow(LABEL$, ST1$)                             'open the ErrWindow and tell user
         CH$ = ""                                                 'set check var to nul
         Fields$(4) = ""                                          'set temp field to nul
         CALL LocateIt(18, 15)
         PRINT STRING$(2, 32);                                    'erase original entry
         GOTO Check                                               'enter the check again
      ELSE
         F(4) = 4                                                    'then set the field counter
      END IF
   END IF

   IF EntryFlag > 1 THEN GOTO Accept                              'done yet?

RedoSection:
      CALL LocateIt(19, 15)
      Row = CSRLIN
      Col = POS(0)
      IN$ = Fields$(5)                                            'Section
      CL = 3
      CALL EntryInput(F())                                        'count em up again!
      CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())
      SE$ = IN$
      IF SE$ <> "" THEN                                           'if section was entered
         IF LEN(SE$) < 3 THEN                                     'and it's less than 3 char then
            SE$ = SE$ + " "                                       'force all sections to three char
         END IF
         K = 1                                                    'keep track of the sections
         DO
            FOR I = 0 TO 10                                       'work through the call areas
               FOR J = 1 TO CallAreas(I)
                  IF SE$ = Sections$(K) THEN                      'valid section?
                     valid = 1                                    'yes
                     EXIT DO                                      'exit gracefully
                  END IF
                  K = K + 1                                       'haven't found it yet
                  IF K > NumberOfSections THEN                    'run out of sections?
                     valid = 0                                    'turn error flag on
                     EXIT DO                                      'and skip town
                  END IF
               NEXT J                                             'keep looking
            NEXT I
         LOOP

         IF valid = 0 THEN                                        'was an error encountered?
            LABEL$ = "SECTION ERROR"
            ST1$ = "Invalid Section!"
            CALL ErrWindow(LABEL$, ST1$)
            SE$ = ""                                              'clear their error
            CALL LocateIt(19, 15)
            PRINT STRING$(3, 32);                                 'erase their booboo
            GOTO RedoSection                                      'make em do it again!
         END IF
      END IF
 
   Fields$(5) = SE$

   IF Fields$(5) <> "" THEN                                       'assuming a valid section has
      F(5) = 5                                                    ' finally been entered, set the
   END IF                                                         ' last field  counter!

   IF EntryFlag > 1 THEN GOTO Accept                              'aren't we done yet?

Accept:                                                           'EntryFlag = 2 means all is OK
      IF EntryFlag = 2 THEN                                       'call LoadTree and see where it goes in the binary tree
         CALL LoadTree(BA$, SS, QSOCounter, C$, SSTree, PR$, NUM$, CH$, SE$)
         IF SectionCounter(K) = 0 THEN                            'new section
            SectionCounter(K) = 1                                 'identify it's worked
            SectionsWorked = SectionsWorked + 1                   'update secs worked
            valid = 0                                             'make sure error flag is off
            LOCATE 11 + I, 36 + (4 * J - 4)                       'find location on screen
            PRINT Sections$(K);                                   'and print it in normal color
         END IF
         QSOMultiplier& = QSOCounter                              'calculate and update
         SectionMultiplier& = SectionsWorked                      ' sections worked and score
         IF MO$ = "CW" THEN
            TotalScore& = (QSOMultiplier& - 1) * 2 * SectionMultiplier&
         ELSE
            TotalScore& = (QSOMultiplier& - 1) * SectionMultiplier&
         END IF
         CALL LocateIt(11, 16)
         PRINT SectionsWorked;                                    'update # of Sections Worked
         CALL LocateIt(12, 16)
         PRINT TotalScore&;                                       'post current score
         CALL Cleanup(F(), Fields$(), TempFields$)                'erase all the previous entries
      ELSEIF EntryFlag > 2 THEN                                   'entry was a dupe or aborted
         IF EntryFlag = 4 THEN                                    'user hit F10 and wants to leave
            CALL ScreenSave
            ULR = 12: ULC = 15: LRR = 18: LRC = 60                'row/col values
            FRAME = 2: FORE = 14: BACK = 0                        'double-line frame - yellow on black
            GROW = 300: SHADOW = -2                               'exploding window - true shadow to left
            LABEL = 15: LABEL$ = "EXIT VERIFICATION"              'bright white window label
            PAGE = 0: SCRMODE = -1                                'screen page 0 and no snow checking
            CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
            COLOR 7, 0                                            'white on black
            CALL LocateIt(13, 16)
            PRINT "If you exit now, your log will indicate"
            CALL LocateIt(14, 16)
            PRINT "the current time as the TIME OFF and you"
            CALL LocateIt(15, 16)
            PRINT "will be expected to stop listening."
            CALL LocateIt(17, 16)
            PRINT "<F5> to Log Off - <F9> to continue..."
            COLOR 7, 1
            DO
               CALL CHECKKEY(MOUSE, ASCCODE, SCANCODE, LFT, RGT)
            LOOP UNTIL (SCANCODE = 63 OR SCANCODE = 67)
            IF SCANCODE = 63 THEN
               EntryFlag = 0                                         'turn EntryFlag off
               Clock = 0                                             'turn the clock off
               IF WriteFlag = 1 THEN                                 'were any records written?
                  IF QSOCounter > 1 THEN                             'make sure we're not still on the first record!
                     DSEG = VARSEG(SS)
                     DOFS = VARPTR(SS)
                     posn& = (CLNG(QSOCounter - 1) * CLNG(LEN(SS))) - CLNG((LEN(SS)) - 1)
                     CALL FSETLOC(Handle, posn&)
                     CALL DFREAD(Handle, DSEG, DOFS, LEN(SS), BytesRead, Ecode)
                     CALL FSETLOC(Handle, posn&)
                     SS.TimeOnOff = LEFT$(TIME$, 2) + MID$(TIME$, 4, 2)
                     CALL DFWRITE(Handle, DSEG, DOFS, LEN(SS), byteswritten, Ecode)
                     IF Ecode = -1 THEN
                        FileFlag = 1
                        EXIT SUB
                     END IF
                     CALL FlushToDisk(Handle, Ecode)
                  END IF
               END IF
               EXIT SUB
            ELSE
               EntryFlag = 0
               CALL ScreenRestore
            END IF
            CALL LocateIt(15, 15)
            PRINT "            ";
            CALL Cleanup(F(), Fields$(), TempFields$)
         ELSE                                                        'dupe or abort brings user here
            CALL LocateIt(15, 15)
            PRINT "            ";
            CALL Cleanup(F(), Fields$(), TempFields$)
         END IF
      END IF
LOOP
END SUB

'**************************************************
'*                                                *
'*   SUB ErrWindow                                *
'*                                                *
'*   This sub procedure creates a window to       *
'*   inform the user that the call that was       *
'*   entered was a duplicate, the check was       *
'*   invalid, or the section was invalid.         *
'*                                                *
'**************************************************
'
SUB ErrWindow (LABEL$, ST1$)

   IF ST1$ = "INVALID BAND" THEN
   ELSE
      CALL ScreenSave
   END IF
   ULR = 14: ULC = 43: LRR = 17: LRC = 70                         'row/col values
   FORE = 4: BACK = 0                                             'red on black
   LABEL = 15                                                     'bright white window label
   FRAME = 2: GROW = 0: SHADOW = -2                               'double-line frame - instant window with shadow
   PAGE = 0: SCRMODE = -1                                         'screen page 0 - no snow checking
   CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
   IF ST1$ = "DUPE! DUPE! DUPE!" THEN
      ST2$ = "Press <F5> to continue."
   ELSE
      ST2$ = "Press <ENTER> to continue."
   END IF
   FORE = 15                                                      'set letters to bright white
   CALL CALCATTR(FORE, BACK, ATTR)
   CALL XQPRINT(ST1$, 15, 45, ATTR, PAGE, SCRMODE)
   IF ST1$ = "DUPE! DUPE! DUPE!" THEN
      CALL XQPRINT("His # was " + Dupe$, 16, 45, ATTR, PAGE, SCRMODE)
      CALL XQPRINT(ST2$, 17, 45, ATTR, PAGE, SCRMODE)
      FOR N = 1 TO 10
         SOUND 900, .75
         SOUND 650, .75
      NEXT
   ELSE
      CALL XQPRINT(ST2$, 16, 45, ATTR, PAGE, SCRMODE)
      CALL Klaxon
   END IF
   IF ST1$ = "DUPE! DUPE! DUPE!" THEN
      DO
         CALL CHECKKEY(MOUSE, ASCCODE, SCANCODE, LFT, RGT)
      LOOP UNTIL SCANCODE = 63                                    'wait for <F5>
   ELSE
      DO
      LOOP UNTIL INKEY$ = CHR$(13)                                'wait for enter key
   END IF
   CALL ScreenRestore
END SUB

'*************************************************
'*                                               *
'*  Sub FileError                                *
'*                                               *
'*  This sub procedure is used to display an     *
'*  error message if a file or proper path can   *
'*  not be found when trying to open or create   *
'*  a file.                                      *
'*                                               *
'*************************************************
'
SUB FileError (FIL$, Ecode)

   CALL ScreenSave
   ULR = 11: ULC = 20: LRR = 17: LRC = 64                         'row/col values
   FORE = 14: BACK = 0                                            'yellow on black
   LABEL = 15: LABEL$ = "FILE ERROR"                              'bright white window label
   CALL DoWindow(Ecode, FIL$, ULR, ULC, LRR, LRC, FORE, BACK, LABEL, LABEL$)
   FileFlag = 1                                                   'let menu routine know there was an error
END SUB

'***************************************************************
'*                                                             *
'*   SUB FileFound                                             *
'*                                                             *
'*   This sub procedure produces a window if the user has      *
'*   indicated that this is a new start but the file chosen    *
'*   already exists.                                           *
'*                                                             *
'***************************************************************
'
SUB FileFound (FIL$)

   CALL ScreenSave                                                'save an image of the current screen
   ULR = 8: ULC = 20: LRR = 17: LRC = 78                          'row/col values
   FORE = 14: BACK = 0                                            'yellow on black
   LABEL = 15: LABEL$ = "START ERROR"                             'bright white window label
   FRAME = 2: GROW = 0                                            'double-line frame - instant window
   SHADOW = -2                                                    'true shadow to left
   PAGE = 0: SCRMODE = -1                                         'screen page 0 and no snow checking
   CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
   CALL CALCATTR(FORE, BACK, ATTR)                                'calc colors for screen print
   REDIM ST$(5)
   ST$(0) = "The file you have specified - "
   ST$(1) = "already exists!"
   ST$(2) = "You have either entered the wrong file name or"
   ST$(3) = "this should be a re-start!"
   ST$(4) = "Please exit the program and try again!"
   ST$(5) = "...any key"
   CALL XQPRINT(ST$(0), 9, 22, ATTR, PAGE, SCRMODE)               'print screen message
   FILNAMEFORE = 15                                               'bright white for file name
   FILNAMEBACK = 0                                                'retain black background
   CALL CALCATTR(FILNAMEFORE, FILNAMEBACK, FILNAMEATTR)           'calculate the attribute
   CALL XQPRINT(FIL$, 10, 22, FILNAMEATTR, PAGE, SCRMODE)
   CALL XQPRINT(ST$(1), 11, 22, ATTR, PAGE, SCRMODE)
   CALL XQPRINT(ST$(2), 13, 22, ATTR, PAGE, SCRMODE)
   CALL XQPRINT(ST$(3), 14, 22, ATTR, PAGE, SCRMODE)
   CALL XQPRINT(ST$(4), 15, 22, ATTR, PAGE, SCRMODE)
   CALL XQPRINT(ST$(5), 17, 68, ATTR, PAGE, SCRMODE)
   CALL AnyKey
   CALL ScreenRestore                                             'remove window and restore original screen
   FileFlag = 1
END SUB

'*************************************************
'*                                               *
'*  SUB Filter                                   *
'*                                               *
'*  This sub procedure "filters" the various     *
'*  inputs.  Parameters are passed from the      *
'*  calling area.  This technique is a much      *
'*  cleaner method than a plain old input!       *
'*                                               *
'*************************************************
'
SUB Filter (Row, Col, IN$, CL, BA$, Clock, Fields$())

BUFF$ = STRING$(1, 32)                                            'helps "erase" the input when backspace is used
CRSR$ = CHR$(254)                                                 'prints a fake cursor
Limit = CL                                                        'maximum size of input string
L = 1                                                             'extended/normal key identifier

DO
   IF Clock THEN                                                  'if we're in the right place
      CALL LocateIt(3, 4)                                         ' display the time
      COLOR 2, 0                                                  'green on black
      PRINT TIME$;
      COLOR 7, 1                                                  'restore color to white on blue
   END IF

   CALL LocateIt(Row, Col)
   TempChar$ = UCASE$(INKEY$)                                     'change to upper case
   CL = LEN(IN$)                                                  'length of string

   IF LEN(TempChar$) = 2 THEN                                     'did the user press
      L = 2                                                       'an extended character key?
      TempChar$ = RIGHT$(TempChar$, 1)
   END IF

   IF L = 2 AND TempChar$ = CHR$(59) THEN                         'Yes - F1 was selected
      TempIN$ = LEFT$(IN$, CL)                                    'save current string
      IN$ = ""
      CALL LocateIt(Row, Col)
      PRINT STRING$(12, 32);
      CALL SetBand(BA$, Clock, Fields$())
      CALL LocateIt(3, 72)                                        'and update current
      COLOR 15, 0
      PRINT BA$;                                                  'entry screen
      COLOR 7, 1
      TempChar$ = ""                                              'before resuming filter input
      CALL LocateIt(Row, Col)
      IN$ = TempIN$
   END IF
 
   IF L = 2 AND TempChar$ = CHR$(62) THEN                         'F4 was pressed
      IF EntryFlag = 1 THEN                                       'Are all entries completed?
         EntryFlag = 2                                            'Yes - done
         PRINT BUFF$
         EXIT SUB
      ELSE
         L = 1                                                    'No - more entries are needed
         TempChar$ = ""
      END IF
   END IF

   IF L = 2 AND TempChar$ = CHR$(66) THEN                         'F8 was hit
      EntryFlag = 3                                               ' the "abort" key
   END IF
  
   IF L = 2 AND TempChar$ = CHR$(68) THEN                         'F10 was hit
      EntryFlag = 4                                               'EXIT
      EXIT SUB
   END IF

   IF EntryFlag = 3 THEN                                          'was the entry aborted?
         IF (CL = 0 AND Row = 15) THEN                            'Yes, but nothing to abort!
            EntryFlag = 0
         ELSE
            IN$ = ""
            KEY(8) OFF                                            'Yes, clear out data and
            EXIT SUB                                              'start over
         END IF
   END IF

   IF TempChar$ = CHR$(8) THEN                                    'check backspace
      CL = CL - 1                                                 'decrease string
      TempChar$ = ""
   ELSEIF TempChar$ = CHR$(127) THEN                              ' CTRL-Backspace erases field
      CL = 0                                                      '  instead of forcing user
      TempChar$ = ""                                              '  to erase one char at a time
      CALL LocateIt(Row, Col)
      PRINT "            ";
   ELSEIF TempChar$ = CHR$(13) THEN                               'return is terminator
      EXIT DO
   END IF

   IF L = 2 THEN                                                  'ignore all other extended keys
      TempChar$ = ""
      L = 1
   END IF

   IF TempChar$ <> "" THEN                                        'filter callsign
      IF Limit = 11 THEN
         valid = INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890@^/", TempChar$)
         IF valid = 0 THEN
            CALL Klaxon
            TempChar$ = ""
         END IF
      ELSEIF Limit = 4 THEN                                       'filter RCVD Number
         valid = INSTR("1234567890", TempChar$)
         IF valid = 0 THEN
            CALL Klaxon
            TempChar$ = ""
         END IF
      ELSEIF Limit = 1 THEN                                       'filter VDISK or Precedence
         IF (Row = 17) OR (Row = 10) THEN
            valid = INSTR("ABQ", TempChar$)                       'permissible chars for Precedence
         ELSE
            valid = INSTR("CDEFGHIJK", TempChar$)                 'permissible chars for ram drive
         END IF
         IF valid = 0 THEN
            CALL Klaxon
            TempChar$ = ""
         END IF
      ELSEIF Limit = 2 THEN                                       'filter check number or
         IF Row = 14 THEN                                         'mode
            valid = INSTR("BCSW", TempChar$)
            IF valid = 0 THEN
               CALL Klaxon
               TempChar$ = ""
            END IF
         ELSE
            valid = INSTR("1234567890", TempChar$)
            IF valid = 0 THEN
               CALL Klaxon
               TempChar$ = ""
            END IF
         END IF
      ELSEIF Limit = 3 THEN                                       'filter section or band
         IF Row = 23 THEN
            valid = INSTR("1245680", TempChar$)                   'filter band
            IF valid = 0 THEN
               CALL Klaxon
               TempChar$ = ""
            END IF
         ELSE                                                     'filter section
            valid = INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ8", TempChar$)
            IF valid = 0 THEN
               CALL Klaxon
               TempChar$ = ""
            END IF
         END IF
      ELSEIF Limit = 25 THEN                                      'filter filenames
         valid = INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ/\0123456789:", TempChar$)
         IF valid = 0 THEN
            CALL Klaxon
            TempChar$ = ""
         END IF
      END IF
   END IF
 
   IF CL > Limit THEN                                             'string too long?
      CL = Limit
   ELSEIF CL < 0 THEN                                             'string too short?
      CL = 0
   END IF

   IN$ = LEFT$(IN$, CL) + TempChar$                               'build string
   CL = CL + 1                                                    'increase string
   PRINT IN$;                                                     'echo it
   LOCATE Row, Col + CL - 1
   COLOR 23
   PRINT CRSR$; BUFF$                                             'print some kind of cursor
   COLOR 7
LOOP
LOCATE Row, Col + CL                                              'the BUFF$ is a blank at the end
PRINT BUFF$                                                       'of the temporary string - if the
                                                                  'user backs up, all extra junk gets "erased"
END SUB

'************************************************
'*                                              *
'*  Sub Klaxon                                  *
'*                                              *
'*  This sub procedure is used instead of the   *
'*  default "BEEP" that BASIC provides.         *
'*                                              *
'************************************************
'
SUB Klaxon

   FOR N = 1 TO 10
      SOUND 250, .25
      SOUND 220, .25
      SOUND 190, .25
      SOUND 160, .25
   NEXT

END SUB

'*****************************************************
'*                                                   *
'*  SUB LoadTree                                     *
'*                                                   *
'*  This sub procedure is the "heart" of this        *
'*  program.  It checks the array in the ram         *
'*  disk (a binary tree) and determines whether      *
'*  or not the call is a duplicate.  If it isn't     *
'*  a duplicate, it is loaded into the array and     *
'*  the appropriate pointers are set.                *
'*                                                   *
'*****************************************************
'
SUB LoadTree (BA$, SS AS RecordType, QSOCounter, C$, SSTree AS TreeType, PR$, NUM$, CH$, SE$)

IF C$ = "" THEN EXIT SUB                                          'no call sign entered

IF QSOCounter = 1 THEN                                            'first record
   SS.RCVDCall = C$
   SSTree.CallSign = C$
   SS.Band = BA$
   SSTree.LeftPointer = 0                                         'first record can't point to
   SSTree.RightPointer = 0                                        '  anything yet!
   SS.Date = LEFT$(DATE$, 6) + RIGHT$(DATE$, 2)
   SS.Time = LEFT$(TIME$, 2) + MID$(TIME$, 4, 2)
   SS.RCVDNum = NUM$
   SS.SentNum = ISTR$(QSOCounter)
   SS.Precedence = PR$
   SS.Check = CH$
   SS.Section = SE$
   SS.CarReturn = CHR$(13)
   SS.LineFeed = CHR$(10)
   posn& = 1                                                      'set record pointer at first byte
   DSEG = VARSEG(SS)                                              'get segment for main records
   DOFS = VARPTR(SS)                                              'get offset for main records
   CALL FSETLOC(Handle, posn&)                                    'set record pointer
   CALL DFWRITE(Handle, DSEG, DOFS, LEN(SS), byteswritten, Ecode) 'write the first main record
   IF Ecode = -1 THEN                                             'disk full!
      CALL DeadWindow                                             'tell user
      SYSTEM                                                      'stop program
   END IF
   CALL FlushToDisk(Handle, Ecode)
   DSEG = VARSEG(SSTree)                                          'get segment for binary tree records
   DOFS = VARPTR(SSTree)                                          'get offset for binary tree records
   CALL FSETLOC(Handle3, posn&)                                   'set record pointer
   CALL DFWRITE(Handle3, DSEG, DOFS, LEN(SSTree), byteswritten, Ecode)   'write record to the ram drive (binary tree)
   IF Ecode = -1 THEN                                             'disk full!
      CALL DeadWindow                                             'tell user they screwed up royally!
      SYSTEM                                                      'stop the program
   END IF
   CALL FlushToDisk(Handle3, Ecode)
   WriteFlag = 1                                                  'turn on flag to identify that
   SS.TimeOnOff = ""                                              ' something was written
   QSOCounter = QSOCounter + 1                                    'increment QSOCounter
   LOCATE 8, 27 - (LEN(ISTR$(QSOCounter)))
   COLOR 15, 0                                                    'bright white on black
   PRINT QSOCounter;                                              'let the user know what the
   COLOR 7, 1                                                     ' next number will be
   EXIT SUB
END IF

DSEG = VARSEG(SSTree)
DOFS = VARPTR(SSTree)
CALL FSIZE(Handle3, Bytes&)                                       'how large is the binary tree file?
firstempty = Bytes& \ LEN(SSTree) + 1                             'where does the next record
Counter = 1                                                       'in the binary tree?
Pointer = 1
DO
   Counter = Pointer
   DSEG = VARSEG(SSTree)
   DOFS = VARPTR(SSTree)
   posn& = (CLNG(Counter) * CLNG(LEN(SSTree))) - (CLNG(LEN(SSTree)) - 1)
   CALL FSETLOC(Handle3, posn&)
   CALL DFREAD(Handle3, DSEG, DOFS, LEN(SSTree), BytesRead, Ecode)
   IF Ecode THEN
      FIL$ = File$
      CALL FileError(FIL$, Ecode)
   END IF
   '
   'set the left pointer?
   '
   IF C$ < RTRIM$(SSTree.CallSign) THEN
      Pointer = SSTree.LeftPointer
      direction = 1
   '
   'check to see if this is a duplicate
   '
   ELSEIF C$ = RTRIM$(SSTree.CallSign) THEN
      Temp$ = SS.TimeOnOff                                        'copy TimeOnOff into Temp$ in case we need it
      '
      'The variable Temp$ was created due to a boo-boo I found in the program.
      'When the user comes from the menu into EntryScreen, the field SS.TimeOnOff is established
      'so it can be recorded when the first record from re-start is written to disk.
      'If the first call entered after the re-start happens to be a duplicate, the original
      'record is recalled to get the original number received from the "dupe" station.
      'When that record is called, the SS.TimeOnOff field will probably be cleared out, or
      'worse, the current value will be replaced by the field from the dupe station's
      'original field!  Saving the field in a temporary variable and then writing it back
      'after the dupe information is captured solves the problem.  Regardless of whether the
      'field has a value (most of the time it doesn't) or not, it's proper setting will
      'be written into the correct record.  ALB 9/3/1991
      '
      LABEL$ = "DUPLICATE"                                        'window label
      ST1$ = "DUPE! DUPE! DUPE!"
      dposn& = (CLNG(Counter) * CLNG(LEN(SS))) - (CLNG(LEN(SS)) - 1)
      DSEG = VARSEG(SS)
      DOFS = VARPTR(SS)
      CALL FSETLOC(Handle, dposn&)
      CALL DFREAD(Handle, DSEG, DOFS, LEN(SS), BytesRead, Ecode)
      Dupe$ = SS.RCVDNum
      CALL ErrWindow(LABEL$, ST1$)                                'tell user it's a duplicate
      Dupe$ = ""
      C$ = ""                                                     'clear call sign
      firstempty = firstempty - 1                                 'decrement the counter
      EntryFlag = 3
      SS.TimeOnOff = Temp$                                        'this will restore TimeOnOff in case it was removed
      EXIT SUB                                                    'get out
   ELSE
      Pointer = SSTree.RightPointer
      direction = 2
   END IF
LOOP UNTIL Pointer = 0
IF EntryFlag < 2 THEN EXIT SUB                                    'only checking the callsign!
                                                                  'EntryFlag  will be set at 2 to accept everything
IF direction = 1 THEN
   SSTree.LeftPointer = firstempty
ELSE
   SSTree.RightPointer = firstempty
END IF

DSEG = VARSEG(SSTree)
DOFS = VARPTR(SSTree)
posn& = (CLNG(Counter) * CLNG(LEN(SSTree))) - (CLNG(LEN(SSTree)) - 1)
CALL FSETLOC(Handle3, posn&)
CALL DFWRITE(Handle3, DSEG, DOFS, LEN(SSTree), byteswritten, Ecode)
IF Ecode = -1 THEN                                                'disk full!
   CALL DeadWindow                                                'tell user they screwed up royally
   SYSTEM                                                         'stop the program
END IF
CALL FlushToDisk(Handle3, Ecode)

SS.RCVDCall = C$
SSTree.CallSign = C$
SS.Band = BA$
SSTree.LeftPointer = 0
SSTree.RightPointer = 0
SS.Date = LEFT$(DATE$, 6) + RIGHT$(DATE$, 2)
SS.Time = LEFT$(TIME$, 2) + MID$(TIME$, 4, 2)
SS.RCVDNum = NUM$
SS.SentNum = ISTR$(QSOCounter)
SS.Precedence = PR$
SS.Check = CH$
SS.Section = SE$
SS.CarReturn = CHR$(13)
SS.LineFeed = CHR$(10)

DSEG = VARSEG(SS)
DOFS = VARPTR(SS)
CALL FSETEND(Handle)
CALL DFWRITE(Handle, DSEG, DOFS, LEN(SS), byteswritten, Ecode)
IF Ecode = -1 THEN                                                'disk full!
   CALL DeadWindow                                                'tell user they screwed up royally
   SYSTEM                                                         'stop the program
END IF
CALL FlushToDisk(Handle, Ecode)
DSEG = VARSEG(SSTree)
DOFS = VARPTR(SSTree)
CALL FSETEND(Handle3)
CALL DFWRITE(Handle3, DSEG, DOFS, LEN(SSTree), byteswritten, Ecode)
IF Ecode = -1 THEN                                                'disk full
   CALL DeadWindow                                                'tell user they screwed up royally
   SYSTEM                                                         'stop the program
END IF
CALL FlushToDisk(Handle3, Ecode)
WriteFlag = 1
SS.TimeOnOff = ""
QSOCounter = QSOCounter + 1
LOCATE 8, 27 - (LEN(ISTR$(QSOCounter)))
COLOR 15, 0                                                       'bright white on black
PRINT QSOCounter;                                                 'print # for next QSO
COLOR 7, 1
END SUB

REM $STATIC
'************************************************
'*                                              *
'*    SUB LocateIt                              *
'*                                              *
'*    This sub procedure mimics the BASIC       *
'*    function LOCATE.  According to Ethan      *
'*    Winer of Crescent Software, this          *
'*    technique saves several bytes of code     *
'*    over the normal LOCATE usage.             *
'*                                              *
'************************************************
'
SUB LocateIt (Row, Column) STATIC

   LOCATE Row, Column

END SUB

REM $DYNAMIC
'*****************************************************
'*                                                   *
'*  SUB RptForm                                      *
'*                                                   *
'*  This sub procedure will produce the "report"     *
'*  that goes with the entry for in the contest.     *
'*  In other words, these are the traditional        *
'*  "log sheets."  Along with the Dupe Sheets        *
'*  all you will need is the actual entry form       *
'*  which you may obtain from the ARRL.              *
'*                                                   *
'*****************************************************
'
SUB RptForm (SS AS RecordType, QSOCounter)

PRTPORT = 1
CALL PRTCHECK(PRTPORT, STATUS)                                    'check to see if printer is ready
IF STATUS = 0 THEN
   ST1$ = "Printer not ready!"
   LABEL$ = "PRINTER ERROR"
   CALL ErrWindow(LABEL$, ST1$)
   EXIT SUB
END IF

IF QSOCounter < 2 THEN                                            'QSOCounter "wakes up" at 1
   ST1$ = "Please load data files!"                               '  therefore there's no data
   LABEL$ = "DATA ERROR"
   CALL ErrWindow(LABEL$, ST1$)
   EXIT SUB
END IF

CLS
CALL LocateIt(12, 20)

PRINT "Printing the log sheets."
PRINT
LOCATE , 20
PRINT "ESCape to stop printing."
WIDTH LPRINT 80
LPRINT CHR$(18);                                                  'set up for normal print
LPRINT CHR$(27) + "3" + CHR$(36);
LPRINT CHR$(27) + CHR$(2);                                        'reset to 6 lpi
PrintCounter = 1                                                  'keep track of contacts
DO
   LPRINT "                              ARRL Sweepstakes"
   LPRINT
   LPRINT "Call Used: ";
   ULINEON$ = CHR$(27) + "-" + CHR$(49)
   ULINEOFF$ = CHR$(27) + "-" + CHR$(48)
   LPRINT ULINEON$;
   LPRINT ID$; ULINEOFF$;
   LPRINT TAB(40); "ARRL Section: "; ULINEON$;
   LPRINT SEC$; ULINEOFF$
   LPRINT "SENT";

   '*****************************************************************
   '*****************************************************************
   '   The characters that follow are line drawing characters.
   '   On a computer using ANSI.SYS they appear just fine.
   '   However, on a printer that does not normally display
   '   the IBM line drawing character sets, they appear as strange
   '   collections of italic characters.
   '
   '   They are used to create a "box" for the top of the log sheet
   '   form.   ALB  September 1989
   '*******************************************************************
   '*******************************************************************

   LPRINT "   Ŀ"
   LPRINT "        PREC    CALL    CK   SEC   "; TAB(50);
   IF MO$ = "CW" THEN
      LPRINT "CW"; ULINEON$; "XXXX";
      LPRINT ULINEOFF$; "  SSB";
      LPRINT ULINEON$; "    ";
      LPRINT ULINEOFF$;
   ELSE
      LPRINT "CW"; ULINEON$; "    ";
      LPRINT ULINEOFF$; "  SSB";
      LPRINT ULINEON$; "XXXX";
      LPRINT ULINEOFF$;
   END IF
   LPRINT "          "; SPREC$; TAB(15); "  "; ID$; TAB(26); " "; CK$; TAB(31); "  "; SEC$; TAB(40); ""
   LPRINT "       "
   LPRINT ""
   LPRINT "                                             RECEIVED                  "
   LPRINT "              TIME             Ĵ   "
   LPRINT " BAND  DATE  ON/OFF  TIME   NR   NR PRECSTATION WORKED CKSECTIONPTS"
   LPRINT ""
   FOR PAGE = 1 TO 50
      posn& = (CLNG(PrintCounter) * CLNG(LEN(SS))) - (CLNG(LEN(SS)) - 1)
      DSEG = VARSEG(SS)
      DOFS = VARPTR(SS)
      CALL FSETLOC(Handle, posn&)
      CALL DFREAD(Handle, DSEG, DOFS, LEN(SS), BytesRead, Ecode)
      TempBand1$ = SS.Band                                        'use these variables to help identify
      TempDate1$ = SS.Date                                        ' if we've changed band or date
      IF PAGE > 1 THEN
         IF TempBand$ = SS.Band THEN                              'same band as previous entry
            SS.Band = ""                                          'don't print it again
         END IF

         IF TempDate$ = SS.Date THEN                              'same date as previous entry
            SS.Date = ""                                          'don't print it again
         END IF
      END IF

      LPRINT "  "; SS.Band; TAB(7); SS.Date; TAB(16); SS.TimeOnOff; TAB(25);
      LPRINT SS.Time; TAB(31); SS.SentNum; TAB(38);
      LPRINT SS.RCVDNum; TAB(45); SS.Precedence; TAB(49); SS.RCVDCall;
      LPRINT TAB(64); SS.Check; TAB(69); SS.Section; TAB(76);
      IF MO$ = "SSB" THEN
         LPRINT "1"
      ELSE
         LPRINT "2"
      END IF

      RE$ = INKEY$

      IF RE$ = CHR$(27) THEN                                      'user wants to stop printing
         LPRINT CHR$(12);                                         'form feed
         EXIT DO                                                  'and exit sub
      END IF

      PrintCounter = PrintCounter + 1
      IF PrintCounter = QSOCounter THEN                           'out of records?
         LPRINT CHR$(12);
         EXIT DO
      END IF
      TempBand$ = TempBand1$
      TempDate$ = TempDate1$
   NEXT PAGE
   LPRINT CHR$(12);
LOOP
CLS
END SUB

'*************************************************************
'*                                                           *
'*   SUB ScreenRestore                                       *
'*                                                           *
'*   This sub procedure restores the normal screen after     *
'*   an error has occurred and a window was drawn to tell    *
'*   the user about it.                                      *
'*                                                           *
'*************************************************************
'
SUB ScreenRestore

   PAGE = 0                                                       'screen page
   SCRMODE = -1                                                   'don't worry about snow checking
   DSEG = VARSEG(SCREEN1(1))                                      'get current segment of the array
   DOFS = VARPTR(SCREEN1(1))                                      'get current offset of the array
   CALL DSCRREST(DSEG, DOFS, PAGE, SCRMODE)                       'restore the screen

END SUB

'***************************************************
'*                                                 *
'*   SUB ScreenSave                                *
'*                                                 *
'*   This sub procedure saves the image of the     *
'*   "normal" screen in an array.  When a window   *
'*   is then drawn on the screen, the images       *
'*   "behind" the window will be saved.  Once the  *
'*   user is ready to erase the window, it is      *
'*   not really erased, but overwritten by this    *
'*   original image that was saved and restored.   *
'*                                                 *
'***************************************************
'
SUB ScreenSave

   REDIM SCREEN1(2000)                                            'dimension an array
   PAGE = 0                                                       'screen page
   SCRMODE = -1                                                   'don't check for snow
   DSEG = VARSEG(SCREEN1(1))                                      'get current segment
   DOFS = VARPTR(SCREEN1(1))                                      'get current offset
   CALL DSCRSAVE(DSEG, DOFS, PAGE, SCRMODE)                       'save the screen

END SUB

'***************************************************
'*                                                 *
'*  SUB SetBand                                    *
'*                                                 *
'*  This sub procedure is used to set or change    *
'*  the band being used.                           *
'*                                                 *
'***************************************************
'
SUB SetBand (BA$, Clock, Fields$())

OBA$ = BA$                                                        'retain original setting
BA$ = ""
DO WHILE BA$ = ""
   IF Clock THEN                                                  'if we're in the entry screen
      COLOR 2, 0                                                  'green on black
      CALL LocateIt(3, 4)                                         ' turn on the clock
      COLOR 7, 1                                                  'restore color to white on blue
      PRINT TIME$;
   END IF

   CALL ScreenSave
   ULR = 22: ULC = 20: LRR = 24: LRC = 33                         'row/col values
   FRAME = 2: FORE = 14: BACK = 0                                 'double-line frame - yellow on black
   GROW = 0: SHADOW = 0                                           'instant window - no shadow
   LABEL = 15: LABEL$ = "SET BAND"                                'bright white window label
   PAGE = 0: SCRMODE = -1                                         'screen page 0 and no snow checking
   CALL WindowManager(ULR, ULC, LRR, LRC, FRAME, FORE, BACK, GROW, SHADOW, LABEL, LABEL$, PAGE, SCRMODE)
   FORE = 7: BACK = 1                                             'white on blue
   CALL CALCATTR(FORE, BACK, ATTR)
   CALL RecolorArea(ULR, ULC, LRR, LRC, ATTR, PAGE, SCRMODE)      'color interior of band window
   Row = 23: Col = 20
   CALL LocateIt(Row, Col)
   PRINT "Band: ";
   Col = POS(0)
   IN$ = ""
   CL = 3
   CALL Filter(Row, Col, IN$, CL, BA$, Clock, Fields$())

   IF IN$ = "" THEN                                               'if band was not changed
      BA$ = OBA$                                                  'keep old setting
      EXIT DO
   ELSE
      BA$ = IN$
   END IF

   IF BA$ = "10" THEN
      BA$ = "10 "
      EXIT DO
   ELSEIF BA$ = "15" THEN
      BA$ = "15 "
      EXIT DO
   ELSEIF BA$ = "20" THEN
      BA$ = "20 "
      EXIT DO
   ELSEIF BA$ = "40" THEN
      BA$ = "40 "
      EXIT DO
   ELSEIF BA$ = "80" THEN
      BA$ = "80 "
      EXIT DO
   ELSEIF BA$ = "160" THEN
      EXIT DO
   ELSE
      ST1$ = "INVALID BAND"                                       'user tried to enter
      LABEL$ = "BAND ERROR"                                       'an invalid meter band
      CALL ErrWindow(LABEL$, ST1$)                                'call the error window
      BA$ = OBA$                                                  'band equals its previous value
      EXIT DO
   END IF
LOOP
CALL ScreenRestore                                                'effectively erase the window
END SUB

