TM-721A UHF Extend Mod

Modifying the Kenwood TM-721A for Extended UHF Coverage

Well I finally uncovered the specifics of the mod which will extend the
UHF coverage of the TM-721A.  This mod changes the UHF receive from
it's factory setting of 438 - 449.995 mhz to approximately 420-460
MHZ.  There are some peculiarities surrounding this mod so I'll
describe them first.

First of all, this mod will allow the UHF digital display to traverse
from 400.000 to 499.995.  The radio will not, however, tune this entire
range due to a combination of a limited synthesizer lock range and the
input RF amplifier bandwidth.  The apparent useful tuning range is
about 420-460, with sensitivity dropping off sharply at either end.
Naturally, the best performance is in the middle (the Ham Band :-).

Similarly, the VHF tuning range is extended in the same manner.  After
the mod is made, the VHF side will apparently tune from between 100-199
mhz but as stated above, there is little or no response outside of the
published range (138-170 mhz), due to the same reasons as stated
above.

As a final side effect, note that performing this mod will remove all
out-of-band transmit restrictions on the rig, for both VHF and UHF.
After the mod is in place, the radio will transmit on any frequency
that it can tune to.

DISCLAIMER:

The author of this report wishes to strongly remind those who perform
this mod that it is ILLEGAL to transmit on any frequencies outside of
the ham bands, EVEN IF YOU ARE OTHERWISE LICENSED TO DO SO.  This is
because of the radio's lack of FCC type acceptance for these
frequencies.  So beware!  Unauthorized use of this feature could be
hazardous to your ticket.  MARS/CAP users are probably OK with a permit.

Now for the nuts and bolts.....

MODIFICATION PROCEDURE

1. Turn the radio on and write down all of your memory channel
frequency assignments, PL codes and anything else you have in memory -
It will all have to be reprogrammed after the mod.  After writing down
all of your data, turn off the unit and disconnect it from the antenna
and power supply.

2. Next, remove the bottom cover on the unit.  Note: this radio
contains a number of CMOS parts which could be damaged by static
discharge.  Take all of the regular precautions to make sure that you
and your tools are properly grounded for anti-static work.  Note that
there is a hole in the rear of the subchassis which supports the
controller circuit board in which you can see a small, black, 1/4 watt
resistor which is labeled on the board as R57.  Using a small pair of
sharp cutters, clip the lead on the end of the resistor.  It is not
necessary to remove the part, just clip one end and bend it slightly
out of the way.

2. Next, remove the top cover and then open the front panel assembly
into the service position.  To do this, remove the four silver screws,
one on the top, one on the bottom, and one from each side.  Two of the
screws are in slotted holes.  Loosen the screws in the slotted holes
slightly so as to allow the front panel to be pulled out and swung down
in a hinge-like fashion.  Once open, set the radio on a table with the
hinged front panel hanging over the edge of your workbench.
Familiarize yourself with the inside of this compartment.  The most
notable features are a silver, button type lithium battery to the left
of center and a large, multi-pin microprocessor chip on the right.  DO
NOT DISCONNECT ANY OF THE RIBBON CABLES.

3. Locate the lithium battery and to it's left you will notice a row of
five programming resistor positions, with the middle position vacant.
The arrangement looks something like this:

|
|                        ____                    ______
|       I I:II          (Bat-)                   |MPU |
|                       (tery)                   |    |
|                        ----                    ------
|
|                  I <- R121 (remove for cross-band repeater operation)
______________________________________________

        VVV front of rig VVV

The (:) above indicates where a jumper is to be placed.  Use care in
soldering since everything is quite small.

        [ This section added by Ed Carp, N7EKG.  Do this ONLY if you
        need the PLL to lock above 460 MHz.]

        +----------------------------------------------------------+
        |      Bottom of radio - Back                              |
        |                                                          |
        |                                                          |
        |                                                          |
        |                                                          |
        |                                                          |
        |  +---------+                                             |
        |  |         |                                             |
        |  |         |                                             |
        |  |  * <---------- Turn this TC CCW                       |
        |  | o     o |                                             |
        |  +---------+                                             |
        |      Bottom of radio - Front                             |
        +----------------------------------------------------------+
3a.     Look at the bottom of the radio.  On the left-hand side, in the
        lower corner of the PCB, there is a silver can (as indicated).
        Place a small, non-metallic screwdriver in the hole indicated
        and turn the cap SLIGHTLY counter clock-wise.  This will lock
        the VCO in the 460 MHz range (and maybe a little bit farther).

        If you turn the screw farther than necessary to achieve PLL lock,
        the receiver or transmitter might not lock up at the band edges.

4. Reassemble the unit in the reverse order as described above.  When
you power the rig up, the display should show 440.000 and 144.000 on
the displays.  It is now ready for operation.  If necessary, perform
the microprocessor reset function by holding down the F button while
turning on the power.  Reprogram the unit with the data you saved in
step 1.

Comments:

There is nothing special about operating the rig once the modification
is made.  All functions operate exactly as before except that the range
on each band is extended as described above.  You will probably want to
program the band scan limiting channels (A and B) on both bands since
otherwise your vfo scanning will be too broad and will spend a lot of
time scanning in areas which it cannot receive.

In addition, my rig also has the cross-band repeater mod.  I do not
know if having this is a prerequisite to performing the mod mentioned
above.  If it is, then R121 will also have to be removed.  The cross-
band repeater mod has already been discussed on the net so I won't go
into it at this time.

Enjoy this mod but don't endanger your license!  Don't transmit out of
band and don't allow others to, even if they're licensed for those
frequencies!

