

        ========= MODS for KENWOOD TS-930 Transcievers ==========

The following is a list of favorite changes that  can  be  made  to  the
Kenwood  930.  These  changes  are  quite  simple and do not require the
addition of any switches.

NOTE: In the operator's manual supplied with the 930, there is an  error
on  one  of  the  drawings. On the upper left corner of the DIGITAL UNIT
schematic locate connector 8. The lead designations are as follows (note
that some of the designations do not appear on this sheet so you can add
them to the drawing):

        Pin     Desig.
         1       100
         2       MU
         3       SCN
         4       M2
         5       MIN
         6       FSK
         7       B2
         8       FT

On the main drawing, called SCHEMATIC DIAGRAM, the pin numbers shown  on
connector  8  are reversed from the way they are numbered on the DIGITAL
UNIT schematic. In  the  following  changes,  I  am  assuming  that  the
numbering on the DIGITAL UNIT sheet is correct. In any event, it will be
obvious which end is which since the end pin is vacant.

                                 CHANGES

1) The resolution of the main tuning digital readout  can  be  increased
from 100 Hz to 10 Hz. No digits are lost since the readout has the extra
digit for this purpose. This change is accomplished by grounding  pin  1
of connector 8 on the DIGITAL UNIT.

2) The tuning rate is 10 kHz per revolution of  the  main  tuning  knob.
The  tuning  rate  can be changed to 5 kHz per revolution by cutting one
end of diode D-13 on the DIGITAL UNIT.

(Note that the black marks on the tuning knob itself are exactly 500  Hz
apart.  The knob can be "corrected" by tuning in an exact frequency, for
example 10,000.00 kHz, pressing the DIAL LOCK switch, then  turning  the
knob  to  line  up  a black line. As long as you don't spin the dial too
fast, it will track nicely from one end to the other. With the slow rate
modification, the dial increments become 250 Hz per division).

You may desire to switch this  reduced  tuning  rate  on  and  off.  For
example,  you  can  select the new rate on just VFO B by using an unused
section of the "FUNCTION" switch. Another  possibility  is  to  use  the
display "DIM" switch.

3) There are an additional 8 memories available. These can  be  obtained
by  grounding  pin  5 of connector 7 on the DIGITAL UNIT.  (This lead is
designated "M3").

The 8 additional memories can be selected by using an unused contact  on
the "FUNCTION" switch.

4) Each group of 8 memories can be scanned at a  rate  of  about  1  per
second.  Unlike a normal scanner, The unit will not stop scanning when a
signal is present, but it is a good way to search  favorite  frequencies
for activity.

A method of turning on the scan function without affecting normal switch
functions would be to wire the unused section of the DIAL LOCK switch in
series with the unused section of the METER switch (meter switch in  the
"VC" position).

5) A handy option is to be able to momentarily unlock one VFO  when  the
DIAL  LOCK  is  on.  This can be useful during split frequency operation
when you want to keep the receive vfo  locked  (the  DX  station's  xmit
freq),  yet  quickly  qsy  to the frequency he is listening to with your
transmit VFO.
This change can be made by wiring one lead from the DIAL LOCK switch  in
series with extra normally closed contacts of the "T-F" switch.

6) This change permits automatic disabling of a linear amplifier  during
full  break-in  cw  operation.  This  is desirable since the relays in a
linear cannot properly follow each keyed character element.  This change
should also be done if AMTOR operation is contemplated.

Assuming that your 930 has the aux. relay board in it, merely  wire  the
+28 volt lead to the relay coil in series with the extra contacts of the
"FULL-SEMI" switch.

7) For AMTOR operation, the T-R switching speed must be increased.

2 suggested changes are to remove C-500  (4.7uf)  on  the  SIGNAL  BOARD
(located  top  center  near connector 30), and to ground the junction of
R-476 / Q-100.

8) In early units, the WARC band transmit was not enabled.  If  this  is
the  case, solder a jumper from pin 12 of IC-23 to ground on the DIGITAL
UNIT.  (Ground can be obtained at pin 8 of IC-24).

9) Transmit can be enabled on all frequencies between 1.5 and 30 MHz for
MARS and transverter use by adding two jumpers on the DIGITAL UNIT:

        Connect pin 9 of IC-11 to pin 12 of IC-21.
        Connect pin 9 of IC-12 to pin 12 of IC-22.

========================================================================
Additional comments:

Even though the receiver low frequency end is spec'd as 150 kHZ, it will
operate down to 100 kHz. [A[BTo conveniently switch in a general purpose
receiving antenna you must use the transverter connector. When the 8 pin
DIN  plug  is  plugged  into  this  connector,  a  switch operates which
separates the coaxial antenna input from the receiver input.  These  two
connections  appear  at pins 8 and 5 resp. of the transverter connector.
(This 8 pin  DIN  plug  is  not  furnished  with  the  930).   The  most
convenient setup is to bring cables from both the REMOTE and TRANSVERTER
connectors into a junction box  which  has  appropriate  connectors  and
switches  on  it  for  interfacing  to a transverter, receiving antenna,
linear amp, etc.

Here is a chart of the connections to these connectors:

        REMOTE (7 pin DIN)      XVERTER (8 pin DIN)
        1 Speaker output        1 Grd
        2 Grd                   2 +V out on xmit*
        3 PTT                   3 Grd
        4 Q-22 out**            4 XVRT ON/OFF Control***
        5 unused                5 Receiver input
        6 ALC input             6 XVRTR ALC input
        7 XMIT RELAY**          7 Xmit RF to xvrtr input
                                8 HF ant in

         * A 12 volt, 50ma max.  relay  may  be  connected  from  pin  2
           to ground. This relay will operate on xmit.

        ** Original units used  Q-22  collector  for  linear  amp  relay
           control.   This  did  not work with low voltage relay systems
           or those using a negative voltage. An  optional  relay  board
           (Now  supplied  in  all  units as standard)  is available and
           provides  a  normally  open  contact  closure  to  ground  at
           pin 7.

       *** Pin 4  is  grounded  to  enable  xvrtr  operation.  This  may
           be done by a switch in the transverter itself.

========================================================================

 ***->Be careful not to transmit out-of-band, or accidentally operate on
      any non-amateur, unless you are authorized to do so.

                     DO NOT JEOPARDIZE YOUR LICENSE!


[EOF]
